### uK4 - BBS共通 ###########################################################
### データはEUCとする (旧データとの互換のため) ##############################
use utf8;
$days     = 7;						# 新規・更新アイコンを表示する日数
$filesize = 100;					# アップロードファイルサイズ(デフォルト)
$indexS   = 'articles.search.txt';	# 検索用データファイル名
$index_ttl = 3600;					# インデックスの有効時間
$profile  = 'profile.txt';			# 掲示板環境ファイル
$pcolor0  = '#c0ffc0';				# 重要度色指定
$pcolor1  = '#ffc0c0';
$pcolor2  = '#ff4040';
$bgcolor5 = "bgcolor = '#e8e8ff'";
$arrowS   = "<img src='$idir/arrow_s.gif' width=9 height=9 title='' border=0>";
$iii      = "<img src='$idir/i.gif' height=26 width=26 title=''>";
$counter  = 'count.txt';
$r        = '<font color="red">*</font>';
$new      = "<img src='$idir/new.gif' height=12 width=30 title='新しい記事です' border=0>";
$search2  = "<img src='$idir/search.gif' height=32 width=32 title='検索' border=0>";
$up       = "<img src='$idir/up.gif' height=12 width=30 title='最近更新の記事です' border=0>";
$write    = "<img src='$idir/write.gif' height=16 width=18 border=0 title='コメントを書く'>";
&auth;
&redirect if (!$extstr5 || !$bbsallow);
$date_0   = "$year$month$mday";
$date_2   = "$year年$month月$mday日 $hour:$min";
$date_5   = "$year/$month/$mday $hour:$min";
$tempdir .= "/$loginid";
%myprof   = &getenv("$userdir/$xmailcfg/config.tab","=");
$handle   = $myprof{'k4bbshandle'};
$userid   = lc("$user1\@$domain1");
##
## ==========================================================================
## URLリンク処理
sub convert_url {
	my ($html,$target) = @_;
	if ($target){$target = "target='$target'";}
	$html =~ s/(ftps?|https?):\/\/[0-9a-z%][!#-'*-;=?\@-~]+/<a href='$&' $target>$&<\/a>/gi;
	$html =~ s/<a href='(ftps*|https*):\/\/(localhost|192\.|172\.|127\.|10\.).*' $target>(.+)<\/a>/$3/g;
	$html;
}

## メニューを表示
sub do_header1 {
	my ($error,$op) = @_;
	$error = "&nbsp;$alert $fs5R $error $fe" if $error;
	my %b = &get_bbs_profile($bbsid) if $bbsid;
	my $subtitle1 = '-'.$b{Title} if $bbsid;
	my $subtitle2 = "$fs7G<b>$subtitle1</b>$fe";
	$subtitle2 = "$fs5G 掲示板 $fe" if !$bbsid;
	
	print "Content-Type: text/html; charset=$charset\n";
	print "Pragma: no-cache\n\n";
	print "<html><head>$charcss</head>";
	
	$K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc13' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4 $cbody0>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><a href='bbs_start.cgi?top'>
<img src='$idir/bbs.gif' width=73 height=24 title='掲示板 $subtitle1' border=0></a></td>
<td nowrap>&nbsp;$subtitle2&nbsp;&nbsp;</td>
<td width='100%'>$error</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=3 height=1>$null</td></tr>
EOF
	if (!$op){$K4 .= "<tr><td height=12></td></tr>\n</table>";}
	else {$K4 .= "</table>\n<blockquote>";}
	&print_utf($K4);
}

## 新規書込み記事IDを得る
sub get_article_id {
	my ($counter) = @_;
	
	my $aID;
	my @tmp;
	if (open(FILE,$counter)){
			@tmp = <FILE>;
		close(FILE);
		$aID = $tmp[0];
		chomp($aID);
	}
	$aID++;
	open(FILE,">$counter");
		flock(FILE,2);
		print FILE "$aID\n";
	close(FILE);
	
	$aID = sprintf("%012d",$aID);
}

## 特定掲示板の記事一覧を得る
sub get_articles {
	my ($bbsid) = @_;
	my $base = "$bbsroot/$bbsid";
	my %info = &get_bbs_profile($bbsid);
	my $index = "$base/articles.txt";
	local ($sec,$min,$hour,$mday,$mon,$year);
	my @list;
	
	## 有効インデックスがあれば
	if (-f $index && (stat($index))[9] + $index_ttl > time()){
		open(MyFILE,$index);
			while (<MyFILE>){
				$_ = &dec_utf($_,$charsetE);
				next if (/^\s*$/ || /^#/);
				push(@list,$_);
			}
		close(MyFILE);
		return @list;
	}
	
	## インデックス作成
	unlink($index);
	my @dir = &getdirs("$base/articles","\\d{4}-\\d{2}");
	my $count;
	foreach my $dir (@dir){
		foreach my $a (glob("$base/articles/$dir/*.article")){
			my $aid = $a;
			$aid =~ s/\.article$//i;
			next if -f "$aid.deleted";
			$fdate = $notice = '';
			$fdate = (stat($a))[9];
			$notice = 'new' if time() - $fdate < 60*60*24*$days;
			my %i = &get_bbs_article($a);
			my $date = $i{Created};
			if (-f "$aid.comments"){
				$fdate = (stat("$aid.comments"))[9];
				$notice = 'up' if time() - $fdate < 60*60*24*$days;
				($sec,$min,$hour,$mday,$mon,$year) = localtime($fdate);
				$year = $year + 1900; $month = $mon + 1;
				foreach my $i (qw(month mday min hour)){$$i = sprintf("%02d",$$i);}
				$date = "$year/$month/$mday $hour:$min";
			}
			
			my $line = join("\t",$bbsid,$i{ArticleID},$dir,$date,$i{FName},$i{From},$i{RCPT},
				$i{Priority},$i{Title},$notice,$fdate);
			push(@list,"$line\n");
		}
	}
	if (@list){		## UTFで保存
		my @list2 = @list;
		open(MyFILE,">$index");
			flock(MyFILE,2);
			# 掲示板 $bbsid の記事インデックス($ttl秒間有効)\n";
			# 0BBSID 1記事ID 2パート 3更新日 4投稿者 5投稿者ID 6あて先 7重要度 8記事タイトル\n";
			# 9状態 10更新時刻\n\n";
			foreach (@list2){
				Encode::_utf8_off($_);
				Encode::from_to($_,$charset,$charsetE);
				print MyFILE;
			}
		close(MyFILE);
	}
	
	@list;
}

## 記事情報を得る
sub get_bbs_article {
	my ($article) = @_;
	my %tmp;
	
	my $count = 0;
	open(FILE,$article) || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			if ($count == 0 ... /^$/i){
				if (/^(\w+):\s*(.*)/){$tmp{$1} = $2;}
				$count++;
				next;
			}
			$tmp{Text} .= "$_\n";
		}
	close(FILE);
	
	%tmp;
}

## 特定掲示板のprofileを得る
sub get_bbs_profile {
	my ($bbsid) = @_;
	my %info;
	
	open(FILE,"$bbsroot/$bbsid/$profile") || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			next if (/^\s*$/ || /^#/);
			my ($key,$value) = split(/\s*=\s*/,$_);
			#$value =~ s/\s*#.*//;
			$info{$key} = $value;
		}
	close(FILE);
	
	%info;
}

## 重要度選択リストを得る
sub get_priority {
	my ($value) = @_;	# valueは現在の値
	my $select;
	my %tmp = ('0','普通','1','重要','2','最重要');
	
	foreach (qw(0 1 2)){
		my $str = 'selected' if $_ eq "$value";
		$select .= "<option $str value='$_'>$tmp{$_}</option>\n";
	}
	
	$select;
}

## ロギング
sub logging {
	my ($file,$data) = @_;
	$data =~ s/[\n\r\s]+$//;
	Encode::_utf8_off($data);
	
	open(FILE,">>$file") || return();
		flock(FILE,2);
		print FILE "$date_5\t$ip\t$data\n";		# UTFのまま保存
	close(FILE);
}

## 関係者に通知
sub notify_bbs {
	local ($bbsid,$message,$subject,$from,$to,$OwnersEmail) = @_;
	$subject .= " 掲示板$bbsidに投稿がありました";
	my $dir1 = "$bbsroot/$bbsid/accounts";
	my $dir2 = "$dir1/exclude";
	@rcpt = @Domains = @Groups = @Users = @Xmail = ();
	if ($bbs{'NotifyAdmin'} && $OwnersEmail =~ /$emreg/){
		push(@rcpt,$OwnersEmail);
		$from = $OwnersEmail if !$from;
	}
	
	# 現アカウントリストを得る
	foreach (glob("$dir1/*")){
		my $name = $& if /[^\/]+$/;
		if ($name =~ /$emreg/){
			push(@Users,$name);
		} else {
			push(@Domains,$name);
			if ($name =~ /^\d{3}$/){
				push(@Groups,$name);
			}
		}
	}
	
	# XMailの全ユーザリストを得ておく
	if (open(FILE,"$mailroot/mailusers.tab")){
			while (<FILE>){
				chomp;
				s/"//g;
				$_ = lc($_);
				next if /m$/;	# MLは除く
				push(@Xmail,$_);
			}
		close(FILE);
	}
	
	# 通知対象者を決定する
	# 1. ユーザアカウントを検索
	foreach my $user (@Users){
		push(@rcpt,$user) if !-f "$dir2/$user";
	}
	
	# 2. ドメインを検索
	foreach my $domain (@Domains){
		my ($dom) = &mod_str($domain);
		foreach my $user (grep(/^$dom\t/,@Xmail)){
			my ($domain2,$name2,$x1,$x2,$x3,$type) = split(/\t/,$user);
			next if "$name2\@$domain2" eq lc($robot);	# リストプロセッサは除く
			push(@rcpt,"$name2\@$domain2") if !-f "$dir2/$name2\@$domain2";
		}
	}
	
	# 3. グループを検索
	foreach my $group (@Groups){
		foreach my $user (glob("$mailroot/groups/$group/members/.*@.*")){
			my $account = $& if $user =~ /[^\/]+$/;
			my ($name,$domain) = split(/\@/,$account);
			push(@rcpt,$account) if !-f "$dir2/$account";
		}
	}
	
	# 重複を削除
	my %count;
	@rcpt = grep(!$count{$_}++, @rcpt);
	return() if !@rcpt;
	
	# @rcptから50人ずつ送信実行
	my $count = 0;
	push(@xheader,"X-xmcfg-dfrflgo: 1");	# 送信保留の対象外とする
	while (@To = splice(@rcpt,0,49)){
		$count += @To;
		&startmail();
	}
	
	"$count 個のアカウントへ投稿を通知しました。";
}

## 改ページリンクを生成
sub page_split {
	my ($cgi,$page,@reg) = @_;		# スクリプト名、現ページ数、配列
	my ($all,$item1,$key,$op1,$start);
	($page,$op1) = split(/\+/,$page);
	$op1 = "+$op1" if $op1;
	$all = @reg;
	
	$start = $item*$page;
	my @list = splice(@reg,$start,$item);
	
	my $link;
	if ($all > $item*$page+$item){
		$key = $page + 1;
		if (($all - ($key*$item)) < $item){
			$item1 = "残りの". ($all - ($key*$item)) ."件";
		}
		else {$item1 = "次の".$item."件";}
		$link = "&nbsp;&nbsp;<a href='$cgi+$key$op1'>$item1</a>$arrowR&nbsp;";
		if ($all > $item*$page+$item*2){
			$key = int($all/$item);
			if ($key*$item != $all){}
			else {$key--;}
			$link = "$link<a href='$cgi+$key$op1'>末尾へ</a>$arrowR$arrowR&nbsp;";
		}
	}
	if ($page > 0){
		$key = $page - 1;
		$link = "$arrowL<a href='$cgi+$key$op1'>前の".$item."件</a>".$link;
		if ($page > 1){$link = "$arrowL$arrowL<a href='$cgi+0$op1'>先頭へ</a>&nbsp;$link";}
	}
	if ($link){$link = "<div align='right'><font size=2>$link</font></div>";}
	else {$link = '<br>';}
	
	($link,@list);
}

## 記事参照済みチェック
sub read_check {
	my ($bbs,$dir,$aid) = @_;
	$dir = "$bbsroot/$bbs/articles/$dir";
	
	my @tmp;
	if (open(FILE,"$dir/$aid.read")){
			@tmp = <FILE>;
		close(FILE);
	}
	my $chk = 1 if (!grep(/^$userid/i,@tmp));
	
	$chk;
}

## ファイルアップロード/ウイルススキャン
sub upload {
	my ($file,$tempfile) = ($qArray{file1},$qFileTmp{file1});
	local $filename = $file;
	#$filename = &dec_utf($filename);
	my $ext = $1 if $tempfile =~ /\.([^.]+)$/;
	my $size = -s $tempfile;
	$size = int(($size+1023)/1024);
	my ($rep,$scanok,@report);
	
	# サイズチェック
	if ($size > $maxsize){
		unlink($tempfile);
		my $size2 = $maxsize;
		$size2 =~ s/(.*\d)(\d\d\d)/$1,$2/;
		&html("ファイルサイズが制限 $size2(KB) を超えています。");
	}
	
	# ウイルスチェック
	if (-f "$scanner"){
		my $str = time();
		my $tempfile2 = "../temp/$loginid/$str";
		copy($tempfile,$tempfile2);
		my ($scanok,@report) = &vscan($tempfile2);
		if (
			(@report && grep(/[\/\\]$str[^.].*(Infection:|Infected|virus)/i,@report)) ||
			($scanner =~ /\\nod32(\.exe)*$/i && grep(/\x83\x45\x83\x43\x83\x8B\x83\x58\x90\x94:[1-9]/,@report) 
				&& grep(/[\/\\]$str /,@report)) ||
			($scanner =~ /\\ecls(\.exe)*$/i && grep(/Infected: +files *- *[1-9]/,@report)) ||
			($scanner =~ /\\vscanwin32(\.com)*$/i && grep(/\\$str /i,@report)) ||
			($scanner =~ /\\clamd?scan(\.exe)*$/i && grep(/$str:.+FOUND/,@report)) ||
			($scanner =~ /\\fsav(\.exe)*$/i && grep(/\\$str(\\.+)* +(\x8A\xB4\x90\xF5|Infection):/i,@report)) ||
			($scanner =~ /\\avgscanx(\.exe)*$/i && grep(/\x20\x82\xAA\x93\xC1\x92\xE8/,@report)) ||
			($scanner =~ /\\fpscan(\.exe)*$/i && grep(/\[Found .+?\] *<.+?>/,@report))
		){
			$rep = 1;
		}
	}
	if ($rep){
		unlink($tempfile,$tempfile2);
		&html("指定ファイルはウイルスに感染しています！");
	}
	
	# ファイルとファイル情報を保存
	my $name = time();
	mkdir("$bbsroot/$bbsid/articles/files",0755);
	my $savefile = "$bbsroot/$bbsid/articles/files/$name";
	copy($tempfile,$savefile);
	
	my $line = "$name\t$ext\t$filename\t$size\t$text1\t$user1\@$domain1\t$pri\t$year/$month/$mday $hour:$min";
	$line;
}

1;
