#!C:/usr/perl/bin/perl.exe

### uK4 - ドメインの管理-アクセスログの表示
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./domain_common.cgi";
($cgi,$maxline,$pageline) = ('domain_log.cgi','1000','50');

&expire() if $Expired;
&domainadmin();
($tdomain,$type,$page) = ($key4,$key5,$key6);
$type = lc($type);
%prot = (pop3,POP3,smtp,SMTP,pop31,SMTP,smtp1,POP3);
$type = 'smtp' if !$type;
$page = 1 if !$page;
&check_domaininfo($tdomain);

## ページを表示
&header('log');
&getlog();
$logs = "<tr><td align='center' colspan=6 height=40>(ログはありません)</td></tr>" if !$logs;

my $title0 = "$prot{$type}ログ";
$K4 = <<"EOF";
$table0
<tr><td nowrap width='100%'>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title0'> 
$fs7G<b>$title0</b>$fe&nbsp;<a href='$cgi?$tdomain+$prot{$type . '1'}'>
$prot{$type .'1'}ログ</a> $arrowR</td>
<td align='right' nowrap>$links&nbsp;</td></tr>
</table>
$table0
<tr><td width='100%'>
	<table cellpadding=0 cellspacing=1 class='doc12' border=0 width='100%'>
	<tr><td>
	$title
	$logs
	$title
	</table>
</table>
$table0
<tr><td width=36></td><td align='right' width='100%'>$links&nbsp;</td></tr>
<tr><td></td><td>$notice</td></tr>
</table>
<div align='right'>$arrowU</div>
EOF
&print_utf($K4);

&print_footer();
&exit();

# --------------------------------------
sub getlog {
	local($count,$file,@reg,@reg1,@reg2,@tmp);
	undef $logs;
	while (glob("$mailroot/logs/$type\-*")){unshift(@reg,$_);}
	
	foreach $file (@reg){
		@reg1 = ();
		open(FILE,"$file");
			while(<FILE>){
				chomp;
				s/"//g;
				@tmp = split(/\t/,$_);
				# ドメインレコードの取捨
				if ($type eq 'smtp' && $tmp[6] !~ /\@$tdomain$/i && $tmp[7] !~ /\@$tdomain$/i){next;}
				elsif ($type eq 'pop3' && $tmp[1] !~ /^$tdomain$/i){next;}
				else {unshift(@reg1,$_);}
			}
		close(FILE);
		push(@reg2,@reg1);
		last if $#reg2 >= $maxline - 1;
	}
	
	# 改ページリンク
	@reg2 = splice(@reg2,0,$maxline);
	$totalpage = int(($#reg2 + 1) / $pageline);
	if (($#reg2 + 1) % $pageline){$totalpage++;}
	if ($totalpage > 1){
		for(1 .. $totalpage){
			if ($_ == $page){$links .= "&nbsp;<b>$_</b>"; next;}
			$links .= "&nbsp;<a href='$cgi?$tdomain+$type+$_'><u>$_</u></a>";
		}
		$links .= " $fs2page$fe";
	}
	
	# 表示部分の抜き出し
	@reg = splice(@reg2, ($page - 1) * $pageline, $pageline);
	
	if (!@reg){
		$logs = "<tr><td>$hr</td></tr>";
		$losg .= "<tr><td align='center' height=100>$fs5R ログはありません。$fe</td></tr>";
		return();
	}
	$count = 0;
	if ($type eq 'smtp'){
		$title = <<"EOF";
<tr bgcolor='#c0ffff'><td>IP</td>
<td nowrap>ローカル時</td>
<td>送信者</td>
<td>受信者</td>
<td nowrap>状態</td>
<td nowrap>サイズ</td></tr>
EOF
		foreach(@reg){
			undef $bg;
			($a1,$a2,$ip,$date,$helodomain,$destdomain,$sender,$recipient,$msgid,$status,$logonuser,$msgsize)
				= split(/\t/,$_);
			next if ($sender !~ /@$tdomain$/ && $recipient !~ /@$tdomain$/);
			$bg = $bgcolor3 if ($count % 2);
			$bg = $bgcolor0 if $status !~ /=OK$/;
			if ($status eq 'RCPT=OK'){$status = '宛先OK'; $msgsize = '-';}
			elsif ($status eq 'RECV=OK'){$status = '受信OK';}
			$logs .= "<tr$bg><td><a href='JavaScript:opn_win(\"accesslogv.cgi?$ip\",360,200)'>$ip</a></td><td>$date</td><td>$sender</td>";
			$logs .= "<td>$recipient</td><td>$status</td><td>$msgsize</td></tr>";
			$count++;
		}
	}
	elsif ($type eq 'pop3'){
		$title = "<tr bgcolor='#c0ffff'><td>IP</td><td>ローカル時</td>";
		$title .= "<td>ログイン名</td></tr>";
		foreach(@reg){
			undef $bg;
			($h,$d,$ip,$date,$name,$pass) = split(/\t/,$_);
			$bg = $bgcolor1 if ($count % 2);
			$logs .= "<tr$bg><td><a href='JavaScript:opn_win(\"accesslogv.cgi?$ip\",360,200)'>$ip</a></td><td>$date</td><td>$name</td></tr>";
			$count++;
		}
	}
	else {return();}
	$notice = <<"EOF";
<ul>
<li>表示するのは全ログのうち、先頭から最大 $maxline 行です。</li>
<li>強調背景（赤色）は何らかのエラーが起きたことを示します。
エラー内容についてはマスター管理者に問い合わせてください。</li>
</ul>
EOF
}
