#!C:/usr/perl/bin/perl.exe

### uK4 - フォルダ内ファイル一覧
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./file_common.cgi";
$titles = <<"EOF";
<tr bgcolor='#c0c0c0'><td width='100%'><font color='white'>&nbsp;<b>名前</b></font></td>
<td nowrap><font color='white'><b>サイズ(KB)</b></font></td>
<td align='center' nowrap><font color='white'><b>登録日時</b></font></td>
<td nowrap><font color='white'><b>処理</b></font></td></tr>
EOF

### 初期表示
if (@ARGV){
	my $dir = "$fsroot/$Root/$key7";
	$dir =~ s/\/+$//;
	if ($key8 eq 'refresh'){unlink("$fsroot/$Root/$dirindex","$dir/$index");}
	elsif ($key8){
		if ($key5){$key5 = 0;}
		else {$key5 = 1;}
	}
	&html;
}

## 処理
&parse_form();
foreach (@delx){
	if (/\d{10}/){$Files .= "$_ ";}
	else {$Folders .= "$_ ";}
}

# アップロード
if ($upload){
	print "Location: $uploadcgi?$key4+$key5+$key6+$key7\n\n";
	exit;
}

# 添付送信
if ($attach){
	&html("フォルダは添付できません。") if $Folders;
	&html("添付対象ファイルにチェックをつけてください。") if !$Files;
	&delattach();
	my $root = "$fsroot/$Root/$key7";
	$root =~ s/[\/]+$//;
	
	# 個数のチェック
	my @tmp = split(/\s+/,$Files);
	&html("1回の送信で添付できるファイルは $attachmax 個までです。") if ($attachmax && $attachmax < @tmp);
	
	# サイズのチェック/ファイルをコピー
	foreach my $file (@tmp){
		my $size = -s "$root/$file";
		$size = int(($size+1023)/1024);
		&html("添付できるファイルの最大サイズは $attachsize(KB) です。") if $size > $attachsize;
		copy("$root/$file","$tempdir/$loginid/upload/$file");
		copy("$root/$file.txt","$tempdir/$loginid/upload/$file.txt");
	}
	
	# メッセージ送信ページへリダイレクト
	print "Location: mailbox_new.cgi?mailto2\n\n";
	exit;

}

# エラー処理
&html("対象ファイル/フォルダにチェックをつけてください。") if (!$Files && !$Folders && !$folder);

# 処理内容を保存してリダイレクト
&save_perms($listcgi);
exit;

### ----------------------------------------------
sub html {
	my ($error) = @_;
	if ($Expired && !$error){&expire();}
	my ($buttons2,$c1,$c2,$data1,$data2,$titles2);
	
	# 現況取得
	my %i = &get_info("$fsroot/$Root/$key7");	# カレントフォルダ情報
	my $space = &get_total_space();				# このユーザの総使用量
	my @files = &get_myfiles();					# カレントフォルダのファイル/フォルダ一覧
	my $total = @files;							# カレントフォルダのファイル/フォルダ総数
	my $files = grep(/^\d{10}\t/,@files);		# カレントフォルダのファイル総数
	my $folders = $total - $files;				# カレントフォルダのフォルダ総数
	
	# ソート処理
	@files = &sorting($key4,0,0,@files);
	
	# カレントページ分を取得
	($link,$counter,@files) = &page_split("$listcgi?$key4+$key5",$key6,@files);
	
	# 表示データ(ファイル/フォルダ一覧)を作成
	my $arg = join("+",$key4,$key5,$key6);
	my $dir2 = $key7;
	$dir2 = '_' if !$dir2;
	foreach (@files){
		chomp;
		next if /^\s*$/;
		my ($id,$name,$size,$from,$date) = split(/\t/,$_);
		1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
		if ($id =~ /^\d{10}$/){
			my $bgc = $bgcolor1;
			$bgc = $bgcolor2 if $c1%2;
			#$data2 .= "<tr $bgc><td><a href=\"JavaScript:opn_win('$downloadcgi?$arg+$dir2+$id',400,400)\">";
			$data2 .= "<tr $bgc><td><a href='$downloadcgi?$arg+$dir2+$id'>";
			$data2 .= "$fs5<font $colorB>$fileIcon $name </font>$fe</a>$arrowU2</td>";
			$data2 .= "<td align='right' nowrap>$size$arrowU2</td><td nowrap>$date</td>";
			$data2 .= "<td align='right' nowrap>$arrowU2<input type='checkbox' name='delx' value='$id'></td></tr>";
			$c1++;
		} else {
			my $bgc = $bgc1;
			$bgc = $bgc2 if $c2%2;
			$data1 .= "<tr $bgc><td><a href='$listcgi?$arg+$id'>$fs5<font $colorB>$folderIcon $name</font>$fe</a>$arrowU2</td>";
			$data1 .= "<td align='right' nowrap>$arrowU2</td><td nowrap>$created</td>";
			$data1 .= "<td align='right' nowrap>$arrowU2<input type='checkbox' name='delx' value='$id'></td></tr>";
			$c2++;
		}
	}
	if (!$files && !$folders){
		$buttons = '';
		$data1 = "<tr><td align='center' colspan=4 height=60>このフォルダは空です.</td></tr>";
	}
	
	# 添付ボタン/フォルダ作成ボタン/アップロードボタン追加
	my $refresh = "[<a href='$listcgi?$key4+$key5+0+$key7+refresh'>更新</a>]";
	if ($k4fsspace && $space > $k4fsspace){
		$error = "残りスペースがないため、ファイル/フォルダの追加はできません。";
	} elsif ($fslevel && ($files || $folders)){
		my $str = "チェックをつけたファイル・フォルダをコピーします";
		$buttons = "<input type='submit' name='copy' value='コピー' title='$str'>$buttons";
	}
	if ($allowattach && $c1){
		$buttons .= "<input type='submit' name='attach' value='添付' title='チェックをつけたファイルを添付送信します'>";
	}
	if ($k4fsspace && $space < $k4fsspace){
		if ($fslevel && $k4fsfolders && $c2 < $k4fsfolders && length($key7) < $fslevel*4-1){
			$buttons .= "<input type='submit' name='folder' value='作成' title='このフォルダにサブフォルダを作成します'>";
		}
		if ($k4fsfiles && $c1 < $k4fsfiles){
			$buttons .= "<input type='submit' name='upload' value='アップ' title='このフォルダにファイルをアップロードします'>";
		}
	}
	my $check = "$counter: " if $total;
	if (@files > 1){
		$check .= "<a href='javascript:SetChecked(1)'>[すべて選択]</a><a href='javascript:SetChecked(0)'>[すべて解除]</a>";
	}
	if (@files >= 10){
		$buttons2 = "<tr><td colspan=4>$table0<tr valign='top'><td>$check $refresh</td><td align='right'>$buttons</td></tr>";
		$buttons2 .= "</table></td></tr>";
		$titles2 = $titles;
	}
	$titles2 = "<tr><td bgcolor='#c0c0c0' colspan=4 height=1></td></tr>" if !$titles2;
	
	# 表示
	&print_header1($error);
	my ($K4) = &print_header2($folders,$files);
	my $link2 = "<tr><td align='right' colspan=4>$link</td></tr>" if $link;
	
	$K4 .= <<"EOF";
<table cellpadding=1 cellspacing=1 class='doc13' border=0 width='100%'>
<form action='$listcgi' method='post' name='mList'>
<input type='hidden' name='key4' value='$key4'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='$key6'>
<input type='hidden' name='key7' value='$key7'>
<tr><td align='right' colspan=4>$link</td></tr>
<tr><td colspan=4>$table0<tr valign='bottom'><td>$check$refresh</td><td align='right'>$buttons</td></tr></table></td></tr>
$titles
$data1
$data2
$titles2
$buttons2
$link2
</table>
EOF
	
	if ($folders){$K4 .= "<li>フォルダ名をクリックすればそのフォルダ内のファイル一覧を表示します。</li>";}
	elsif (length($key7) < $fslevel*4-1){$K4 .= "<li>[作成] ボタンからフォルダを作成できます。</li>";}
	if ($files){$K4 .= "<li>ファイル名をクリックすればそのファイルをダウンロードするための小ウインドウが開きます。</li>";}
	else {$K4 .= "<li>[アップ] ボタンからファイルを登録(アップロード)できます。</li>";}
	$K4 .= "<li>添付ファイルにして送信できるのはファイルだけです。</li>" if ($files && $folders);
	$K4 .= "<div align='right'>$arrowU</div>" if $total >= 10;
	$K4 .= "</form></td></tr></table>";
	
	&print_utf($K4);
	&print_footer();
	exit;
}
