#!C:/usr/perl/bin/perl.exe

### uK4 - ファイル/フォルダの処理
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./file_common.cgi";
%Title = ('copy','ファイル/フォルダのコピー','move','ファイル/フォルダの移動','remove','ファイル/フォルダの削除',
	'rename','ファイル/フォルダ名の変更','folder','サブフォルダの作成');

## 初期表示
if (@ARGV){
	($taskid) = @ARGV;
	if (open(FILE,"$tempdir/$loginid/.$taskid")){
			while (<FILE>){
				chomp;
				my ($key,$value) = split(/ *= */,$_);
				$$key = $value;
			}
		close(FILE);
	} else {
		print "Location: $startcgi?0+0+0\n\n";
		exit;
	}
	
	($Files2,$Folders2) = ($Files,$Folders);
	$root = "$fsroot/$Root/$key7";				# カレントディレクトリ
	$root =~ s/[\/]+$//;
	
	&html();
}

## フォルダ・ファイルの処理
&parse_form();
foreach (@delx){
	if (/\d{10}/){$Files .= "$_ ";}
	else {$Folders .= "$_ ";}
}
while (my($name,$value) = each %qArray) {
	&redirect if $k4envstr =~ /,$name,/;
	$value = &dec_utf($value,$charset);
	&zenhan('value');
	$value =~ s/\s+/ /g;
	$$name = $value;
}
$Files =~ s/\s+$//;
$Folders =~ s/\s+$//;
$root = "$fsroot/$Root/$key7";
$root =~ s/[\/]+$//;
&html("このアカウントでは実行できません！") if $k4fixed;

## フォルダID/ファイルIDに対する名前を得ておく
my %i;
my @i = &get_myfiles();
foreach (@i){
	my ($id,$name) = split(/\t/,$_);
	$i{$id} = $name;
}
@list = ();
my @f = &get_dirs();
@list = ();
foreach (@f){
	my ($id,$name) = split(/\t/,$_);
	$i{$id} = $name;
}

## フォルダ作成
if ($Task eq 'folder'){
	exit if !$fslevel;
	my $str;
	for (1 .. $count){$str .= ${'F'.$_}."\t";}
	$str =~ s/^\t+//;
	$str =~ s/\t+$//;
	&html("作成するフォルダの名前を指定してください。") if !$str;
	
	# 同名チェック
	my @str1 = split(/\t+/,$str);
	my %c;
	my @str2 = grep($c{$_}++, @str1);		# 重複を抜き出し
	&html("同名フォルダは作成できません。") if @str2;
	foreach (@i){							# 既存フォルダをチェック
		next if /^\d{10}/;
		my ($id,$name) = split(/\t/,$_);
		my $tmp = $name;
		$tmp =~ s/["$()*+\-.\/?@\[\\\]{|}]/\\$&/g;
		if (grep(/^$tmp\s*$/i,@str1)){
			$name =~ s/</&lt;/g;
			$name =~ s/>/&gt;/g;
			$name =~ s/"/&quot;/g;
			&html("同名の既存フォルダ [$name] があります。");
		}
	}
	
	# 作成OK
	my $count = 0;
	foreach my $str1 (@str1){
		# フォルダIDを決定
		my $ID;
		for my $id (1 .. $k4fsfolders){
			$id = sprintf("%03d",$id);
			next if -d "$root/$id";
			$ID = $id;
			last;
		}
		next if !$ID;
		
		# フォルダ作成
		mkdir("$root/$ID",0755);
		$count++ if -d "$root/$ID";
		
		# フォルダ情報を保存
		Encode::_utf8_off($str1);
		$ID = "$key7/$ID" if $Key7;
		open(FILE,">$root/$ID/$profile");
			flock(FILE,2);
			print FILE "ID = $ID\n";
			print FILE "Name = $str1\n";
			print FILE "Owner = $user1\@$domain1\n";
			print FILE "Created = $year/$month/$mday $hour:$min\n";
			print FILE "Updated = \n";
			print FILE "IP = $ENV{'REMOTE_ADDR'}\n";
		close(FILE);
	}
	&html("サブフォルダを作成できませんでした(原因不明)。") if !$count;
	
	# システムルートのディレクトリインデックスを削除して終了
	unlink("$fsroot/$Root/$dirindex","$root/$index");
	for (1 .. $k4fsfolders){${'F'.$_} = '';}
	$msg = "$count 個のサブフォルダを作成しました。";
}

## コピー/移動
elsif ($Task eq 'copy' || $Task eq 'move'){
	my ($c1,$c2,$str0);
	if ($Task eq 'copy'){$str0 = 'コピー';}
	elsif ($Task eq 'move'){$str0 = '移動';}
	if (!$destination){&html($str0."先を指定してください。");}
	my @FILES = split(/\s+/,$Files);
	my @FOLDERS = split(/\s+/,$Folders);
	
	# 処理先が現フォルダでないかチェック
	if (($key9 eq $startcgi && $destination eq '_') || ($key7 eq $destination || (!$key7 && $destination eq '_'))){
		&html($str0."先を現在のフォルダにすることはできません。");
	}
	
	# 処理元と処理先が同じでないかチェック
	foreach (@FOLDERS){
		if ($destination eq $_){&html($str0."先フォルダ [$i{$destination}] は$str0元と同じです。".$str0."できません。");}
	}
	
	# 現在の全容量(ディスク使用量)を得ておく
	my $space = &get_total_space();
	
	# コピー/移動先の現状を得ておく
	my $target = "$fsroot/$Root/$destination";
	$target =~ s/[\/_]+$//;
	my %ii = &get_info($target);
	my $Name = $ii{'Name'};								# 処理先フォルダ名
	$Name = $rootname if !$Name;
	
	my ($myfolders,$myfiles,@myfoldernames);
	foreach (&get_myfiles($destination)){
		my @tmp = split(/\t/,$_);
		$myfiles++;										# 処理先全ファイル/フォルダ数
		if ($tmp[0] =~ /^\d{10}/){}
		else {
			push(@myfoldernames,"$tmp[1]\t$tmp[0]");	# @myfoldernameは同名チェックで使用
			$myfolders++;								# 処理先全フォルダ数
		}
	}
	
	# コピー/移動元フォルダ内のファイルを処理
	foreach my $file (@FILES){
		if ($k4fsfiles && $myfiles > $k4fsfiles){
			$errors .= "ファイル $i{$file} は".$str0."先ファイル数制限のため".$str0."できませんでした。\n";
			next;
		}
		if ($Task eq 'copy' && $k4fsspace && $space > $k4fsspace){
			$errors .= "ファイル $i{$file} は容量制限のため".$str0."できませんでした。\n";
			next;
		}
		my $file1 = $file;
		if (-f "$target/$file1"){
			for (1 .. 1000){
				$file1 += $_;
				last if !-f "$target/$file1";
			}
		}
		
		# コピー元ファイル情報を得る
		my @tmp;
		open(FILE,"$root/$file.txt");
			@tmp = <FILE>;
		close(FILE);
		my ($info) = $tmp[0];
		$info =~ s/^\d+/$file1/;
		open(FILE,">$target/$file1.txt");		# ファイル情報を作成
			flock(FILE,2);
			print FILE $info;
		close(FILE);
		copy("$root/$file","$target/$file1");	# 本体をコピー
		
		if ($Task eq 'move'){
			unlink("$root/$file","$root/$file.txt");
		} else {
			my $space2 = -s "$root/$file";
			$space2 = int(($space2+1023)/1024);
			$space += $space2;					# 使用量を加算
		}
		
		$errors .= "ファイル \"$i{$file}\" をフォルダ [$Name] に".$str0."しました。\n";
		$c1++;									# 処理ファイル数を1増
		$myfiles++;								# 処理先のファイル/フォルダ合計数を1増
	}
	
	# コピー/移動元フォルダを処理
	foreach my $folder (@FOLDERS){
		if ($k4fsfiles && $myfiles > $k4fsfiles){
			$errors .= "フォルダ [$i{$folder}] は".$str0."先ファイル数制限のため".$str0."できませんでした。\n";
			next;
		}
		if ($k4fsfolders && $myfolders > $k4fsfolders){
			$errors .= "フォルダ [$i{$folder}] は".$str0."先フォルダ数制限のため".$str0."できませんでした。\n";
			next;
		}
		
		# 処理元フォルダ情報を得る
		my %ii;
		if (open(FILE,"$fsroot/$Root/$folder/$profile")){
				while (<FILE>){
					chomp;
					$_ = &dec_utf($_);
					my ($key,$value) = split(/ *= */,$_);
					$value =~ s/</&lt;/g;
					$value =~ s/>/&gt;/g;
					$value =~ s/"/&quot;/g;
					$ii{$key} = $value;
				}
			close(FILE);
		}
		
		# 処理先フォルダ名を決定
		my $chk2;
		my $Name2 = $name2 = $ii{'Name'};
		$name2 =~ s/["$()*+\-.\/?@\[\\\]{|}]/\\$&/g;
		if (grep(/^$name2\t/i,@myfoldernames)){		# 処理先に同名フォルダが存在
			for my $i (1 .. $k4fsfolders){
				my $name = '('.$str0.'されたフォルダ #'.$i.')';
				if (!grep(/^$name\t/i,@myfoldernames)){
					$chk2 = 1;
					$Name2 = $name;
					last;
				}
			}
			if (!$chk2){
				$errors .= "フォルダ [$i{$folder}] は".$str0."先でのフォルダ名が取得できないため".$str0."を行いませんでした。\n";
				next;
			}
		}
		
		# 処理先フォルダIDを決定
		my $ID;
		for my $i (1 .. $k4fsfolders){
			$i = sprintf("%03d",$i);
			if (!-d "$target/$i"){
				$ID = $i;
				last;
			}
		}
		if (!$ID){
			$errors .= "フォルダ [$i{$folder}] は".$str0."先でのフォルダIDが取得できないため".$str0."を行いませんでした。\n";
			next;
		}
		
		# 処理先フォルダルートを作成
		Encode::_utf8_off($Name2);
		mkdir("$target/$ID",0755);
		open(FILE,">$target/$ID/$profile");
			flock(FILE,2);
			print FILE "ID = $ID\n";
			print FILE "Name = $Name2\n";
			print FILE "Owner = $ii{'Owner'}\n";
			print FILE "Created = $ii{'Created'}\n";
			print FILE "Updated = $year/$month/$mday $hour:$min\n";
			print FILE "IP = $ENV{'REMOTE_ADDR'}\n";
		close(FILE);
		$c2++;
		$myfiles++;
		$myfolders++;
		
		# 処理元の全ファイルを処理
		@mydirs = ();
		@myfiles = ();
		$chk1 = $chk2 = '';
		my $str1 = "$fsroot/$Root/$folder";
		&get_files($str1);
		$str1 =~ s/[\\\/]/\\$&/g;
		
		foreach my $dir (@mydirs){
			my ($target2,$dest) = ("$target/$ID",$destination);
			$dir =~ /^$str1(.+)$/;
			$target2 .= "/$1" if $1;
			$dest .= "/$1" if $1;
			my $count = split(/\//,$dest);
			if ($fslevel && $count > $fslevel){			# 階層オーバー
				$chk1 = 1;
				next;
			}
			
			# コピー先フォルダ作成
			if (!-d $target2){
				mkdir($target2,0755);
				$c2++;
			}
			my $dir2 = $dir;
			$dir2 =~ s/["$()*+\-.\/?@\[\\\]{|}]/\\$&/g;
			
			# サブフォルダ内profile.txtコピー
			my @tmp;
			if (!-d "$target2/$profile"){copy("$dir/$profile","$target2/$profile");}
			
			# サブフォルダ内ファイルコピー
			foreach my $i (grep(/^$dir2\t/,@myfiles)){
				if ($Task eq 'copy' && $k4fsspace && $space > $k4fsspace){
					$chk2 = 1;							# 容量オーバー
					last;
				}
				my ($d_x,$id) = split(/\t/,$i);
				copy("$dir/$id","$target2/$id");
				copy("$dir/$id.txt","$target2/$id.txt");
				if ($Task eq 'move'){
					unlink("$dir/$id","$dir/$id.txt","$dir/$index");
				} else {
					my $space2 = -s "$dir/$id";
					$space2 = int(($space2+1023)/1024);
					$space += $space2;					# 使用量を加算
				}
			}
			last if $chk2;
		}
		
		# 移動の場合、移動元フォルダが空になったら削除する
		if ($Task eq 'move'){
			foreach my $dir (reverse(@mydirs)){
				my $chk;
				foreach (glob("$dir/*")){
					$chk = 1 if (/\/\d{10}$/ || /\/\d{3}$/);
				}
				if (!$chk){
					rmtree(["$dir"],0,0);
				}
			}
		}
		
		$errors .= "階層制限または容量制限のため一部のファイルまたはフォルダは".$str0."できませんでした。\n" if ($chk1 || $chk2);
		$errors .= "フォルダ [$i{$folder}] をフォルダ [$Name] に".$str0."しました。\n";
	}
	
	$msg = "$c2 個のフォルダ、" if $c2;
	$msg .= "$c1 個のファイル" if $c1;
	if ($c1 || $c2){
		$msg =~ s/(、)+$//;
		$msg .= "を".$str0."しました。";
		unlink("$target/$index");
		if ($Task eq 'move'){unlink("$root/$index","$fsroot/$Root/$dirindex");}
		if ($c2){unlink("$fsroot/$Root/$dirindex");}
	} else {
		$msg = $str0."を中止しました。";
		$errors = "ファイル/フォルダの".$str0."を中止しました。\n" if !$errors;
	}
}

## 削除
elsif ($Task eq 'remove'){
	my ($c1,$c2);
	if (!$Files && !$Folders){&html("削除するファイルまたはフォルダを指定してください。");}
	
	foreach my $folder (split(/\s+/,$Folders)){
		rmtree(["$fsroot/$Root/$folder"],0,0);
		$errors .= "フォルダ [$i{$folder}] を削除しました。\n";
		$c1++;
	}
	
	foreach my $file (split(/\s+/,$Files)){
		unlink("$root/$file","$root/$file.txt");
		$errors .= "ファイル \"$i{$file}\" を削除しました。\n";
		$c2++;
	}
	
	if ($c1){
		unlink("$fsroot/$Root/$dirindex");
		$msg = "$c1 個のフォルダ";
	}
	if ($c2){
		if ($c1){$msg .= "、";}
		$msg .= "$c2 個のファイル";
	}
	
	unlink("$root/$index","$fsroot/$Root/$dirindex");
	$msg .= "を削除しました。";
}

## 名前変更
elsif ($Task eq 'rename'){
	my ($c1,$c2);
	my @str;
	
	# フォルダ名の変更
	if ($Folders){
		# 入力の重複チェック
		my @str1;
		foreach my $i (split(/\s+/,$Folders)){
			my $id = $i;
			$id =~ s/\//_/g;
			my $name = ${'name1_'.$id};
			next if (!$name || $name eq $i{$i});	# 空白または同名は処理スキップ
			my $tmp = $name;
			$tmp =~ s/["$()*+\-.\/?@\[\\\]{|}]/\\$&/g;
			if (grep(/^$tmp$/i,@str1)){
				$errors .= "フォルダ名 [$name] の指定は重複するため変更できませんでした。\n";
				next;
			}
			push(@str1,$name);
			
			# 既存フォルダ名との重複をチェック
			my @tmp = @i;
			if ($key9 eq $startcgi){
				my $dir = $i;
				$dir =~ s/\/*\d{3}$//;
				@tmp = &get_myfiles($dir);
			}
			if (grep(/^(\d{3}\/*)*\t$tmp\t/,@tmp)){
				$errors .= "フォルダ名 [$name] の指定は既存フォルダ名と重複するため変更できませんでした。\n";
				next;
			}
			push(@str,"$i\t${'name1_'.$id}\t${'name3_'.$id}");
		}
		
		# 登録情報更新
		foreach my $i (@str){
			my ($id,$name,$oldname) = split(/\t/,$i);
			my $root = "$fsroot/$Root/$id";
			my @tmp;
			if (open(FILE,"$root/$profile")){
					while (<FILE>){
						chomp;
						$_ = &dec_utf($_,$charset);
						my ($key,$value) = split(/ *= */,$_);
						if (/^Name *=/){$_ = "Name = $name";}
						elsif (/^Updated *=/){$_ = "Updated = $year/$month/$mday $hour:$min";}
						elsif (/^IP *=/){$_ = "IP = $ENV{'REMOTE_ADDR'}";}
						push(@tmp,"$_\n");
					}
				close(FILE);
				open(FILE,">$root/$profile");
					flock(FILE,2);
					foreach (@tmp){
						Encode::_utf8_off($_);
						print FILE;
					}
				close(FILE);
				
				$errors .= "フォルダ [$oldname] の名前を [$name] に変更しました。\n";
				unlink("$root/$index");
				$c1++;
			} else {
				$errors .= "フォルダ [$oldname] は名前を変更できませんでした。\n";
			}
		}
	}
	
	# ファイル名の変更
	@str = ();
	foreach my $i (split(/\s+/,$Files)){
		my ($text,$newname,$oldname) = (${'name1_'.$i},${'name2_'.$i},${'name3_'.$i});
		$oldname =~ /\.([^.]+)$/;
		my $ext1 = $1;
		$newname =~ s/(\.$ext1)*$/.$ext1/i;
		
		# 比較
		my @tmp;
		open(FILE,"$root/$i.txt");
			while (<FILE>){
				chomp();
				$_ = &dec_utf($_);
				push(@tmp,$_);
			}
		close(FILE);
		my ($id0,$ext0,$name0,$size0,$text0,$user0,$pri0,$date0) = split(/\t/,$tmp[0]);
		my $name1 = $text0;
		if ($name1){$name1 .= "($name0)";}
		else {$name1 = $name0;}
		if ($newname eq $oldname && $text eq $text0){
			$errors .= "ファイル \"$name1\" は変更がありませんでした。\n";
			next;
		}
		
		# 更新
		my $line = join("\t",$i,$ext0,$newname,$size0,$text,$user0,$pri0,$date0,"$year/$month/$mday $hour:$min");
		Encode::_utf8_off($line);
		open(FILE,">$root/$i.txt");
			flock(FILE,2);
			print FILE "$line\n";
		close(FILE);
		
		my $name2 = $text;
		if ($name2){$name2 .= "($newname)";}
		else {$name2 = $newname;}
		
		$errors .= "ファイル \"$name1\" の名前を \"$name2\" に変更しました。\n";
		$c2++;
	}
	
	if ($c1 || $c2){unlink("$root/$index");}
	if ($c1){
		unlink("$fsroot/$Root/$dirindex");
		$msg = "$c1 個のフォルダ";
	}
	if ($c2){
		if ($c1){$msg .= "、";}
		$msg .= "$c2 個のファイル";
	}
	if ($msg){$msg .= "について名前を変更しました。";}
	else {$msg = '変更を中止しました。'; $errors = "ファイル名/フォルダ名の変更を中止しました。\n" if !$errors;}
}

## ロギング

## 完了
&htmlconv('errors');
$errors =~ s/\n/<br>/g;
&html($msg,$errors,1);

### ---------------------------------------------------------------
sub html {
	my ($errors1,$errors2,$op) = @_;
	if ($Expired && !$errors1){&expire();}
	&print_header1($errors1);
	($K4) = &print_header3($errors2,$op);
	
	@list = ();
	@folders = &get_dirs();						# 全フォルダのID,名前情報
	@list = ();
	@files = &get_myfiles();					# カレントフォルダのファイル/フォルダ一覧
	$folders = grep(/^(\d{3}\/*)+\t/,@files);	# カレントフォルダのサブフォルダ総数
	@F1 = split(/\s+/,$Folders);
	@F2 = split(/\s+/,$Files);
	@F1x = split(/\s+/,$Folders2);
	@F2x = split(/\s+/,$Files2);
	
	$K4 .= <<"EOF";
<p><table cellpadding=10 cellspacing=0 class='doc131' border=0 width='100%'>
<form action='$managecgi' method='post' name='mList'>
<input type='hidden' name='key4' value='$key4'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='$key6'>
<input type='hidden' name='key7' value='$key7'>
<input type='hidden' name='key8' value='$key8'>
<input type='hidden' name='key9' value='$key9'>
<input type='hidden' name='Task' value='$Task'>
<input type='hidden' name='Files2' value='$Files2'>
<input type='hidden' name='Folders2' value='$Folders2'>
EOF
	
	if ($Task eq 'folder'){$K4 .= &html_folder();}
	elsif ($Task =~ /^copy|move|remove/){$K4 .= &html_copy();}
	elsif ($Task eq 'rename'){$K4 .= &html_rename();}
	
	$K4 .= "</table></form></p></td></tr></table>";
	
	&print_utf($K4);
	&print_footer();
	exit;
}

### フォルダ作成フォームを表示
sub html_folder {
	# 作成可能フォルダ数を得る
	$k4fsfolders = $fsfolders if !$k4fsfolders;
	my $count = $k4fsfolders - $folders;
	$count = 5 if $count > 5;
	
	my $K4 = "<tr><td $bgcolor3>";
	$K4 .= "<table cellpadding=1 cellspacing=0 class='doc131' border=0>";
	$K4 .= "<input type='hidden' name='count' value='$count'>";
	if ($count){
		for (1 .. $count){
			my $c = $folders+$_;
			${'F'.$_} =~ s/</&lt;/g;
			${'F'.$_} =~ s/>/&gt;/g;
			${'F'.$_} =~ s/"/&quot;/g;
			$K4 .= "<tr><td>フォルダ$c:&nbsp;</td>";
			$K4 .= "<td><input name='F$_' size=30 maxlentgh=128 value=\"${'F'.$_}\" $nosubmit></td></tr>";
		}
		$K4 .= <<"EOF";
<tr><td height=8></td></tr>
<tr><td colspan=2><input type='submit' value='サブフォルダを作成' $class></td></tr>
</table></td></tr>
<tr><td class='doc13'>
<li>このフォルダ内には合計 $k4fsfolders 個のサブフォルダを作成できます。</li>
<li>フォルダ名は任意に指定できます。使用文字についての制限はありません(日本語可)。</li>
<li>同名のサブフォルダは作成できません。</li></td></tr>
EOF
	} else {
		$K4 .= "<tr><td align='center' colspan=2 height=120>フォルダ数が規定数に達しました。</td></tr>";
	}
	
	$K4;
}

### コピー/移動/削除フォームを表示
sub html_copy {
	my ($c1,$c2,$confirm,$data1,$data2,$dstn,$str0,$str1,$str2);
	
	if ($Task eq 'copy'){$str0 = 'コピー';}
	elsif ($Task eq 'move'){$str0 = '移動';}
	else {
		$confirm = " onClick=\"if(!confirm('本当に削除しますか？ 削除後は回復できません。')){return false;}\"";
		$str0 = '削除';
	}
	
	foreach my $folder (@F1x){
		$folder =~ s/\//\\$&/g;
		my ($line) = grep(/^$folder\t/,@folders);
		my ($id,$name,$size) = split(/\t/,$line);
		my $bgc = $bgc1;
		$bgc = $bgc2 if $c1%2;
		my $id2 = $id;
		$id2 =~ s/\//\\$&/g;
		my $chk = 'checked' if grep(/^$id2$/,@F1);
		$data1 .= <<"EOF";
<tr $bgc><td class='doc15'>$name$arrowU2</td>
<td align='right' nowrap>$arrowU2</td><td nowrap>$created</td>
<td align='right' nowrap>$arrowU2<input type='checkbox' name='delx' value='$id' $chk></td></tr>
EOF
		$c1++;
	}
	
	if ($data1 && $Task eq 'remove'){
		$str1 = <<"EOF";
<dl><dd><p>$fs2 フォルダを削除すると、内部のサブフォルダとファイルもすべて削除されます。<br>
回復することはできません。$fe</p></dl>
EOF
	}
	
	foreach my $file (@F2x){
		my ($line) = grep(/^$file\t/,@files);
		my ($id,$name,$size,$from,$date) = split(/\t/,$line);
		my $bgc = $bgcolor1;
		$bgc = $bgcolor2 if $c2%2;
		my $chk = 'checked' if grep(/^$id$/,@F2);
		$data2 .= <<"EOF";
<tr $bgc><td class='doc15'>$name$arrowU2</td>
<td align='right' nowrap>$size$arrowU2</td><td nowrap>$date</td>
<td align='right' nowrap>$arrowU2<input type='checkbox' name='delx' value='$id' $chk></td></tr>
EOF
		$c2++;
	}
	
	# コピー先/移動先リストを得る
	if ($Task ne 'remove'){
		my $select;
		@list = ();
		my @data = &get_dirs();
		@list = ();
		foreach (&sorting(0,0,0,@data)){
			my ($dir,$name) = split(/\t/,$_);
#			next if $key7 eq $dir;			# 自分は除外
			my $class = split(/\//,$dir);
			next if $class > $fslevel;		# 最深階層に達しているフォルダは除外
			next if (!@F2 && $class >= $fslevel);	# フォルダのみの処理であればさらに除外
			my $c;
			if (!$dir){
				$dir = '_';
				$name = "[$rootname]";
			} else {
				$c = split(/\//,$dir);
				my $c2 = '+-' x --$c;
				$name = "$c2$name" if $c;
			}
			$select .= "<option value='$dir'>$name</option>";
		}
		if ($select){
			$dstn = "<tr><td height=8></td></tr>";
			$dstn .= "<tr><td colspan=4><select name='destination'>";
			$dstn .= "<option value=''>$str0"."先を指定してください</option>";
			$dstn .= "$select</select></td></tr>";
		}
		my $str = $destination;
		$str =~ s/\//\\$&/g;
		$dstn =~ s/'$str'/$& selected/;
	}
	
	my $K4 = <<"EOF";
$str1
<tr><td>
<table cellpadding=1 cellspacing=1 class='doc131' border=0 width='100%'>
<tr bgcolor='#c0c0c0'><td width='100%'><font color='white'>&nbsp;<b>名前</b></font></td>
<td nowrap><font color='white'><b>サイズ(KB)</b></font></td>
<td align='center' nowrap><font color='white'><b>登録日時</b></font></td>
<td nowrap><font color='white'><b>$str0する</b></font></td></tr>
$data1
$data2
$dstn
<tr><td height=8></td></tr>
<tr><td colspan=4><input type='submit' value='$str0 を実行する' $confirm $class></td></tr>
</table></td></tr>
EOF
	
	$K4;
}

### リネームフォームを表示
sub html_rename {
	my ($c1,$c2,$data1,$data2);
	
	my %fn;			# フォルダIDとフォルダ名の連想配列を得ておく
	foreach (@folders){
		my ($id,$name) = split(/\t/,,$_);
		$fn{$id} = $name;
	}
	
	foreach my $folder (@F1x){
		$folder =~ s/\//\\$&/g;
		my ($line) = grep(/^$folder\t/,@folders);
		my ($id,$name,$size) = split(/\t/,$line);
		my $id2 = $id3 = $id4 = $id;
		$id2 =~ s/\//_/g;
		my $bgc = $bgc1;
		$bgc = $bgc2 if $c1%2;
		$id3 =~ s/\//\\$&/g;
		my $chk = 'checked' if grep(/^$id3$/,@F1);
		my $parent;
		if ($key9 eq $startcgi){
			while ($id4 =~ s/\/\d{3}$//){$parent = "$fn{$id4}/$parent";}
			$parent = "$rootname/$parent";
		} else {
			$parent = 'フォルダ:';
		}
		$data1 .= <<"EOF";
<tr $bgc><td nowrap>$parent</td><td><input type='hidden' name='name3_$id2' value="$name">
<input name='name1_$id2' size=25 maxlength=128 value='$name' $nosubmit></td>
<td colspan=2 width='100%'></td>
<td align='right' nowrap><input type='checkbox' name='delx' value='$id' $chk></td></tr>
EOF
		$c1++;
	}
	
	foreach my $file (@F2x){
		my @tmp;
		open (FILE,"$root/$file.txt") || next;
			@tmp = <FILE>;
		close(FILE);
		my $tmp = $tmp[0];
		$tmp = &dec_utf($tmp,$charset);
		my ($id,$ext,$rname,$size,$text) = split(/\t/,$tmp);
		my $rname2 = $rname;
		$rname2 =~ s/\.[^.]+$//;
		my $bgc = $bgcolor1;
		$bgc = $bgcolor2 if $c2%2;
		my $chk = 'checked' if grep(/^$id$/,@F2);
		$data2 .= <<"EOF";
<tr $bgc><td nowrap>保存名:</td><td><input type='hidden' name='name3_$id' value="$rname">
<input name='name1_$id' size=25 maxlength=128 value="$text" $nosubmit></td>
<td nowrap>&nbsp;オリジナル名:</td><td nowrap>
<input name='name2_$id' size=35 maxltngth=128 value='$rname2' $nosubmit> .$ext</td>
<td align='right' nowrap><input type='checkbox' name='delx' value='$id' $chk></td></tr>
EOF
		$c2++;
	}
	
	my $K4 = <<"EOF";
<tr><td>
<table cellpadding=1 cellspacing=1 class='doc131' border=0 width='100%'>
<tr bgcolor='#c0c0c0'><td colspan=4><font color='white'>&nbsp;<b>名前の変更</b></font></td>
<td nowrap><font color='white'><b>変更する</b></font></td></tr>
$data1
$data2
<tr><td height=8></td></tr>
<tr><td colspan=5><input type='submit' value='変更を実行する' $confirm $class></td></tr>
</table></td></tr>
EOF
	
	if ($Folders || $Files){
		$K4 .= "<tr><td class='doc13'>";
		if ($Folders){$K4 .= "<li>フォルダ名の変更では、同階層の他のサブフォルダと同名にすることはできません。</li>";}
		if ($Files){
			$K4 .= "<li>ファイルの [保存名] は自由に指定でき、同階層の他の名前と重複させることも可能です(日本語可)。</li>";
			$K4 .= "<li>ファイルの保存名を指定しなかった場合、オリジナル名が保存名になります。</li>";
			$K4 .= "<li>オリジナル名は省略できません。また、オリジナル名の拡張子は変更できません。</li>";
		}
		$K4 .= "</td></tr>";
	}
	
	$K4;
}

### タイトルを表示
sub print_header3 {
	my ($error,$op) = @_;		# $opは完了時
	my ($folders,$name) = &get_dirs_list();
	$name = $rootname if !$name;
	if (!$error){
		my $str;
		if ($Files){
			$str = 'ファイル';
			$str .= 'またはサブフォルダ' if $Folders;
		} else {
			$str = 'サブフォルダ';
		}
		if ($key9 eq $startcgi){$error = '個人用フォルダ内';}
		else {$error = "[$name] フォルダ内";}
		if ($Task eq 'copy'){
			$error .= "の".$str."を指定場所にコピーします。";
		} elsif ($Task eq 'move'){
			$error .= "の".$str."を指定場所に移動します。";
		} elsif ($Task eq 'remove'){
			$error .= "の".$str."を削除します。";
		} elsif ($Task eq 'rename'){
			$error .= "の".$str."の名前を変更します。";
		} elsif ($Task eq 'folder'){
			$error .= "にサブフォルダを作成します。";
		}
	}
	
	my $K4 = <<"EOF";
$table0
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=4 cellspacing=0 class='doc131' border=0 width='100%'>
		<tr valign='top'><td $bgcolor1 height=100>
			<table cellpadding=1 cellspacing=0 class='doc131' border=0>
			<tr><td align='center' bgcolor='#c0c0c0'><font color='white'><b>フォルダツリー</b></font></td></tr>
			<tr><td height=4></td></tr>
			$folders
			</table></td></tr>
		</table></td></tr>
	</table></td>
<td><img src='$idir/null.gif' height=1 width=12 alt=''></td>
<td width='100%'>
	$table0
	<p><tr valign='bottom'><td>
	$fs5<b>$Title{$Task}</b>$fe [$name]</td>
	<td align='right'><a href='$key9?$key4+$key5+$key6+$key7'>前にもどる$arrowR</a></td></tr>
	<tr bgcolor='#c0c0c0'><td colspan=2 height=1></td></tr>
	</table></p>
	<dl><dd><p><font $colorG>$error</font></p></dl>
EOF
	
	if ($Task ne 'folder' && $op){		# 処理完了
		$K4 .= "</td></tr></table>";
		&print_utf($K4);
		&print_footer();
		exit;
	}
	
	($K4,$name);
}
