#!C:/usr/perl/bin/perl.exe

### uK4 - グループの管理 - 全員への同報
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Net::SMTP;
use MIME::Base64;
use utf8;
require "./config.cgi";
require "./group_common.cgi";
$cgi = "group_notify.cgi";
$template = 'K4.msg.template.tab';
@array = qw(gid Bcc exclude from message subject mytemplate id save);

## 初期表示
if (@ARGV){
	($gid) = @ARGV;
	exit if $extstr4 !~ /$gid/;
	
	$from = "$user1\@$domain1";
	$Bcc = $from;
	$subject = "管理者からのお知らせです。";
	
	&html();
}

## フォームからの入力を処理
&parse_form(@array);
&html("このアカウントでは実行できません！") if $k4fixed;

# テンプレート呼び出し
if ($mytemplate){
	if (!$id){
		$id = $from = $subject = $message = '';
		&html();
	}
	if (open(FILE,"$groot/$gid/$template")){
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				if (/^$id\t/){
					($id,$date,$gid2,$from,$bcc,$subject,$message) = split(/\t/,$_);
					$message =~ s/\|\|+/\n/g;
					last;
				}
			}
		close(FILE);
	}
	&html();
}

# 入力チェック
&html("用件を書いてください。") if !$subject;
&html("送信者アドレスを書いてください。") if !$from;
foreach my $i (split(/, */,$Bcc)){
	my $em = &get_email($i);
	&html("Bccアドレスを確認してください。") if $em !~ /^$emreg$/;
	push(@Bcc,$em);
}
&html("何かメッセージを書いてください。") if !$message;
foreach my $i (split(/\n+/,$exclude)){			# 除外リスト
	my $em = &get_email($i);
	if ($em =~ /^$emreg$/){push(@exclude,$em);}
}

# 送信先リストを得てメッセージ送信
$count = $members = '';
my ($bcc,$from1,$msg,$subj) = ($Bcc,$from,$message,$subject);
foreach $to (&get_group_members($gid)){
	my ($to2) = &mod_str($to);
	if (grep(/^$to2$/,@exclude)){next;}
	($Bcc,$from,$message,$subject) = ($bcc,$from1,$msg,$subj);
	@To = ($to);
	if ($count){
		$Bcc = '';
		@Bcc = ();
	}
	&startmail();
	$count++;
	$members .= "$to<br>";
}
($Bcc,$from,$message,$subject) = ($bcc,$from1,$msg,$subj);

# テンプレート保存
if ($save){
	my $wday1 = ('日','月','火','水','木','金','土')[$wday];
	my $date = "$year/$month/$mday($wday1)";
	my $time = time();
	my $msg = $message;
	$msg =~ s/\n/\|\|/g;
	my $line = "$time\t$date\t$gid\t$from\t$Bcc\t$subject\t$msg";
	Encode::_utf8_off($line);
	Encode::from_to($line,$charset,$charsetE);
	# 保存
	open(FILE,">>$groot/$gid/$template");
		flock(FILE,2);
		print FILE "$line\n";
	close(FILE);
}

# 完了
&html("メンバー全員にメッセージを送りました。",1);

## ページを表示 ----------------------------
sub html {
	&expire if ($Expired && !$_[1]);
	
	&header(@_);
	&print_mytitle('notify');
	&print_complete() if $_[1];
	
	# 有効期限外でないか
	my $ctime = $year.$month.$mday;
	my $str1 = "$table0<td><td><input type='reset' value='リセット'></td>";
	$str1 .= "<td align='right'><input type='submit' value='メッセージを送信する' $confirm2></td></tr></table>";
	if (($g{'Start'} && $g{'Start'} > $ctime) || ($g{'End'} && $g{'End'} < $ctime)){
		$str1 = "$fs2(このグループは有効期限切れです。送信できません)$fe";
	}
	
	# 送信対象メンバーは存在するか
	my $dir = "$groot/$gid";
	if ((!glob("$dir/members/*")) && (!glob("$dir/groups/*")) && (!glob("$dir/domains/*"))){
		$str1 = "$fs2(このグループはメンバーが存在しません。送信できません)$fe";
	}
	
	# テンプレートがある場合はそれを呼び出せるようにする
	my $mytemp = &get_template($gid);
	if ($mytemp){
		$mytemp =~ s/'$id'/$& selected/;
		$mytemp = <<"EOF";
<tr $bgcolor0><td colspan=2>&nbsp;■ テンプレート(ひな形)を読み出す<br>
<select name='id'>
<option value=''>▽選択してください</option>
$mytemp</select><input type='submit' name='mytemplate' value='読み出し実行'></td></tr>
<tr><td height=8></td></tr>
EOF
	}
	
	print <<"EOF";
<dl><dd>
<form action='$cgi' method='post'>
<input type='hidden' name='gid' value='$gid'>

<table cellpadding=1 cellspacing=0 class='doc13' border=0>
$mytemp
<tr><td>用件(Subject:)</td><td><input name='subject' size=70 maxlength=128 value="$subject"></td></tr>
<tr><td>送信者(From:)</td><td><input name='from' size=70 maxlength=128 value="$from"></td></tr>
<tr><td>内報(Bcc:)</td><td><input name='Bcc' size=70 maxlength=256 value="$Bcc"></td></tr>
<tr><td colspan=2><textarea class='doc15' name='message' cols=70 rows=12 wrap='soft'>$message</textarea></td></tr>
<tr><td valign='top'>除外アドレス&nbsp;</td>
	<td><textarea name='exclude' cols=30 rows=5 wrap='soft'>$exclude</textarea></td></tr>
<tr><td colspan=2>
<input type='checkbox' name='save' value='1'> このメッセージをテンプレートとして保存する。$hr</td></tr>
<tr><td height=8></td></tr>
<tr><td colspan=2>$str1</td></tr>
</table>

<p>$hr
<div class='doc13'>
<li>用件やメッセージには日本語を使うことができます。</li>
<li>送信先が重複している場合、送信は 1回のみです。</li>
<li>メッセージフッタの自動付加は行われません。手入力してください。</li>
<li>除外アドレスを入力すると、そのメンバーに対しては送信を行いません。</li>
<li>送信済みメッセージを再利用する場合はテンプレートとして保存してください。</li>
<li>メンバー数が多い場合は完了まで時間がかかることがあります。</li>
</div></p>

<div align='right'>$arrowU</div>
</form>
</dl>
EOF
	
	&print_footer();
	&exit();
}

## テンプレートがあれば読む
sub get_template {
	my ($group) = @_;
	my $data;
	my @tmp;
	
	open(FILE,"$groot/$gid/$template") || return();
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			chomp;
			push(@tmp,$_);
		}
	close(FILE);
	
	foreach (reverse(@tmp)){
		my ($id,$date,$gid2,$from,$bcc,$subject,$message) = split(/\t/,$_);
		$data .= "<option value='$id'>$date  $subject</option>\n";
	}
	
	$data;
}

## 送信完了
sub print_complete {
	$message =~ s/[\n\r]/<br>/g;
	
	print <<"EOF";
<dl><dd>
<table cellpadding=2 cellspacing=0 class='doc131' border=0>
<tr><td>あて先(To):</td><td>$count (人)</td></tr>
<tr><td>用件(Subject:)</td><td>$subject</td></tr>
<tr><td>送信者(From:)</td><td>$from</td></tr>
<tr><td>内報(Bcc:)</td><td>$Bcc</td></tr>
<tr><td height=8></td></tr>
<tr><td colspan=2>
	<table cellpadding=10 cellspacing=0 border=1>
	<tr><td class='doc15'>$message</td></tr>
	</table></td></tr>
</table>
<dl><dd>
<p>■以下は送信先アドレスの一覧です。</p>
$members
</dl>
</dl>
EOF
	&print_footer();
	exit();
}
