#!C:/usr/perl/bin/perl.exe

### uK4 - グループの管理 - 責任者への同報
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Net::SMTP;
use MIME::Base64;
use utf8;
require "./config.cgi";
require "./group_common.cgi";
$cgi = "group_sendmail.cgi";
@array = qw(gid Bcc Cc from to message subject);
%array = ('Bcc','Bcc','Cc','Cc','from','送信者','to','あて先');

## 初期表示
if (@ARGV){
	($gid) = @ARGV;
	exit if $extstr4 !~ /$gid/;
	
	my %g = &get_group_profile($gid);		# グループ情報を得る
	for (1 .. 10){
		$to .= $g{'Charge'.$_.'Email'}.',' if $g{'Charge'.$_.'Email'} =~ /$emreg/;
	}
	$to =~ s/,$//;
	$from = "$user1\@$domain1";
	$Bcc = $from;
	$subject = "管理者からのお知らせです。";
	
	&html();
}

## フォームからの入力を処理
&parse_form(@array);
&html("このアカウントでは実行できません！") if $k4fixed;

# 入力チェック
&html("用件を書いてください。") if !$subject;
foreach my $i (qw(to Cc Bcc from)){
	my ($str1,$str2);
	if ($i eq 'to'){$str1 = 'To';}
	elsif ($i eq 'Cc' || $i eq 'Bcc'){$str1 = $i;}
	
	&html("$array{$i}アドレスを書いてください。") if (($i eq 'to' || $i eq 'from') && !$$i);
	
	foreach my $ii (split(/, */,$$i)){
		my $em = &get_email($ii);
		&html("$array{$i}アドレスを確認してください。") if $em !~ /^$emreg$/;
		$str2 .= $ii.',';
		if ($str1){push(@$str1,$em);}
	}
	$str2 =~ s/,+$//;
	$$i = $str2;
}
&html("送信可能なあて先が指定されていません。") if !@To;
&html("何かメッセージを書いてください。") if !$message;

# メッセージ送信
$forcemsgfooter = 0;
my ($to1,$cc,$bcc,$from1,$msg,$subj) = ($to,$Cc,$Bcc,$from,$message,$subject);
&startmail();
($to,$Cc,$Bcc,$from,$message,$subject) = ($to1,$cc,$bcc,$from1,$msg,$subj);

# 完了
&html("責任者にメッセージを送りました。",1);

## ページを表示 ----------------------------
sub html {
	&expire if ($Expired && !$_[1]);
	&htmlconv('to','cc','bcc','from','subject','message');
	
	&header(@_);
	&print_mytitle('sendmail');
	&print_complete() if $_[1];
	
	# 有効期限外でないか
	my $ctime = $year.$month.$mday;
	my $str1 = "$table0<td><td><input type='reset' value='リセット'></td>";
	$str1 .= "<td align='right'><input type='submit' value='メッセージを送信する' $confirm2></td></tr></table>";
	if (($g{'Start'} && $g{'Start'} > $ctime) || ($g{'End'} && $g{'End'} < $ctime)){
		$str1 = "$fs2(このグループは有効期限切れです。送信できません)$fe";
	}
	
	print <<"EOF";
<dl><dd>
<form action='$cgi' method='post'>
<input type='hidden' name='gid' value='$gid'>

<table cellpadding=1 cellspacing=0 class='doc131' border=0>
<tr><td>用件(Subject:)</td><td><input name='subject' size=70 maxlength=128 value="$subject"></td></tr>
<tr><td>あて先(To):</td><td><input name='to' size=70 maxlength=128 value="$to"></td></tr>
<tr><td>送信者(From:)</td><td><input name='from' size=70 maxlength=128 value="$from"></td></tr>
<tr><td>同報(Cc:)</td><td><input name='Cc' size=70 maxlength=256 value="$Cc"></td></tr>
<tr><td>内報(Bcc:)</td><td><input name='Bcc' size=70 maxlength=256 value="$Bcc"></td></tr>
<tr><td colspan=2><textarea class='doc15' name='message' cols=70 rows=12 wrap='soft'>$message</textarea></td></tr>
<tr><td height=8></td></tr>
<tr><td colspan=2>$str1</td></tr>
</table>

<p>$hr
<div class='doc13'>
<li>用件やメッセージには日本語を使うことができます。</li>
<li>責任者への連絡ではメッセージフッタの自動付加は行われません。手入力してください。</li>
</div></p>

<div align='right'>$arrowU</div>
</form>
</dl>
EOF
	
	&print_footer();
	exit();
}

## 送信完了
sub print_complete {
	$message =~ s/[\n\r]/<br>/g;
	
	print <<"EOF";
<dl><dd>
<table cellpadding=2 cellspacing=0 class='doc131' border=0>
<tr><td>用件(Subject:)</td><td>$subject</td></tr>
<tr><td>あて先(To):</td><td>$to</td></tr>
<tr><td>送信者(From:)</td><td>$from</td></tr>
<tr><td>同報(Cc:)</td><td>$Cc</td></tr>
<tr><td>内報(Bcc:)</td><td>$Bcc</td></tr>
<tr><td height=8></td></tr>
<tr><td colspan=2>
	<table cellpadding=10 cellspacing=0 border=1>
	<tr><td class='doc15'>$message</td></tr>
	</table></td></tr>
</table>
EOF
	&print_footer();
	exit();
}
