#!C:/usr/perl/bin/perl.exe

### uK4 - 個人用リストの管理トップ
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use MIME::Base64;
use Net::SMTP;
use utf8;
require "./config.cgi";
require "./list_common.cgi";
@array = qw(k4mklist ListName);
@array1 = qw(Attachment Deny Footer ForceFrom GoodbyeMessage Header ListAdmin Log MaxUser MessageID 
	MessageSize Owner ReplyTo Robot RobotHelp RobotInfo Subscribe Tag WelcomeMessage);	# K4独自変数

## 初期表示/削除
if (@ARGV){
	if ($key4 eq 'ifdel'){&html('',$key5,'del');}
	if ($key4 eq 'del'){
		my ($l,$d) = split(/\@/,$key5);
		&ctrlcmd("\"userdel\"	\"$d\"	\"$l\"");
		if ($? != 0){&log('f',$domain1,$user1,'?','admin','個人用リスト削除に失敗',$0);}
		else {&log('s',$domain1,$user1,'?','admin','個人用リストを削除',$0);}
		
		my @LA;
		my ($tmp) = &mod_str($key5);
		# listadmin.tabから削除
		open(FILE,"$mailroot/$listadmintab");
			while(<FILE>){
				if (/^&* *$tmp\t/i){$chk = 'y'; next;}
				push(@LA,$_);
			}
		close(FILE);
		if ($chk && open(FILE,">$mailroot/$listadmintab")){
				flock(FILE,2);
				print FILE @LA;
			close(FILE);
		}
		unlink("$mailroot/custdomains/$key5.tab");
		# ディレクトリ削除
		if (-e "$mailroot/domains/$d/$l"){
			rmtree(["$mailroot/domains/$d/$l"],0,0);
		}
		
		# 削除の通知
		#&noticemsg($key5,"削除");
	}
	&getenv("$userdir/$xmailcfg/config.tab",'=',1);
	$l{'k4mklist'} = $k4mklist;
	&html();
}

## フォーム入力を処理
&parse_form(@array);
while (my($key,$val) = each %qArray){
	$val =~ s/\s+//g;
	$l{$key} = $val;
}
$ml = "$l{ListName}\@$domain1";

# エラーチェック
$tmp = $l{ListName};
$tmp =~ s/[.\-]/\\$&/g;
&html("このアカウントでは作成できません！",1) if $k4fixed;
&html("リスト名を指定してください。",1) if !$l{ListName};
&html("リスト名に不正な文字が含まれています！",1) if $l{ListName} =~ /[^\w.\-]/;
&html("ドットで開始または終了するリスト名は使用できません！",1) if ($l{ListName} =~ /^\./ || $l{ListName} =~ /\.$/);
&html("$l{ListName}\@$domain1 はシステムで予約済みです！") if -s "$mailroot/cmdaliases/$domain1/$l{ListName}.tab";
foreach(split(/\s+/,$plrname)){		# 予約アカウントのチェック
	&html("リスト名に $l{ListName} は使えません！",1) if /^$tmp$/i;
}
&env0($domain1);					# ドメインの全アカウントを得る
&html("リスト名 $l{ListName} は使用済みです！",1) if (grep(/^$tmp$/i,@K4A));

# アカウント作成
my $pass0 = time();
&ctrlcmd("\"useradd\"	\"$domain1\"	\"$l{ListName}\"	\"$pass0\"	\"M\"");
if (!-f "$mailroot/domains/$domain1/$l{ListName}/user.tab"){
	&log('f',$domain1,$user1,'?','admin','個人用リストアカウント作成に失敗',$0);
	&html("$l{ListName} は作成できませんでした。管理者までご連絡ください。",1);
}

# user.tabを更新(ClosedML)
$ClosedML = 1;
&saveenv('userm',$domain1,$l{ListName},'ClosedML');

# config.tabを保存
$MaxUser = $plmaxmember;
$MessageSize = $K4D[9];
$MessageSize = 10 if !$MessageSize;
$ListAdmin = $Owner = "$user1\@$domain1";
my $dir = "$mailroot/domains/$domain1/$l{ListName}/$xmailcfg";
mkdir("$dir",0755);
open(FILE,">$dir/config.tab");
	flock(FILE,2);
	foreach(@array1){print FILE "$_ = $$_\n";}
close(FILE);

# listadmin.tabを保存
my $file = "$mailroot/$listadmintab";
my $pldel = 1;
open(FILE,">>$file");
	flock(FILE,2);
	if (-z "$file"){
		my $str1 = "### リスト名 管理者 最大メンバ数 最大MSGサイズ Subjectタグ 添付削除 MsgID\n";
		my $str2 = "### ヘッダ/フッタ 受信拒否 リストプロセッサ 削除の許可 From:固定 ログ閲覧 書庫作成\n";
		Encode::_utf8_off($str1);
		Encode::_utf8_off($str2);
		Encode::from_to($str1,$charset,$charsetE);
		Encode::from_to($str2,$charset,$charsetE);
		print FILE $str1;
		print FILE $str2;
	}
	print FILE "$ml\t$user1\@$domain1\t$MaxUser\t$MessageSize\t$plstag\t$plattach\t";
	print FILE "$plmsgid\t$plheader\t$pldeny\t$plrobot\t$pldel\t$plffrom\n";
close(FILE);

# 開設の通知
#&noticemsg($ml,"開設");

# ロギング
&log('',$domain1,$user1,'?','run',"$ml を作成","-");

$l{'ListName'} = '';
&html("$ml を開設しました。");

## ------------------------------
sub html {
	&expire($_[0]) if ($Expired && !$_[1]);
	$msg = "<font color='#ff0000' size=4>$alert $_[0]$fe" if $_[0];
	($list,$count) = &check_ml;
	if ($count >= 10){$gotop = "<div align='right'>$arrowU</div>";}
	my $title = "MLの管理";
	
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "<html><head>$charcss</head>";
	
	$K4 = <<"EOF";
<body $bodyp class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4 $cbody0>
$table0
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><img src='$idir/letter.gif' width=34 height=24 title='$title' border=0></td>
<td nowrap>&nbsp;$fs7G<b>$title</b>$fe&nbsp; &nbsp;</td>
<td width='100%'>$msg</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#D0D0D0' colspan=3 height=1>$null</td></tr>
<tr><td height=12></td></tr>
</table>

$table1
<tr valign='top'><td>&nbsp;</td><td>
	$table1
	<tr><td height=4></td></tr>
	<tr valign='top'><td>
		<table cellpadding=1 cellspacing=0 border=0>
		<tr><td bgcolor='#ffb0b0'>
			<table cellpadding=6 cellspacing=0 class='doc131' border=0 width=130>
			<tr valign='top'><td $bgcolor1 height=100>
			個人用メーリングリストの作成と管理を行います。</td></tr>
			</table></td></tr>
		</table></td>
	<td width=15></td><td><br>
EOF

	if ($_[1] && $_[2] eq 'del'){&html2("$_[1]");}		# 削除の確認ページ
	
	if ($l{k4mklist} && $l{k4mklist} > $count){	# 開設メニュー表示
		if ($l{k4mklist} == 1){$tmp = " 1 個";}
		else {$tmp = "合計 $l{k4mklist} 個まで";}
		
		$K4 .= <<"EOF";
	<form method='post' action='$startcgi'>
	<input type='hidden' name='k4mklist' value="$l{'k4mklist'}">
	
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='MLの開設'> 
	$fs7 メーリングリストの新規開設 $fe
	$hr
	<li>個人用メーリングリストを $tmp 開設できます。</li>
	<li>リスト名には英数文字、ドット、ハイフン、アンダースコアが使えます。</li>
	<li>ドメインは \@$domain1 固定で、指定する必要はありません。</li>
	
		<table cellpadding=8 cellspacing=0 border=0 width='100%'>
		<tr><td height=8></td></tr>
		<tr><td $bgcolor0>
			$table1
			<tr><td>&nbsp; リスト名:&nbsp;</td>
			<td><input name='ListName' value="$l{ListName}" size=30 maxlength=30 $nosubmit></td></tr>
			<tr><td height=4></td></tr>
			<tr><td></td><td><input type='submit' value=' 作成する '></td></tr>
		</table></td></tr>
	</table>
</form>
EOF
	}
	
	if ($count){
		$K4 .= <<"EOF";
<br>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='MLの一覧'> 
$fs7 開設メーリングリスト一覧 $fe (開設数: $count)<br>

	<table cellpadding=2 cellspacing=0 class='doc131' border=0>
	<tr><td height=4></td></tr>
	<tr $bgcolor0><td nowrap>&nbsp;リストアドレス</td>
	<td nowrap>&nbsp;リスト説明</td>
	<td align='right' nowrap>&nbsp;メンバー数&nbsp;</td>
	<td nowrap>状態</td><td align='center' nowrap>&nbsp;削除</td></tr>
	<tr><td height=4>
	$list
	<tr><td height=2></td></tr>
	<tr><td colspan=5>
		<table cellpadding=0 cellspacing=0 border=0 width='100%'>
		<tr><td $bgcolor0 height=1>$null</td></tr>
		</table></td></tr>
	<tr><td height=6 width=260></td></tr>
	<tr><td colspan=4>
	<li>リストアドレスをクリックすれば管理ページが開きます。</li>
	$notice1
	</td></tr>
	</table></td></tr>
</table></td></tr>
</table>
$gotop
EOF
	}
	
	&print_utf($K4);
	&print_footer();
	exit;
}

sub html2 {		# 削除確認用
	&getLinfo("$_[0]");
	
	$K4 .= <<"EOF";
	<table class='doc131' width=450><tr><td></td></tr></table>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='MLの削除'> 
	$fs7 メーリングリストの削除 $fe
	$hr
	<dl>
	<dt>
	以下のメーリングリストを削除します。<br>
	削除すると、メンバー情報など関連情報もすべて削除されます。<br>
	削除したデータは復活できません。<br>
	<br>
EOF
	
	&print_utf($K4);
	&listadmin("$user1","$domain1","$_[0]");
	&printstat("$_[0]");

	$K4 = <<"EOF";
	<br>
	<p>
		<table>
		<tr><td><img src='$idir/i.gif' height=26 width=26 title='削除してよろしいですか？'></td>
		<td>$fs5R 本当に削除してよろしいですか？$fe</td></tr>
		</table>
	</p>
	<dd>
	$fs7
	<p>
	<img src='$idir/arrow_red.gif' width=31 height=13 title='削除しない'> 
	<a href='$startcgi?___'>削除せずトップメニューにもどる。</a>
	</p>
	
	<p>
	<img src='$idir/arrow_red.gif' width=31 height=13 title='削除を実行'> 
	<a href='$startcgi?del+$_[0]'>確認したので削除を実行する。</a>
	</p>
	$fe
	</dl>
	</table>
</table>
EOF
	&print_utf($K4);
	&print_footer();
	exit;
}

sub check_ml {
	my ($address,$count,$enable,$list,$tmp,$tmp1,$tmp2,$tmp3,@reg);
	
	# リスト一覧を得る
	&listadmin($user1,$domain1);
	
	# リストの情報を得る
	foreach $tmp (sort(@listadmin)){
		$enable=$link=$tmp1 = '';
		my @tmp = split(/\t/,$tmp);
		my ($name,$domain) = split(/\@/,$tmp[0]);
		my $base = "$mailroot/domains/$domain/$name";
		
		next if !-f "$base/user.tab";
		&getenv("$base/user.tab",'',1);
		$ReceiveEnable = 1 if $ReceiveEnable eq '';
		$tmp1 = $RealName;
		$enable = $ReceiveEnable;
		$tmp1 = '(なし)' if $tmp1 =~ /^[\s?]*$/;
		if (open(FILE,"$base/mlusers.tab")){
				@reg = <FILE>;
			close(FILE);
		}
		$tmp2 = @reg;
		1 while $tmp2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		if ($c){$bgc = $bgcolor2; $c = '';} else {$bgc = $bgcolor1; $c = 1;}
		$address = "<a href='$viewcgi?$tmp[0]'>$tmp[0]</a>";
		if ($enable){$enable = '有効';} else {$enable = '停止';}
		if ($domain =~ /^$domain1$/i && $tmp[10] && !$k4fixed){
			$link = "<a href='$startcgi?ifdel+$tmp[0]'>削除</a>";
		} else {$link = '&nbsp;--'; $notice1 = 1;}
		
		$list .= "<tr $bgc><td class='doc15'>&nbsp;$address</td>";
		$list .= "<td>$tmp1</td>";
		$list .= "<td align='right'>$tmp2&nbsp;</td>";
		$list .= "<td>$enable</td>";
		$list .= "<td>&nbsp;$link</td></tr>";
		$count++;
	}
	$notice1 = "<li>[削除] 項目が [--] のリストは管理者に削除権があります。</li>" if $notice1;
	return ($list,$count);
}

sub noticemsg {
	return() if ($postmaster !~ /^$emreg$/i || !$postmaster || !$plnotice);
	my ($ml,$type) = @_;
	
	$from = $postmaster;
	$subject = $ml ." が".$type."されました。";
	$to = $postmaster;
	@To = ($to);
	$message = <<"EOF";
$user1\@$domain1 さんが個人用メーリングリストを$typeしました。
-----------------------------------------------------------------
■日　　時	$year-$month-$mday $hour:$min
■リスト名	$ml
-----------------------------------------------------------------
$ENV{'HTTP_USER_AGENT'}
$ENV{'REMOTE_ADDR'}
EOF
	&startmail();
}
