#!C:/usr/perl/bin/perl.exe

## uK4 - 添付ファイル処理用
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use File::Find;
use utf8;
require "./config.cgi";
&auth();

&redirect() if !@ARGV;
$base = "$tempdir/$loginid";
$key4 = &dec_str($key4);
$key5 = &dec_str($key5);
($tempname,$realname,$size) = &getfilename($key4);

# [ファイルの管理]へコピー
if ($key5 eq 'filecopy'){
	my $myroot = "$fsroot/$domain1/$user1/FileRoot";
	my $size1 = $size;
	$size1 =~ s/\D//g;
	my $ext = $1 if $file =~ /\.([^.]+)$/;
	
	# コピー先ファイルIDを決定->コピー
	$fileid = time();
	for (1..100){
		$fileid++;
		last if !-f "$myroot/$fileid";
	}
	copy("$base/$tempname","$myroot/$fileid");
	my $line = join("\t",$fileid,$ext,$realname,$size1,$realname,"$user1\@$domain1",0,"$year/$month/$mday $hour:$min");
	Encode::_utf8_off($line);
	#Encode::from_to($line,$charset,$charsetE);
	open(FILE,">$myroot/$fileid.txt");
		print FILE "$line\t\n";
	close(FILE);
	unlink("$myroot/index.txt","$myroot/index_dir.txt");
	
	$perm = 1;
	$message = "<tr><td align='center'>$fs2<b>1</b>個のファイルを [ファイルの管理] にコピーしました。$fe</td></tr>";
}

$link = $link1 = $realname;
if ($realname =~ /\.(cgi|com|exe|html?|pl|shtml?|php\d?)$/i){$link = $tempname;}
elsif ($realname !~ /[^$zstr]/){copy("$base/$tempname","$base/$realname");}
else {$link = $tempname;}
$link =~ s/([^\w.])/'%'.unpack("H2", $&)/eg;

if (!-f $scanner){
	foreach my $ext (split(/[. \t]+/,$attachtag)){
		next if ($ext && $realname !~ /\.$ext$/);
		$caution = <<"EOF";
<p>$fs2 ■警 告 !!$fe<br>
このタイプのファイルにはウイルスやワームが潜んでいる可能性があります。安全が確認できない場合、
ブラウザのファイル保存メニューを利用してファイルをローカルディスク上に一時保存（ダウンロード）し、
その後にウイルススキャンプログラムを利用して検査を行うことをすすめます。</p>
EOF
	}
}

# ファイルの管理が許可されていれば
if (!$perm && $fsallow && $k4fsallow){
	# 利用状況を検査
	$mydir = "$fsroot/$domain1/$user1/FileRoot";
	$files = $size1 = '';
	find(sub {$size1 += -s if -f}, $mydir);
	$size1 = int($size1/1024);
	$size1 -= 100;
	foreach (glob("$mydir/*")){
		if (-d || /\d{10}.txt$/i){$files++;}
	}
	if ($size1 <= $k4fsspace && $files < $k4fsfiles){		# コピー許可
		my $str0 = &enc_str($key4);
		my $str1 = &enc_str('filecopy');
		my $confirm2 = " onClick=\"if(!confirm('このファイルをコピーしてもよろしいですか？')){return false;}\"";
		$fsservice = <<"EOF";
<p><font class='doc15' $colorG>■[ファイルの管理] エリアへコピー</font><br>
このファイルはメニュー [ファイルの管理] で管理することができます。
コピーを実行すると、このファイルのコピーが [ファイルの管理] フォルダ内に作成されます。
(左ボタンでクリックしてください)</p>
<p align='center'><a href='mailbox_download.cgi?$str0+$str1' $confirm2>コピーを実行 $arrowR</a></p>
EOF
	}
}

print "Content-Type: text/html; charset=$charset\n";
print "Pragma: no-cache\n\n";
print "<html><head>$charcss</head>";

$K4 = <<"EOF";
<body background='$idir/bgimg.gif' class='doc131' bgcolor='#ffffff'>
<table cellpadding=0 cellspacing=0 border=0 class='doc131' width='100%'>
$message
<tr><td>
<table cellpadding=0 cellspacing=0 border=1>
<tr><td bgcolor='#ffffff'>
	<table cellpadding=8 class='doc131'>
	<tr><td><p align='center'>以下のリンクをクリックしてファイルをダウンロードしてください。</p>
	<p align='center'><a href='mailbox_download2.cgi?$ARGV[0]+$ARGV[1]'>$fs7<b><u>&nbsp;$realname&nbsp;</u></b>$fe<br>
	( $size KB )</a></p>
	
	<p><font class='doc15' $colorG>■ダウンロードできない場合</font><br>
	ファイルを正常にダウンロードできない場合、以下のリンクを試してみてください。
	この場合、できるだけブラウザの $fs2 [対象をファイルに保存] $fe などのメニューを利用してください。</p>
	<p align='center'><a href="$base/$link">$fs5<b><u>&nbsp;$link1&nbsp;</u></b>$fe</a></p>
	$caution
	$fsservice
	</table></td></tr>
</table></td></tr>
<tr><td height=4></td></tr>
</table>
<div align='right'>
<a href="javascript:window.close()"><img src="$idir/close.gif" height=16 width=16 alt='' border=0>
<font $colorB> 閉じる</font></a>
</div>
</body>
</html>
EOF

&print_utf($K4);
exit;

sub getfilename {
	my ($file) = @_;
	my ($tempname,$realname);
	my @tmp;
	
	if (open(FILE,"$base/$file.tmp")){
			@tmp = <FILE>;
		close(FILE);
		my $tmp = shift (@tmp);
		chomp($tmp);
		$tmp = &dec_utf($tmp,$charset);
		($tempname,$realname) = split(/\t/,$tmp);
	}
	my $size = (stat("$base/$tempname"))[7];
	$size = int(($size+1023)/1024);
	1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	
	($tempname,$realname,$size);
}
