#!C:/usr/perl/bin/perl.exe

### uK4 - 下書き/ひな形メッセージ一覧の表示(key7がその区別)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./mailbox_common.cgi";

&expire() if $Expired;
if ($key7 eq $draftbox){@BOX = ($key7,$cgidraft,$box{$draftbox},);}
elsif ($key7 eq $templatebox){@BOX = ($key7,$cgidraft,$box{$templatebox},);}
($total,@reg) = &makelist($key7);
$nomsg = "<tr><td align='center' colspan=7 height=120>$BOX[2]はありません。</td></tr>" if !$total;

my ($st1,$st2);
if ($key5){$st1 = '昇順ソート'; $st2 = '新しい';}
else {$st1 = '降順ソート'; $st2 = '古い';}
if ($key8 == 5){$stype = '(サイズで'.$st1.')';}
elsif ($key8 == 4){$stype = '(更新日で'.$st1.')';}
elsif ($key8 == 3){$stype = '(作成日で'.$st1.')';}
elsif ($key8 == 1){$stype = '(送信先で'.$st1.')';}
elsif ($key8 == 0 && $key8 ne ''){$stype = '(用件で'.$st1.')';}
else {$stype = '('.$st2.'処理順に表示)';}

if ($total && $allowsearch){$opt1 = $BOX[2].'を検索';}
&do_header($BOX[2],'',$opt1);
my $key51 = $key5;
if ($key51){$key51 = 0;} else {$key51 = 1;}
$arg = "0+$key51";

if (@reg){
	$c = 0;
	foreach(@reg){
		chomp;
		$c++;
		($subject,$to,$from,$created,$updated,$fsize,$file,$tstamp) = split(/\t/,"$_");
		1 while $fsize =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		if ($c % 2){$bgc = $bgcolor1;} else {$bgc = $bgcolor3;}
		$page .= <<"EOF";
<tr $bgc><td><input type='checkbox' name='delx' value='$file'></td>
<td class='doc15'><a href='$cgidraftv?$key4+$key5+0+$key7+$key8+$c\_$total+$file'>$subject</a></td>
<td>$to</td>
<td>$created</td>
<td>$updated</td>
<td align='right'>$fsize&nbsp;</td></tr>
EOF
	}
	$current = $key4*$item+$c;
	if ($current % $item != 1){
		$current = $key4*$item+1 . '-' . "$current";
		$delmsg = "<a href='javascript:SetChecked(1)'>[すべて選択]</a> <a href='javascript:SetChecked(0)'>[すべて解除]</a>";
	}
	$current = "(表示: $current)";
	$delmsg = "<input type='submit' value='削除' title='選択したメッセージを削除します' $confirm1 $class> $delmsg";
	$notice = <<"EOF";
<li>項目タイトル([用件]や[送信先]など)をクリックするとその項目で昇順または降順のソートを行います。</li>
<li>個々の$BOX[2]の用件をクリックすると本文の閲覧・編集、メッセージ送信が可能です。</li>
EOF
	$notice .= "<li>$maxmsgfile 個を超えるメッセージがありますが超過分は表示できません。</li>" if $rest;
}

$gotop = "<div align='right'>$arrowU&nbsp;</div>" if $c >= 10;

$K4 = <<"EOF";
$table0
<form name='mList' method='post' action='$cgifile'>
<tr><td width='100%'>&nbsp;<b>$total</b> 件$current $stype</td>
<td align='right' nowrap></td></tr>
<tr><td colspan=2>
	<table cellpadding=1 cellspacing=0 class='doc121' border=0 width='100%'>
	<tr $bgcolor0><td $bgcolor4 width=1>
	<input type='hidden' name='key4' value='$key4'>
	<input type='hidden' name='key5' value='$key5'>
	<input type='hidden' name='key7' value='$BOX[0]'>
	<input type='hidden' name='key8' value='$key8'>
	<input type='hidden' name='op' value='del'>
	<input type='hidden' name='script' value='$cgidraft'></td>
	<td width='50%' nowrap><a href='$cgidraft?$arg+$key6+$BOX[0]+0'>&nbsp;用　件</a></td>
	<td nowrap><a href='$cgidraft?$arg+$key6+$BOX[0]+1'>送信先</a></td>
	<td nowrap><a href='$cgidraft?$arg+$key6+$BOX[0]+3'>作成日</a></td>
	<td nowrap><a href='$cgidraft?$arg+$key6+$BOX[0]+4'>更新日</a></td>
	<td align='right' nowrap><a href='$cgidraft?$arg+$key6+$BOX[0]+5'>サイズ&nbsp;</a></td></tr>
	<tr><td height=2></td></tr>
	$page$nomsg
	</table></td></tr>
<tr><td height=4></td></tr>
<tr valign='top'><td>$delmsg</td><td align='right'></td></tr>
<tr><td colspan=2>$hr</td></tr>
</table>

$table0
<tr><td class='doc13'><ul>$notice$gotop</ul></td></tr>
</table>
</form>
EOF

&print_utf($K4);
&print_footer();
&deltrash();
exit;

## ------------------------------------
sub makelist {
	my ($mbox) = @_;
	my $index  = "$userdir/temp/msg-$mbox.lst";
	local ($created,$updated,$to,$from,$subject,$start,$total,@reg);
	
	# インデックスがあれば得る
	if ((!$slogin || $k4fixed) && 
		(stat($index))[9] >= time() - $ttlmidx && open(FILE2,$index)){
			while (<FILE2>){
				$_ = &dec_utf($_,$charset);
				push(@reg,$_);
			}
		close(FILE2);
		if (@reg){
			$total = @reg;
			return($total,@reg);
		}
	}
	
	# 全メッセージを取得
	my @tmp = glob("$userdir/$mbox/*.*");
	
	# メッセージなし
	return(0) if !@tmp;
	
	@tmp = reverse(@tmp);
	# 総数が制限数を超えていれば超えた分を捨てる
	if ($maxmsgfile && @tmp > $maxmsgfile){
		splice(@tmp,0,$maxmsgfile) ;
		$rest = 1;
	}
	$total = @tmp;
	
	# メッセージ解析
	foreach my $file (@tmp){
		my $count = 0;
		$created=$updated=$to=$from=$subject='';
		open(FILE,$file) || next;
			while (<FILE>){
				$_ = &dec_utf($_);		# 文字コードは推定(上位互換)
				if ($count == 0 .. /^$/){
					chomp;
					s/^#+//;	# 上位互換
					s/\t+/: /;	# 上位互換
					my ($name,$value) = split(/: */,$_,2);
					if ($name =~ /(cc|from|subject|to)/i && $value =~ /$charset/i){
						$value  = decode("MIME-Header",encode($charset,$value));
					}
					$$name = $value;
					$count++;
				}
			}
		close(FILE);
		
		$subject = '(無題)' if !$subject;
		$subject .= "　　　　　\&nbsp;" if length($subject) < 10;
		my ($d,$fsize) = &parse_msg('',$file);
		
		if ($file =~ /[^\/]+$/){
			push(@reg,"$subject\t$to\t$from\t$created\t$updated\t$fsize\t$&\n");
		}
	}
	
	if (@reg && !$slogin){		# インデックスを作成
		my @reg2 = @reg;
		open(FILE,">$userdir/temp/msg-$BOX[0].lst");
			foreach (@reg2){
				Encode::_utf8_off($_);
				print FILE;
			}
		close(FILE);
	} else {
		unlink("$userdir/temp/msg-$BOX[0].lst");
	}
	
	# ソートする
	if ($key8 =~ /^[0-4]$/){@reg = &sorting($key8,0,0,@reg);}
	elsif ($key8 == 5){@reg = &sorting($key8,0,'num',@reg);}
	else {}
	if (!$key5){@reg = reverse(@reg);}
	
	# ページ処理は行わない
	($total,@reg);
}
