#!C:/usr/perl/bin/perl.exe

### uK4 - ビッグファイル送付
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Digest::MD5 'md5_hex';
use utf8;
require "./config.cgi";
require './mailbox_common.cgi';
$bigfilemax = 1 if $bigfilemax eq '';
$cgi = 'mailbox_upload2.cgi';
$directory = "../temp/$loginid/upload2";
$workdir = "../temp/$loginid/bigfile";
exit if (!$allowmail || !$allowbigfile);

### 初期表示またはアップ済みファイルの削除
if (@ARGV){
	($big,$op1,$op2) = @ARGV;
	%e = &getenv($bigfileflag,'=','',1,$charset);
	exit if $e{BigfileID} ne $big;
	my $profile = "$workdir/$big/profile.txt";
	my $msg;
	
	if (!$op1){
		mkdir($directory,0755);
		mkdir($tempdir,0755);
		mkdir($workdir,0755);
		foreach my $d ($directory,$tempdir,$workdir){
			foreach my $file ('index.htm','index.html','default.htm'){
				open(FILE,">$d/$file") && close(FILE);
			}
		}
		$Url = ${bigfileurl};
		$Url = $1 if (!$Url && $ENV{'HTTP_REFERER'} =~ /^(https?:\/\/.+?)mailbox_(new|reply)\.cgi/);
		$Message = "ダウンロードサイトのお知らせです。\n";
		$Message .= "以下のサイトにファイルをご用意しました。\n";
		$Message .= "    ${Url}download.cgi?$big\n";
		$Message .= "ログイン時のパスフレーズは以下のものをご利用ください。\n";
		$Message .= "    ##_pass_##\n";
		$step = 1;
	}
	
	## アップロード済みファイル削除
	if ($op1 eq 'delete' && $op2 && -s $profile){
		my @tmp;
		my %p = &getenv($profile,'=','',1,$charset);
		if (-s "$workdir/$big/$p{'File'.$op2.'ID'}"){
			$msg = "ファイル \"$p{'File'.$op2.'Name'}\" を削除しました。";
			open(FILE,"$profile");
				while (<FILE>){
					$_ = &dec_utf($_,$charset);
					chomp;
					if (/^File$op2/){
						s/=.*/=/;
						unlink("$workdir/$big/$p{'File'.$op2.'ID'}");
						next;
					}
					push(@tmp,"$_\n");
				}
			close(FILE);
			if (@tmp && open(FILE,">$profile")){
					print FILE @tmp;
				close(FILE);
			}
		}
		$step = 2;
	}
	
	&html($msg);
}

### ステップ1(基本設定)/ステップ2(ファイルをアップロード)
&parse_form();
while (($key,$val) = each %qArray){
	&redirect if $k4envstr =~ /,$key,/;
	&zenhan('val') if $val =~ /[^$zstr]/;
	$val =~ s/\s+/ /g if ($key ne 'Message' && $key ne 'HTMLMessage');
	$$key = $val;
}

%e = &getenv($bigfileflag,'=','',1,$charset);
my $dir = "$workdir/$e{BigfileID}";
my $profile = "$dir/profile.txt";

## ステップ1
if ($step == 1){
	&html("送付案内文を書いてください。") if $Message eq '';
	my ($sStr,$eStr,$today) = ("$sY0$sM0$sD0","$eY0$eM0$eD0","$year$month$mday");
	&html("開始日の指定が不完全です。") if ($sStr && (!$sY0 || !$sM0 || !$sD0));
	&html("終了日の指定が不完全です。") if ($eStr && (!$eY0 || !$eM0 || !$eD0));
	&html("開始日は終了日の前を指定してください。") if ($sStr && $eStr && $sStr >= $eStr);
	&html("終了日は本日以後を指定してください。") if ($eStr && $eStr < $today);
	if ($Auth){
		&html("認証する場合はパスフレーズを指定する必要があります。") if $PassPhrase eq '';
		&html("パスフレーズは <b>$bigfileauthstr</b> 文字以上で指定してください。") if length($PassPhrase) < $bigfileauthstr;
		&html("リトライ許可回数を指定する場合、数値で指定してください。") if $Retry =~ /\D/;
		&html("認証済みページの有効時間は数値で指定してください。") if $ExpireTime =~ /\D/;
		&html("認証済みページの有効時間は 600(秒) 以上で指定してください。") if ($ExpireTime && $ExpireTime < 600);
	} elsif ($Message =~ /#+_+pass(word)*_+#+/i){
		&html("認証しないサイトでは <b>$&</b> は不要です。関連部分を削除してください。");
	}
	&html("認証サイトの場合、送付案内文に <b>##_pass_##</b> 文字列を入れる必要があります。") if ($Auth && $Message !~ /#+_+pass(word)*_+#+/i);
	
	# データを保存
	mkdir($dir,0755);
	my ($html,$phrase) = ($HTMLMessage,$PassPhrase);
	$html =~ s/\n/\|\|/g;
	#Encode::_utf8_off($html);
	#Encode::_utf8_off($phrase);
	
	open(FILE,">$profile");
		print FILE <<"EOF";
Created = $year/$month/$mday $hour:$min:$sec
Owner = $user1\@$domain1
IP = $ENV{'REMOTE_ADDR'}
Referer = $ENV{'HTTP_REFERER'}
Start = $sStr
End = $eStr

BigfileID = $e{BigfileID}
BigfileURL = ${Url}download.cgi?$e{BigfileID}
Auth = $Auth
ExpireTime = $ExpireTime
PassPhrase = $phrase
Sensitive = $Sensitive
Retry = $Retry

RCPTName = $RCPTName
SenderName = $SenderName
HTMLMessage = $html

EOF
	close(FILE);
	open(FILE,">$dir/message.txt");
		print FILE $Message;
	close(FILE);
	
	$step = 2;
	&html();
}

## アップロード
elsif ($step == 2){
	&html("このアカウントではアップロードできません！") if $k4fixed;
	if ($nextStep){		# ステップ3へ
		$step = 3;
		&html();
	}
	my ($file,$tempfile) = ($qArray{file},$qFileTmp{file});
	local $fileName = $file;
	Encode::_utf8_on($fileName);
	$fileExt = $1 if $fileName =~ /\.([^.]+)$/;
	&html("アップロードするファイルを指定してください。") if !-s $tempfile;
	
	# 拡張子のチェック
	if ($bigfiletag){
		my @tag = split(/ +/,$bigfiletag);
		&html("拡張子 $fileExt のファイルはアップロードできません。") if grep(/^$fileExt$/i,@tag);
	}
	
	# サイズチェック
	my $size = -s $tempfile;
	$size = int(($size+(1023))/1024);		# KB単位
	if ($bigfilesize && $size > $bigfilesize){
		my ($size1,$size2) = ($bigfilesize,$size);
		1 while $size1 =~ s/(.*\d)(\d\d\d)/$1,$2/;
		1 while $size2 =~ s/(.*\d)(\d\d\d)/$1,$2/;
		&html("\"$fileName\" はサイズオーバーです。$size1(KB) 以内でアップロード可能です。");
	}
	
	# ウイルススキャン(NOD以外は役に立たない?)
	if (-s $scanner && $size < 100000){
		my $rep;
		my $upFile = time().".$fileExt";
		copy($tempfile,"$directory/$upFile");
		my ($scanok,@report) = &vscan("$directory/$upFile");
		if (
			(@report && grep(/[\/\\]$upFile[^.].*(Infection:|Infected|virus)/i,@report)) ||
			($scanner =~ /\\a2cmd(\.exe)*$/i && grep(/\sdetected: *.+/,@report)) ||
			($scanner =~ /\\nod32(\.exe)*$/i && grep(/\x83\x45\x83\x43\x83\x8B\x83\x58\x90\x94:[1-9]/,@report) 
				&& grep(/[\/\\]$upFile /,@report)) ||
			($scanner =~ /\\ecls(\.exe)*$/i && grep(/Infected: +files *- *[1-9]|\x8B\xBA\x88\xD0=".+/,@report)) ||
			($scanner =~ /\\vscanwin32(\.com)*$/i && grep(/\\$upFile /i,@report)) ||
			($scanner =~ /\\clamd?scan(\.exe)*$/i && grep(/$upFile:.+FOUND/,@report)) ||
			($scanner =~ /\\fsav(\.exe)*$/i && grep(/\\$upFile(\\.+)* +(\x8A\xB4\x90\xF5|Infection):/i,@report)) ||
			($scanner =~ /\\avgscanx(\.exe)*$/i && grep(/\x20\x82\xAA\x93\xC1\x92\xE8/,@report)) ||
			($scanner =~ /\\fpscan(\.exe)*$/i && grep(/\[Found .+?\] *<.+?>/,@report))
		){
			unlink($tempfile,"$directory/$upFile");
			$rep = "指定ファイルはウイルスに感染しています！";
		}
		&html($rep) if $rep;
	}
	
	# 格納ファイル名を得る
	my $str = "$user1\@$domain1". time() .$ENV{'REMOTE_ADDR'}.$ENV{'HTTP_REFERER'};
	my $myFile = md5_hex $str;
	
	# 格納ファイルID(1..$bigfilemax)を決定
	my $myID;
	if (-s $profile){
		my %p = &getenv($profile,'=','',1,$charset);
		for my $i (1 .. $bigfilemax){
			next if ($p{'File'.$i.'ID'} && -s "$dir/$p{'File'.$i.'ID'}");
			$myID = $i;
			last;
		}
	} else {
		$myID = 1;
	}
	&html("格納ID を決定できませんでした。") if $myID eq '';
	
	# ファイル情報を保存
	my $fName = $fileName;
	$fName = $Name if $Name;
	$str = 'File'.$myID;
	my $data = <<"EOF";
${str}ID = $myFile
${str}Name = $fName
${str}Ext = $fileExt
${str}Desc = $Desc
${str}Size = $size
${str}Limit = $Limit
EOF
	Encode::_utf8_off($data);
	open(FILE,">>$profile");
		print FILE $data;
	close(FILE);
	
	# ファイルを$workdir/$e{BigfileID}へ移動
	copy($tempfile,"$dir/$myFile");
	
	$Desc = $Name = $Limit = '';
	&html("\"$fileName\" をアップロードしました。");
}

## ファイルの準備を完了(元スクリプトへ戻る)
elsif ($step == 3){
	print "Location: $e{BackTo}?bigfile\n\n";
}

exit;

### ---------------------------------------
sub html {
	my ($msg1,$msg2) = @_;
	my $back = "<a href='$e{BackTo}?$e{BackArg}+suspend'>&nbsp;中止してもどる$arrowR&nbsp;</a>";
	my ($height,$str0,$str1,$str2) = (18,"未完了のまま他のページに移動すると処理はキャンセルされます。");
	if ($step == 1){
		$height = 20;
		$str2 = "ビッグファイル送付サイトを作成します。$str0";
	} elsif ($step == 2){
		$height = 24;
		my $files = "(最大 $bigfilemax 個)";
		$files = "(1個)" if !$bigfilemax;
		$str2 = "ビッグファイルを準備します$files。$str0";
	} elsif ($step == 3){
		$height=8;
	}
	if ($msg1){
		$str2 = "$alert $fs5R$msg1$fe";
		$str2 .= "<br>&nbsp;$msg2" if $msg2;
	}
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	$K4 = <<"EOD";
<html>
<head>
$charcss
<title>ビッグファイル送付</title>
</head>
<body $bodyp class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4>
$table0
<form action='$cgi' ENCTYPE='multipart/form-data' method='post'>
<input type='hidden' name='step' value='$step'>
<input type='hidden' name='Url' value="$Url">
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><img src='$idir/letter.gif' width=34 height=24 title='ビッグファイルを準備します'></td>
<td nowrap width='100%'>&nbsp;$fs7G<b>ビッグファイル送付</b>$fe</td><td nowrap>$back</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=3 height=1>$null</td></tr>
<tr><td height=2></td></tr>
<tr><td colspan=3 height=$height valign='top'>$str2</td></tr>
</table>
EOD
	
	## ステップ1 - 送付案内の編集・サイトの動作条件、ヘルプの表示
	if ($step == 1){
		&htmlconv('Message','PathPhrase','RCPTName','SenderName');
		my ($sY,$eY) = (&s_year($sY0),&s_year($eY0));
		my ($sM,$eM) = (&s_month($sM0),&s_month($eM0));
		my ($sD,$eD) = (&s_day($sD0),&s_day($eD0));
		my $confirm = " onClick=\"if(!confirm('次のステップに進みますか？')){return false;}\"";
		my $a1 = 'checked' if $Auth;
		my $a2 = 'checked' if $Sensitive;
		my $Str = "本サイトでは";
		if ($bigfilesize){
			1 while $bigfilesize =~ s/(.*\d)(\d\d\d)/$1,$2/;
			$Str .= "最大 <b>$bigfilesize</b>(KB) のファイルを";
		} else {
			$Str .= "任意のサイズのファイルを";
		}
		if ($bigfilemax == 1){$Str .= " <b>1</b> 個アップロードできます。";}
		else {$Str .= " <b>$bigfilemax</b>".'個までアップロードできます。';}
		
		$K4 .= <<"EOF";
<table border=0 cellpadding=0 cellspacing=0 class='doc131'>
<tr valign='top'><td>
	<table border=0 cellpadding=8 cellspacing=0 class='doc13'>
	<tr><td>${fs5G}[ステップ1] <b>送付案内の編集・サイトの動作条件</b>$fe</td></tr>
	<tr><td $bgcolor3>$buttonG 送付案内文の作成・編集(通知メッセージに挿入します)$fs2(必須)$fe<br>
	<textarea name='Message' cols=81 rows=7 wrap='off'>$Message</textarea></td></tr>
	<tr><td $bgcolor3>$buttonG ダウンロードサイトの有効期限<br>
	<select name='sY0'>$sY</select>年 
	<select name='sM0'>$sM</select>月 
	<select name='sD0'>$sD</select>日 ～ 
	<select name='eY0'>$eY</select>年 
	<select name='eM0'>$eM</select>月 
	<select name='eD0'>$eD</select>日</td></tr>
	<tr><td $bgcolor3>$buttonG セキュリティ<br>
	<input type='checkbox' name='Auth' $a1 value='1'> ダウンローサイトへのアクセスはパスフレーズによる認証が必要<br>
	<input type='checkbox' name='Sensitive' $a2 value='1'> 以下のパスフレーズは大文字・小文字を区別<br>
	<input name='PassPhrase' size=45 value="$PassPhrase" $nosubmit> ($bigfileauthstr 文字以上、空白文字・全角文字OK)<br>
	<input name='Retry' size=10 maxlength=3 value="$Retry" $nosubmit> (認証失敗時のリトライ許可回数)<br>
	<input name='ExpireTime' size=10 maxlength=9 value="$ExpireTime" $nosubmit> (認証済みページの有効時間、秒単位、1日=86400秒、1週間=604800秒)</td></tr>
	<tr><td $bgcolor3>$buttonG あて先名 / 送付元名(ダウンロードサイトで表示)<br>
	<input name='RCPTName' size=45 value="$RCPTName" $nosubmit>(あて先名)<br>
	<input name='SenderName' size=45 value="$SenderName" $nosubmit>(送付元名)</td></tr>
	<tr><td $bgcolor3>$buttonG 連絡メッセージの作成・編集(ダウンロードサイトで表示)<br>
	<textarea name='HTMLMessage' cols=81 rows=7 wrap='off'>$HTMLMessage</textarea></td></tr>
	<tr><td align='right'><input type='submit' value='次のステップ(ファイルのアップロード)へ進む &raquo;' $confirm></td></tr>
	</table></td>
<td nowrap>&nbsp;</td>
<td>
<table border=1 cellpadding=6 cellspacing=0>
<tr><td>
	<table border=0 cellpadding=2 cellspacing=0 class='doc13'>
	<tr><td>$fs5&lt;<b>ビッグファイル送付機能について</b>&gt;</td></tr>
	<tr><td>E-mail に添付できないほど大きいファイルをウェブサイトを介して相手に届けるのがビッグファイル送付機能です。</td></tr>
	<tr><td><ol>
	<li>送付するファイルを本ページからサーバにアップロードします。$Str</li>
	<li>これにより該当ファイルが以下のリンクからダウンロードできるようになります。<br>
	&nbsp; <span class='doc111'>${Url}download.cgi?$e{BigfileID}</span></li>
	<li>このリンクを通知メッセージ内に挿入して相手に送信します。</li>
	<li>相手はリンク先へアクセスしてファイルをダウンロードします。</li>
	</ol></td></tr>
	<tr><td>$fs5&lt;<b>設定のヒント</b>&gt;</td></tr>
	<tr><td><ul>
	<li>[送付案内文の作成・編集] は、ここで指定する内容が通知メッセージに挿入されて送信されます。必ず入力してください。<br>
	[セキュリティ] で認証を必要にした場合、この案内文の中には必ず $fs2<b>##_pass_##</b>$fe という文字列を入れる必要があります。
	<b>##_pass_##</b> は通知メッセージへの案内文の挿入時に実際のパスフレーズに置換されます。</li>
	<li>${fs2}ダウンロードサイト URL の download.cgi\? に続く 32 文字はサイトを識別するために必須です。削除・変更しないでください。$fe</li>
	<li>[ダウンロードの有効期限] は、有効期限が必要でない場合は何も指定しないでください。
	指定をすると、期間外のアクセスが拒否されます。</li>
	<li>[セキュリティ] は、ダウンロードサイトへのアクセスで認証を必要にする場合に適切な設定を行います。<br>
	"<b>認証失敗時のリトライ回数</b>" を指定すると、認証に指定回数失敗した場合はログインフォームの表示を一時停止し、サイトへの再アクセスの案内を表示します。<br>
	"<b>認証済みページの有効時間</b>" を指定すると、1回の認証でダウンロードサイトを利用できる時間(秒数)を制限できます。
	制限した場合、指定時間が過ぎると改めてダウンロードサイトへの認証ログインを強制します。有効時間を指定しない場合、制限を行いません。</li>
	<li>[あて先/送付元名] は、もし指定すればダウンロードサイトが誰のために用意されたのか、誰が用意したのかをサイト内に表示します。
	あて先が組織名や個人名である場合、「様」までつけた方がよい場合があります。
	HTML タグは使用できません。</li>
	<li>[連絡メッセージの作成・編集] は、ダウンロードサイトに追加コメントを表示したい場合に任意の内容で入力してください。
	HTML タグは使用できません。フォーム内の改行がそのままコメントの改行になります。</li>
	</ul></td></tr>
	</table></td></tr>
</table></td></tr>
EOF
	}
	
	## ステップ2 - ビッグファイルの登録・アップロード
	elsif ($step == 2){
		#my $confirm = "onClick=\"if(!confirm('最終確認ステップへ進みますか？')){return false;}\"";
		my $complete = "<input type='submit' name='nextStep' value='最終確認ステップへ進む &raquo;'>";
		&htmlconv('Desc','Name');
		my ($count,$size,@files) = &get_files;
		$K4 .= "<div id='K4'>";
		$K4 .= "<table border= 0cellpadding=4 cellspacing=0 class='doc131' border=0 width='100%'>";
		$K4 .= "<tr><td>${fs5G}[ステップ2] <b>ファイルをアップロード</b>$fe</td></tr>";
		$K4 .= "<tr><td bgcolor='#c0c0c0' height=1></td></tr>";
		$K4 .= "<tr><td height=4></td></tr>";
		
		if ($count >= $bigfilemax){
			$K4 .= "<tr><td align='center'><table class='doc15'>";
			$K4 .= "<tr><td align='center'><p><br>$fs2".'ファイル登録が制限数に達しました。最後のステップへ進んでください。'."$fe</p>";
			$K4 .= "$complete</p></td></tr>";
			$K4 .= "<tr><td height=10></td></tr>";
			$K4 .= "</table></td></tr>";
		} else {
			my $confirm1 = "onClick=\"if(!confirm('指定ファイルをアップロードしますか？')){return false;}\"";
			if ($bigfilesize){
				my $size = $bigfilesize;
				1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
				$str1 = "<li>$fs2$size(KB)".' を超えるサイズのファイルはアップロードできません。'."$fe</li>";
			}
			my $nextStep;
			if ($count){
				$nextStep = "<div align='right'>";
				$nextStep .= "<span class='doc15'>$fs2<b>".'アップロードを完了する場合は下のボタンを押してください。'."</b>$fe</span><br>";
				$nextStep .= $complete;
				$nextStep .= "</div>";
			}
			
			$K4 .= <<"EOF";
<tr $bgcolor0><td>&nbsp;■関連情報を指定し、ファイルを登録(アップロード)してください。</td></tr>
<tr><td height=2></td></tr>
<tr><td>
	<table border=0 cellpadding=4 cellspacing=0 class='doc131'>
	<tr><td $bgcolor3>$buttonG ファイルを指定<br>
	<input type='file' $class size=35 name='file'></td>
	<td class='doc13' rowspan=5 valign='top'><ul>
	$str1
	<li>[ファイルの表示名] を指定すると、ダウンロードサイトにおいて該当ファイルの名前を指定名で表示します。
	何も指定しない場合、オリジナル名を表示します。</li>
	<li>[ファイルの説明] を指定すると、ダウンロードサイトにおいて該当ファイルの追加説明を表示します。</li>
	<li>[ダウンロード回数] を指定すると、該当ファイルは指定回数を超えてダウンロードすることができなくなります。</li>
	</ul>
	$nextStep
	</td></tr>
	<tr><td $bgcolor3>$buttonG ダウンロードページでのこのファイルの表示名を指定してください。<br>
	<input name='Name' size=81 $nosubmit value="$Name"></td></tr>
	<tr><td $bgcolor3>$buttonG 必要ならこのファイルの説明を入力してください。<br>
	<input name='Desc' size=81 $nosubmit value="$Desc"></td></tr>
	<tr><td $bgcolor3>$buttonG このファイルのダウンロード回数を制限しますか?<br>
	<input name='Limit' size=5 $nosubmit value="$Limit">回に制限</td></tr>
	<tr><td align='right'><input type='submit' value='指定ファイルの登録を実行' onclick='WaitDisplay()'></td></tr>
</table></td></tr>
<tr><td height=10></td></tr>
</table>
EOF
		}
		
		1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
		$K4 .= "<table cellpadding=1 cellspacing=1 class='doc131' border=0 width='100%'>";
		$K4 .= "<tr $bgcolor0><td colspan=5>&nbsp;■登録済みファイルの一覧 (合計l: $size KB)</td></tr>";
		if (!$count){
			$K4 .= "<tr><td align='center' colspan=5 height=40>(ファイルは登録されていません)</td></tr>";
		} else {
			my $c = 0;
			my $confirm3 = "onClick=\"if(!confirm('このファイルを削除してもよろしいですか？')){return false;}\"";
			foreach my $file (@files){
				my ($fid1,$fid2,$name,$ext,$desc,$size,$limit) = split(/\t/,$file);
				if ($c%2){$bgc = $bgcolor2;} else {$bgc = $bgcolor1;}
				$limie .= '(回)' if $limit;
				$K4 .= "<tr $bgc valign='top'><td>&nbsp;$name</td><td>$desc</td><td align='right'>$size(KB) &nbsp;</td><td>$limit</td>";
				$K4 .= "<td align='center'><a href='$cgi?$e{BigfileID}+delete+$fid1' $confirm3>削除</td></tr>";
				$c++;
			}
		}
		$K4 .= "<tr><td bgcolor='#c0c0c0' colspan=5 height=1></td></tr>";
		$K4 .= "</table>";
		$K4 .= "</div>";
		$K4 .= &print_waitmsg('しばらくお待ちください...','ファイルをアップロードしています...');
	}
	
	# ステップ3 - 最終確認
	elsif ($step == 3){
		#my $confirm = "onClick=\"if(!confirm('メッセージ作成ページへもどります。よろしいですか？')){return false;}\"";
		my %p = &getenv("$workdir/$e{BigfileID}/profile.txt",'=','',1,$charset);
		my $message;
		if (open(FILE,"$workdir/$e{BigfileID}/message.txt")){
				while (<FILE>){
					$_ = &dec_utf($_,$charset);
					$message .= $_;
				}
			close(FILE);
		}
		$message =~ s/</&lt;/g;
		$message =~ s/>/&gt;/g;
		$message =~ s/"/&quot;/g;
		$message =~ s/\n/<br>/g;
		my $str = " (大文字・小文字を区別) " if $p{Sensitive};
		$message =~ s/#+_+pass(word)*_+#+/$p{PassPhrase}$str/gi;
		
		$K4 .= <<"EOF";
<table border=0 cellpadding=4 cellspacing=0 class='doc131'>
<tr valign='top'><td>
	<table border=0 cellpadding=1 cellspacing=0 class='doc13'>
	<tr><td>${fs5G}[ステップ3] <b>最終確認</b>$fe</td></tr>
	<tr><td bgcolor='#c0c0c0' height=1></td></tr>
	<tr><td height=8></td></tr>
	<tr><td>${fs2}以下の内容でビッグファイル送付の準備ができました。$fe<br>
	以下の [送付案内文] はメッセージ作成ステップで引用・挿入されます。<br>
	この内容でよければメッセージ作成ステップへもどり、送付通知メッセージを送信してください。</td></tr>
	<tr><td height=8></td></tr>
	<tr><td $bgcolor3>
		<table cellpadding=2 cellspacing=0 class='doc131' border=0>
EOF
		$K4 .= "<tr><td>有効期限</td><td>";
		if (!$p{Start} && !$p{End}){
			$K4 .= "期間の制限なし";
		} else {
			$K4 .= "$1/$2/$3 に開始" if $p{Start} =~ /(\d{4})(\d{2})(\d{2})/;
			$K4 .= " ～ " if $p{End};
			$K4 .= "$1/$2/$3 に終了" if $p{End} =~ /(\d{4})(\d{2})(\d{2})/;
		}
		$K4 .= "</td></tr>";
		$K4 .= "<tr><td valign='top' nowrap>サイトへのアクセス &nbsp;</td><td>";
		if ($p{Auth}){
			$K4 .= "認証が必要 (パスフレーズ: $p{PassPhrase})";
			$K4 .= "(大文字・小文字を区別)<br>" if $p{Sensitive};
		} else {
			$K4 .= "認証不要</td></tr>";
		}
		$K4 .= "<tr><td valign='top'>送付するファイル</td><td>";
		for (1 .. $bigfilemax){
			my $str = 'File'.$_;
			my ($name,$size,$desc,$limit) = ($p{$str.'Name'},$p{$str.'Size'},$p{$str.'Desc'},$p{$str.'Limit'});
			next if $name eq '';
			1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
			$K4 .= "$name (${size}KB)";
			$K4 .= "($desc)" if $desc;
			$K4 .= "(制限回数: $limit)" if $limit;
			$K4 .= "<br>";
		}
		$K4 .= "</td></tr>";
		my ($rcpt,$sender) = ($p{RCPTName},$p{SenderName});
		$rcpt = '-' if !$rcpt;
		$sender = '-' if !$sender;
		$K4 .= "<tr><td>あて先の名前</td><td>$rcpt</td></tr>";
		$K4 .= "<tr><td>送付元の名前</td><td>$sender</td></tr>";
		$K4 .= "<tr><td valign='top'>送付案内文</td><td bgcolor='#ffffe0'>$message</td></tr>";
		if ($p{HTMLMessage}){
			my $html = $p{HTMLMessage};
			$html =~ s/</&lt;/g;
			$html =~ s/>/&gt;/g;
			$html =~ s/"/&quot;/g;
			$html =~ s/\|+/<br>/g;
			$K4 .= "<tr><td valign='top' nowrap>連絡メッセージ &nbsp;</td><td>$html</td></tr>";
		}
		
		$K4 .= <<"EOF";
		</table></td></tr>
	<tr><td height=4></td></tr>
	<tr><td align='right'><input type='submit' value='メッセージ作成ステップへもどって続行 &raquo;'></td></tr>
	</table></td></tr>
</table>
EOF
	}
	
	&print_utf($K4,'',1);
	
	## 残骸ファイル削除
	foreach (glob("$tempdir/*")){unlink($_);}
	
	exit;
}

## 送付ファイル情報を得る
sub get_files {
	my ($count,$size,@files) = (0,0);
	my %p = &getenv("$workdir/$e{BigfileID}/profile.txt",'=','',1,$charset);
	
	for my $i (1 .. $bigfilemax){
		my $str = 'File'.$i;
		next if ($p{$str.'ID'} eq '' || !-f "$workdir/$e{BigfileID}/$p{$str.'ID'}");
		my $size0 = $p{$str.'Size'};
		$size += $size0;
		1 while $size0 =~ s/(.*\d)(\d\d\d)/$1,$2/;
		# 0ファイルID 1格納名 2オリジナル名 3拡張子 4説明 5サイズ 6ダウンロード許可回数
		push(@files,"$i\t$p{$str.'ID'}\t$p{$str.'Name'}\t$p{$str.'Ext'}\t$p{$str.'Desc'}\t$size0\t$p{$str.'Limit'}");
		$count++;
	}
	
	# オリジナル名でソート
	@files = &sorting(2,0,0,@files);
	
	($count,$size,@files);
}
