;### uK4 - アーカイブ閲読共通
;# key4:開始ページ、key5:ソート方法、key6:管理者フラグ、key7:リストアドレス、
;# key8:ソートキー、key9:前へ/次へフラグ、key10:MSGファイル
use utf8;
$startcgi = 'mlist_start.cgi';	# トップページ用
$filecgi = 'mlist_file.cgi';	# ファイル操作用
$listcgi = 'mlist_list.cgi';	# メッセージリスト表示用
$printcgi = 'mlist_print.cgi';	# 印刷用
$searchcgi = 'mlist_search.cgi';	# 検索用
$viewcgi = 'mlist_view.cgi';	# メッセージ内容表示用
$cginew = 'mailbox_new.cgi';	# メッセージ送信用
$item = 20;
$textstyle = "style='font-size:14px;line-height:$linespace'";
&auth();

## メニューを表示
sub do_header1 {
	my ($title,$op1) = @_;
	
	if ($op1 eq 'search'){
		$op1 = <<"EOF";
<table cellpadding=0 cellspacing=0 class='doc131' border=0 align='right'>
<tr><td><form method='post' action='$searchcgi'></td>
<td nowrap>
<input type='hidden' name='key4' value='0'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='$key6'>
<input type='hidden' name='key7' value='$key7'>
<input type='hidden' name='key8' value='$key8'>
<input type='hidden' name='f1' value='subject'>
<input type='hidden' name='f2' value='from'>
<input type='hidden' name='f3' value='message'>アーカイブを検索 
<input name='keyword' size=20 maxlength=50>
<input type='submit' value='検索'></td>
<td></form></td></tr>
</table>
EOF
	} elsif ($op1){
		$op1 = "<table><tr><td nowrap>&nbsp;$alert</td><td nowrap>$fs5R $op1$fe</table>";
	}
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	print "<html><head>$charcss<script type='text/javascript'><!--\nfunction SetChecked(val){";
	print "dml=document.mList;len=dml.elements.length;var i=0;for(i=0;i<len;i++){";
	print "if(dml.elements[i].name=='del'){dml.elements[i].checked=val;}}}//--></script></head>";
	
	my $title1 = "アーカイブ閲読 - $key7";
	my $K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4 $cbody0>
$table0
<tr><td height=1><a name='top'>$null</a>
<tr valign='bottom'><td><a href='$startcgi?0+1'>
<img src='$idir/letter.gif' width=34 height=24 title='$title1' border=0></a></td>
<td nowrap>&nbsp;$fs7G<b>$title</b>$fe&nbsp;&nbsp;</td>
<td width='100%'>$op1</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=3 height=1>$null</td></tr>
<tr><td height=12></td></tr>
</table>
EOF
	
	&print_utf($K4);
}

## リスト情報を得る
sub getMListInfo {
	my($tmp) = @_;
	my ($list,$domain) = split(/@/,$tmp);
	&getenv("$mailroot/domains/$domain/$list/user.tab",'','1');	# RealNameを得る
	if ($RealName =~ /^[\s?]*$/){$RealName = $tmp;}
	$RealName;
}

## アーカイブリストを作成
sub make_msglist {
	my ($cgi) = @_;
	my ($current,$page);
	my $c = 0;
	my $tmp = '+search' if $cgi eq $searchcgi;
	if ($key6 && !$k4fixed){
		$delmsg = <<"EOF";
<input type='submit' value='管理者削除' title='選択したメッセージを削除します' $confirm1> 
<a href='javascript:SetChecked(1)'>[すべて選択]</a> 
<a href='javascript:SetChecked(0)'>[すべて解除]</a>
EOF
		$ifadmin = <<"EOF";
<form name='mList' method='post' action='$filecgi'>
<input type='hidden' name='key4' value='$key4'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='$key6'>
<input type='hidden' name='key7' value='$key7'>
<input type='hidden' name='key8' value='$key8'>
<input type='hidden' name='script' value='$cgi'>
EOF
		$refresh = "&nbsp;<a href='$listcgi?0+$key5+$key6+$key7+$key8+delete'>最新情報に更新$arrowR</a>";
	}
	foreach(@reg){
		chomp;
		$c++;
		my ($bgc,$del);
		my ($subject,$sender,$rcpt,$date,$file,$fsize,$attach,$tstamp) = split(/\t/,$_);
		1 while $fsize =~ s/(.*\d)(\d\d\d)/$1,$2/g;
		if ($c % 2){$bgc = $bgcolor1;} else {$bgc = $bgcolor2;}
		if ($key6 && !$k4fixed){$del = "<input type='checkbox' name='del' value='$file'>";}
		$page .= <<"EOF";
<tr $bgc><td>$del</td><td>$attach</td>
<td class='doc15'><a href='$viewcgi?$key4+$key5+$key6+$key7+$key8+$c\_$total+$file$tmp'>$subject</a></td>
<td>$sender</td>
<td>$date</td>
<td align='right'>$fsize&nbsp;</td></tr>
EOF
	}
	$current = $key4*$item+$c;
	if ($current % $item != 1){$current = $key4*$item+1 . '-' . "$current";}
	$current = "(表示:$current)";
	
	my $gotop = "<div align='right'>$arrowU</div>" if $c >= 10;
	return ($page,$current,$gotop);
}

## メッセージ内容取得
sub view_msg1 {
	my ($file,$list,$op0) = @_;
	my ($x,$y) = split(/@/,$list);
	my $base = "$mailroot/domains/$y/$x";
	
	if ($key9 =~ /_$/){
		if (open(MyFILE5,"$base/temp/msg-$list.lst")){
				@tmp1 = <MyFILE5>;	# <前へ/次へ> からメッセージ表示の場合は
			close(MyFILE5);			# インデックスからMSGファイル名を得る
			# ソート
			if ($key8 == 4){@tmp1 = &sorting($key8,0,'num',@tmp1);}
			elsif ($key8 =~ /^[0-3]$/ && $key8 ne ''){@tmp1 = &sorting($key8,0,0,@tmp1);}
			else {}
			if (!$key5){@tmp1 = reverse(@tmp1);}
			
			my ($tmp2,$tmp3) = split(/_/,$key9);
			$tmp2 = $item*$key4 + $tmp2 - 1;
			$tmp1 = $tmp1[$tmp2];
			chomp($tmp1);
			@tmp1 = split(/\t/,$tmp1);
			$key10 = $file = $tmp1[4];
		}
	}
	
	&view_msg("mlist","$base/logs/$file",$op0);
}

1;
