;# .cgiファイルの第1行（perlへのパスを定義）を
;# このコンピュータの環境に合わせます。
use Encode qw/encode decode from_to/;
use utf8;
($euc,$sjis,$utf) = ('EUC-JP','Shift_JIS','UTF-8');
$OS = $^O;
$OS = '' if $OS =~ /MSWin/;

exit if ($ENV{'SERVER_SOFTWARE'} || $ENV{'REMOTE_ADDR'});
$cgipath = '../cgi';	# スクリプトの場所

if ($OS){
	$perlpath = `which perl`;
} else {
	foreach (split(/;+/,"$ENV{'PATH'}")){
		s/[\\\/]+$//g;
		if (-f "$_\\perl.exe"){
			$perlpath = "$_\\perl.exe";
			last;
		}
	}
}

if (!$perlpath){
	$error = "\n【エラー】\n";
	$error .= "perl へのパスが見つかりません。\n";
	$error .= "perl が正しくインストールされていない可能性があります。\n";
	Encode::_utf8_off($error);
	if ($OS){
		Encode::from_to($error,$utf,$euc);
	} else {
		Encode::from_to($error,$utf,$sjis);
	}
	print $error;
	exit;
}
$perlpath =~ s/\\/\//g;

opendir(DATA,"$cgipath");
	@list = grep(/\.cgi/i, readdir(DATA));
closedir(DATA);

foreach my $file (@list){
	$chk = $str = '';
	@reg = ();
	if ($file =~ /^(_.*|calendar\.|config\.|expired\.|help_.*|update\.|.*?_common\.)/){
		$str = "$file は処理の必要がありません。";
		Encode::_utf8_off($str);
		if ($OS){
			Encode::from_to($str,$utf,$euc);
		} else {
			Encode::from_to($str,$utf,$sjis);
		}
		print "$str\n";
		$c2++;
		next;
	}
	open(FILE,"$cgipath/$file");
		while (<FILE>){
			$_ = decode($utf,$_);
			push(@reg,$_);
		}
	close(FILE);
	if ($reg[0] =~ /^#!$perlpath$/i){
		$str = "$file は処理の必要がありません。";
		Encode::_utf8_off($str);
		if ($OS){
			Encode::from_to($str,$utf,$euc);
		} else {
			Encode::from_to($str,$utf,$sjis);
		}
		print "$str\n";
		$c2++;
		next;
	}
	open(FILE,">$cgipath/$file");
		flock(FILE,2);
		foreach my $line (@reg){
			if ($line =~ /^\#!/ && !$chk){
				$line = "#!$perlpath\n";
				$chk = "yes";
				$c1++;
			}
			Encode::_utf8_off($line);
			print FILE "$line";
		}
	close(FILE);
	$files .= "$file\n";
}

($str1,$str2) = ("\n以下の $c1 個のファイルを処理しました","$c2 個のファイルは処理の必要がありませんでした。");
Encode::_utf8_off($str1);
Encode::_utf8_off($str2);
if ($OS){
	Encode::from_to($str1,$utf,$euc);
	Encode::from_to($str2,$utf,$euc);
} else {
	Encode::from_to($str1,$utf,$sjis);
	Encode::from_to($str2,$utf,$sjis);
}
print "\n$str1\n" if $c1;
print "$files\n" if $files;
print "$str2\n" if $c2;
exit;
