#!C:/usr/perl/bin/perl.exe

### uK4 - アンチ・スパム - 条件検索
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require './config.cgi';
$cgi = 'antispam3.cgi';
$cgi2 = 'antispam2.cgi';
$cgi3 = 'antispam4.cgi';
$title = 'アンチ・スパム - 条件検索';
$confirm = "onClick=\"if(!confirm('このルールを登録しますか？')){return false;}\"";
@array = qw(rule header word method regexp);
%method = (
	0,'で始まる',
	1,'を含む',
	2,'である',
	3,'で終る',
	4,'で始まらない',
	5,'を含まない',
	6,'でない',
	7,'で終らない'
);
&auth();
$tab = "$userdir/$xmailcfg/spamwords-def.tab";

### 初期表示/ルールの削除・移動
if (@ARGV){
	&getenv("$userdir/$xmailcfg/config.tab",'=',1);
	if (!$k4allowantispam || !$allowantispam){
		&log('r',$domain1,$user1,'?','run','不正実行',$0);
		&redirect();
	}
	
	# ルールを削除
	my ($op,$count,$msg) = @ARGV;
	if ($op eq 'del'){
		my ($chk,$count2);
		my @reg;
		if (open(FILE,$tab)){
			while (<FILE>){
				$count2++;
				chomp;
				if ($count == $count2){
					$chk = 1;
					next;
				}
				push(@reg,"$_\n");
			}
			close(FILE);
			
			if ($chk && open(FILE,">$tab")){
					flock(FILE,2);
					print FILE @reg;
				close(FILE);
				$msg = "指定ルールを削除しました。";
			}
		}
	}
	
	# ルールの優先順位を上位/下位に
	elsif ($op eq 'down' || $op eq 'up'){
		my ($chk,$count2);
		my @tmp1;
		my @tmp2;
		if (open(FILE,$tab)){
			while (<FILE>){
				$count2++;
				chomp;
				if ($count == $count2){
					$chk = "$_\n";
					next;
				}
				if (!$chk){push(@tmp1,"$_\n");}		# 指定行より前のデータ
				else {push(@tmp2,"$_\n");}			# 指定行より後のデータ
			}
			close(FILE);
			
			if ($op eq 'down'){
				my $line = shift(@tmp2);
				unshift(@tmp2,$chk);
				push(@tmp1,$line);
			} else {
				my $line = pop(@tmp1);
				push(@tmp1,$chk);
				unshift(@tmp2,$line);
			}
			if ($chk && open(FILE,">$tab")){
					flock(FILE,2);
					if (@tmp1){print FILE @tmp1;}
					if (@tmp2){print FILE @tmp2;}
				close(FILE);
				$msg = "指定ルールを移動しました。";
			}
		}
	}
	
	&html($msg);
}

## フォーム入力を処理
&parse_form(@array);
&html("このアカウントでは保存できません！",1) if $k4fixed;

# エラーチェック(正規表現チェックなど)
&html("ルール名を指定してください。") if !$rule;
&html("検索対象フィールドを選択してください。") if !$header;
&html("キーワードを指定してください。") if !$word;
if ($regexp && &chk_regexp($word)){&html("キーワードの正規表現が正しくありません。");}

# 重複チェック
my $word1 = $word;
$word1 =~ s/\s+//g;
($word1) = &mod_str($word1);
my $line = join("\t",$header,$word1,$method,$regexp);
($line) = &mod_str($line);
if (open(FILE,"$cfg{'mailroot'}\\$tab")){
		while (<FILE>){
			chomp;
			next if (/^\s*$/ || /^#/);
			$_ = &dec_utf($_,$charsetE);
			&html("同じ内容の登録があります。") if /\t$line$/;
			my @tmp = split(/\t/,$_);
			my ($str) = &mod_str($tmp[0]);
			&html("既存のルール名は指定できません。") if $rule =~ /^$str$/i;
		}
	close(FILE);
}

# ルール追加
$method = 0 if $method eq '';
$regexp = 0 if $regexp eq '';
$line = join("\t",$rule,$header,$word,$method,$regexp);
Encode::_utf8_off($line);
Encode::from_to($line,$charset,$charsetE);
open(FILE,">>$tab");
	flock(FILE,2);
	print FILE "$line\n";
close(FILE);

# 完了
&html("1個のルールを追加しました。");

## ページを表示 --------------------------------
sub html {
	my ($emsg) = @_;
	$emsg = "$alert $fs5R $emsg $fe" if $emsg;
	if ($Expired && !$_[1]){&expire($_[0]);}
	&htmlconv(qw());
	my $na = $nofilter if -f "$tempdir/$nf";
	my $methods;
	foreach (sort {$a <=> $b} keys %method){$methods .= "<option value='$_'>$method{$_}</option>\n";}
	
	print "Content-Type: text/html; charset=$charset\n";
	print "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
	print "<html><head>$charcss</head>";
	
	$K4 = <<"EOF";
<body bgcolor='#ffffff' class='doc13' topmargin=10 leftmargin=4 marginheight=10 marginwidth=4 $cbody0>
<form method='post' action='$cgi'>
$table0
<tr><td>
	$table1
	<tr><td><img src='$idir/antispam.gif' width=30 height=30 title='$title'></td>
	<td nowrap valign='bottom'>&nbsp;$fs7<b>$title</b>$fe &nbsp;$na $emsg</td></tr>
	</table></td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#C0C0C0' colspan=2>
	<table cellpadding=4 cellspacing=1 class='doc131' border=0 width='100%'>
	<tr><td $bgcolor3>特定ヘッダフィールドまたはボディ(本文)で条件を指定して検索を行います。
	&nbsp;<a href='$cgi2?top'>キーワード検索 $arrowR</a>&nbsp; 
	<a href='$cgi3?top'>ホワイトリストの管理 $arrowR</a></td></tr>
	</table></td></tr>
</table>
<table cellpadding=20 cellspacing=0 border=0>
<tr><td>
	<table cellpadding=2 cellspacing=0 class='doc131' border=0>
	<tr><td>■条件(ルール)の追加$hr</td></tr>
	<tr><td height=2></td></tr>
	<tr><td>ルール名: <input name='rule' value='$rule' size=30 maxlength=128 $nosubmit> (日本語で自由に)</td></tr>
	<tr><td>
		<table cellpadding=1 cellspacing=1 class='doc131' border=0>
		<tr $bgcolor0><td>検索対象フィールド</td><td>キーワード</td>
		<td>評価方法</td><td>正規表現</td></tr>
		<tr><td><select name='header'>
		<option value=''>▽選択</option>
	<option>Authentication-Results</option>
	<option>Cc</option>
	<option>Comments</option>
	<option>Content-Disposition</option>
	<option>Content-Transfer-Encoding</option>
	<option>Content-Type</option>
	<option>Date</option>
	<option>Delivery-Agent</option>
	<option>Disposition-Notification-To</option>
	<option>DomainKey-Signature</option>
	<option>Errors-To</option>
	<option>From</option>
	<option>In-Reply-To</option>
	<option>Keywords</option>
	<option>Lines</option>
	<option>Message-Id</option>
	<option>MIME-Version</option>
	<option>Organization</option>
	<option>Posted</option>
	<option>Precedence</option>
	<option>Received</option>
	<option>Received-SPF</option>
	<option>References</option>
	<option>Reply-To</option>
	<option>Return-Path</option>
	<option>Return-ReCeipt-To</option>
	<option>Sender</option>
	<option>Subject</option>
	<option>To</option>
	<option>User-Agent</option>
	<option>X-Account</option>
	<option>X-Antivirus</option>
	<option>X-Apparently-From</option>
	<option>X-Apparently-To</option>
	<option>X-Attach</option>
	<option>X-Dispatcher</option>
	<option>X-Html</option>
	<option>X-Keywords</option>
	<option>X-Mail-Agent</option>
	<option>X-Mail-Count</option>
	<option>X-Mailer</option>
	<option>X-MailerError</option>
	<option>X-MailerServer</option>
	<option>X-MessageId</option>
	<option>X-MimeOLE</option>
	<option>X-ML-Name</option>
	<option>X-MSMail-Priority</option>
	<option>X-Originating-IP</option>
	<option>X-Priority</option>
	<option>X-S25R-Check</option>
	<option>X-SmtpMessageID</option>
	<option>X-Spam-Level</option>
	<option>X-Spam-Status</option>
	<option>X-Virus-Scanned</option>
	<option value='Header'>ヘッダ全体</option>
	<option value='RHeader'>標準ヘッダ全体(X-???以外のヘッダ)</option>
	<option value='XHeader'>拡張ヘッダ全体(X-???となるヘッダ)</option>
	<option value='Body'>Body(メッセージ本文)</option>
	<option value='BodyHtml'>BodyHtml(HTMLタグを含むメッセージ本文)</option>
		</select></td>
		<td><input name='word' size=30 maxlength=128 value='$word' $nosubmit></td>
		<td><select name='method'>
		<option value='0'>▽選択</option>
		$methods
		</select></td>
		<td><select name='regexp'>
		<option value='0'>▽選択</option>
		<option value='0'>オフ</option>
		<option value='1'>オン</option>
		</select></td></tr>
		</table></td></tr>
	<tr><td><input type='submit' value='ルールを追加/設定更新'></td></tr>
	<tr><td height=20></td></tr>
	
	<tr><td>■登録済みルール一覧</td></tr>
	<tr><td>
		<table cellpadding=1 cellspacing=1 class='doc131' border=0>
		<tr $bgcolor0><td nowrap>順位&nbsp;</td><td nowrap>ルール名 &nbsp;</td>
		<td nowrap>フィールド &nbsp;</td><td nowrap>キーワード &nbsp; &nbsp; &nbsp;</td>
		<td nowrap>評価方法 &nbsp;</td><td nowrap>正規表現 &nbsp;</td>
		<td nowrap>削除/移動</td></tr>
EOF
	
	# 検索条件一覧の表示
	my @rules;
	if (open(FILE,$tab)){
			while (<FILE>){
				chomp;
				next if (/^\s*$/ || /^#/);
				$_ = &dec_utf($_,$charsetE);
				push(@rules,$_);
			}
		close(FILE);
	}
	
	if (@rules){
		my $count0 = @rules;
		my $count1;
		foreach (@rules){
			$count1++;
			my ($rule,$header,$word,$method,$regexp) = split(/\t/,$_);
			$rule =~ s/</&lt;/g;
			$rule =~ s/>/&gt;/g;
			my $down = "<a href='$cgi?down+$count1' title='このルールを下へ移動します'>▼</a>&nbsp;" if $count1 != $count0;
			my $up = "<a href='$cgi?up+$count1' title='このルールを上へ移動します'>▲</a>&nbsp;" if $count1 != 1;
			if ($count0 == 1){$down = $up = '';}
			if ($count1 == $count0){$down = '　 &nbsp;';}
			if ($regexp){$regexp = 'オン';} else {$regexp = 'オフ';}
			$word =~ s/</&lt;/g;
			$word =~ s/>/&gt;/g;
			$word =~ s/"/&quot;/g;
			
			$K4 .= <<"EOF";
<tr valign='top'><td>$count1</td><td>$rule</td>
<td>$header</td><td>$word</td><td>$method{$method}</td><td>$regexp</td>
<td><a href='$cgi?del+$count1' $confirm1>削除</a>&nbsp; $down $up</td><tr>
EOF
		}
	} else {
		$K4 .= "<tr><td height=40 colspan=7>検索ルールは登録されていません。</td></tr>\n";
	}
	
	$K4 .= <<"EOF";
	</table></td></tr>
<tr><td>$hr</td></tr>
<tr><td class='doc13'>
<ul>
<li>正規表現がオフの場合、キーワード文字列にはワイルドカード(?,*)が使用できます。</li>
<li>正規表現がオンの場合、キーワード文字列の簡易な文法チェックを行っていますが完全ではありません。</li>
<li>複数のルールが存在する場合、登録の上位から順に評価が行われ、最初に一致したルールでスパム処理が行われます。</li>
<li>"評価方法" 項目で値を選択しなかった場合、"で始まる" を選択したものとみなし、"正規表現" 項目で値を選択しなかった場合、"オフ" を選択したものとみなします。</li>
</ul></td></tr>
</table>
</form>
EOF
	
	&print_utf($K4);
	&print_footer();
	&exit();
}
