#!c:/usr/perl/bin/perl.exe

### uK4 - BBSコメントを書き込む
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use MIME::Base64;
use Net::SMTP;
use utf8;
require './config.cgi';
require './bbs_common.cgi';
$cgi1  = 'bbs_post_comment.cgi';
$cgi2  = 'bbs_view.cgi';
$cgi3  = 'bbs_articles.cgi';
$cgi4  = 'bbs_search.cgi';
$bgcolor = "bgcolor='#f0f0f0'";		# フォーム背景色

### 初期表示
if (@ARGV){
	($bbsid,$field,$method,$page,$part,$aID,$op,$op2) = @ARGV;	# opは'serch'のみ
	my $base1 = "$bbsroot/$bbsid/articles/$part";		# 記事・コメントの格納場所
	%bbs = &get_bbs_profile($bbsid);					# 掲示板情報を得る
	my %a = &get_bbs_article("$base1/$aID.article");	# 記事情報を得る
	($articleTitle,$maxsize,$upload) = ($a{Title},$bbs{Size},$bbs{Upload});
	$maxsize = $bbsmaxupload if !$maxsize;
	
	## 親記事を引用
	if ($op2 eq '1'){
		my $aid = sprintf("%03d",$aID);
		my $name = $a{FName};
		$name .= " &lt;$a{From}&gt;" if $bbs{DispEmail};
		$Text = $a{Text};
		$Text =~ s/[\n\r]+$//;
		$Text =~ s/^/&gt; /;
		$Text =~ s/\r*\n/$&&gt; /g;
		$Text = "&gt; 記事#$aid\n&gt; $name wrote:\n&gt;\n$Text\n\n";
		$rows = 21;
	}
	
	## コメントを引用
	elsif ($op2){
		my ($tmp1,$tmp2,@tmp);
		open(FILE,"$base1/$aID.comments");
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				$tmp1 .= $_;
			};
		close(FILE);
		@tmp = split(/\n*#+\s*-+\s*#+\n*/,$tmp1);
		($tmp2) = grep(/CommentID: *$op2/,@tmp);
		my ($id,$name);
		my $c = 0;
		foreach my $i (split(/\r*\n/,$tmp2)){
				if ($c == 0 .. $i =~ /^$/i){
					if ($i =~ /^ID:\s*(.*)/){$id = $1;}
					if ($i =~ /^Name:\s*(.*)/){$name = $1;}
					$c++;
					next;
				}
				$Text .= "&gt; $i\n";
		}
		$name .= " &lt;$id&gt;" if $bbs{'DispEmail'};
		$Text =~ s/[\n\r]+$//;
		1 while $Text =~ s/(&gt;) +>/$1$1/g;
		my $op1 = sprintf("%03d",$op2);
		$Text = "&gt; コメント#$op1\n&gt; $name wrote:\n&gt;\n$Text\n\n";
		$rows = 21;
	} else {
		$rows = 13;
	}
	$Name = $handle;
	
	&html();
}

### フォーム処理
&parse_form();
while (($key,$val) = each %qArray){
	&redirect() if $k4envstr =~ /,$key,/;
	&zenhan('val');
	1 while $val =~ s/^(\s|　)+//;
	1 while $val =~ s/(\s|　)+$//;
	if ($key ne 'Text'){
		$val =~ s/[\r\n]//g;
		$val =~ s/\t+/ /g;
	}
	$$key = $val;
}
($bbsid,$field,$method,$page,$part,$aID,$op) = split(/\+/, $arg);
%bbs = &get_bbs_profile($bbsid);

## エラー処理
&html("ゲストアカウントでは投稿できません！",1) if $k4fixed;
&html("ハンドル名を書いてください。",1) if !$Name;
&html("ハンドル名にあなたのメールアドレスを書くことはできません。",1) if $Name =~ /$user1\@$domain1/i;
&html("コメントを書いてください。",1) if !$Text;

## ファイルアップロード/ウイルススキャン
$saved = &upload();

## コメントIDを決定
my $comment = "$bbsroot/$bbsid/articles/$part/$aID.comments";
my ($tmp,@tmp);
if (open(FILE,$comment)){
		while (<FILE>){
			$_ = &dec_utf($_,$charsetE);
			$tmp .= $_;
		}
	close(FILE);
	my @tmp = split(/#+\s*-+\s*#+\n/,$tmp);
	$cid = @tmp;
}
$cid = 1 if $cid eq '';
$cid = sprintf("%05d",$cid);

## ファイル情報を保存
if ($saved){
	Encode::_utf8_off($saved);
	Encode::from_to($saved,$charset,$charsetE);
	if (open(FILE,">>$bbsroot/$bbsid/articles/files/$aID.txt")){
			flock(FILE,2);
			print FILE "$saved\t$cid\n";		# コメントIDを付加
		close(FILE);
	}
}

## コメントを保存
foreach (qw(articleTitle handle Text)){
	${$_.2} = $$_;
	Encode::_utf8_off(${$_.2});
	Encode::from_to(${$_.2},$charset,$charsetE);
}
open(FILE,">>$comment") || &html("コメントを保存できませんでした。",1);
	print FILE <<"EOF";
BBS: $bbsid
Part: $part
ArticleID: $aID
Title: $articleTitle2
CommentID: $cid
Date: $date_5
IP: $ENV{'REMOTE_ADDR'}
ID: $user1\@$domain1
Name: $handle2
Notify: $bbs{Notify}

$Text2

##### ----- #####

EOF
close(FILE);

## 通知/ロギング
$aid = sprintf("%05d",$aID);
$cid2 = sprintf("%03d",$cid);
&logging("$bbsroot/$bbsid/logs/bbs.txt","$Name($user1\@$domain1) が記事「$articleTitle($aid)」にコメント($cid2)を書きました。");
if ($bbs{'Notify'}){
	my $str1 = "<$user1\@$domain1>" if $bbs{'DispEmail'};
	# 通知メッセージ作成
	my $cid2 = sprintf("%03d",$cid);
	my $notice1 = "■ファイルがアップロードされています。\n" if $saved;
	$message = <<"EOF";
$Name がコメントを書きました。
----------------
■掲示板
$bbs{'Title'}($bbsid)
■記事番号
$aid
■記事タイトル
$articleTitle
----------------
■コメント日時
$date_2
■コメント者
$Name$str1
■コメント番号
$cid2
$notice1■コメント本文
$Text
----------------
* このメッセージに返信しないでください。
* 関連発言は掲示板で行ってください。
EOF
	
	$msg = &notify_bbs($bbsid,$message,$bbs{'NotifyTag'},$bbs{'NotifySender'},$bbs{'NotifyTo'},$bbs{'OwnersEmail'});
	$msg = "<br>$msg" if $msg;
}

## 終了処理
unlink("$bbsroot/$bbsid/articles.txt");
open(FILE,">$bbsroot/$bbsid/articles/$part/$aID.read");
	flock(FILE,2);
	print FILE $userid ."\t". time() ."\n";
close(FILE);
&complete("コメントIDは #$cid2 です。$msg");

### 表示 -----------------------------------
sub html {
	my ($error,$op3) = @_;
	&expire($error) if ($Expired && !$op3);
	$arg = join("+",$bbsid,$field,$method,$page,$part,$aID,$op);
	&htmlconv(qw(Name Text articleTitle));
	$aid = sprintf("%05d",$aID);
	
	&print_common($error);
	
	print <<"EOF";
<form action='$cgi1' method='post' ENCTYPE='multipart/form-data'>
<input type='hidden' name='arg' value="$arg">
<input type='hidden' name='articleTitle' value='$articleTitle'>
<input type='hidden' name='maxsize' value='$maxsize'>
<input type='hidden' name='rows' value='$rows'>
<input type='hidden' name='upload' value='$upload'>

<table cellpadding=0 cellspacing=1 class='doc13' border=0>
<tr $bgcolor3><td nowrap>親記事のタイトル: &nbsp;</td><td class='doc15'><b>$articleTitle</b></td></tr>
<tr><td>ハンドル名:$r</td><td><input name='Name' size=70 maxlength=128 value='$Name'></td></tr>
<tr $bgcolor3><td colspan=2>コメント:$r</td></tr>
<tr><td colspan=2><textarea class='doc15' name='Text' cols=81 rows=$rows wrap='soft'>$Text</textarea></td></tr>
<tr><td height=4></td></tr>
<tr><td><input type='reset' value='リセット'></td>
<td align='right'><input type='submit' value=' このコメントを書き込む ' onClick="if(!confirm('このコメントを書き込んでよろしいですか？')){return false;}"></td></tr>
<tr><td height=4></td></tr>
EOF
	
	# ファイルアップロードを許可する掲示板であれば
	if ($bbsallowupload && $upload){
		my $size = $maxsize;
		1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
		print "<tr $bgcolor3><td nowrap>ファイルの<br>アップロード:</td>";
		print "<td><input type='file' name='file1' size=30 $nosubmit><br>\n";
		print "<input name='text1' size=30 maxlength=100 $nosubmit value='$text1'> (ファイルの説明)</td></tr>\n";
		print "<tr><td height=4></td></tr>\n";
		print "<tr><td class='doc12' colspan=2>&nbsp;* アップロードできるファイルは $size(KB) に制限されています。</td></tr>\n" if $size;
	}
	print "<tr><td class='doc12' colspan=2>&nbsp;* この掲示板ではあなたのメールアドレス($user1\@$domain1)が投稿者情報として表示されます。</td></tr>\n" if $bbs{'DispEmail'};
	
	print "</table>\n</form>\n";
	
	# 一時ファイル残骸削除
	foreach (glob("../temp/$loginid/temp/*__")){unlink($_);}
	
	&print_footer();
	exit;
}

## 投稿完了
sub complete {
	local ($msg) = @_;
	&htmlconv(qw(Text));
	$Text =~ s/[\r\n]/<br>/g;
	$Text =~ s/\t/    /g;
	1 while $Text =~ s/  /&nbsp; /;
	my $aid = sprintf("%05d",$aID);
	my $str = $fs7R.'投稿完了です。'.$fe;
	
	&print_common();
	
	my $back = $cgi3;
	$back = $cgi4 if $op eq 'search';
	
	print <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc13' border=0>
<tr><td>$iii</td><td>$str</td></tr>
<tr><td></td><td>
$Name 名でコメントを書き込みました。<br>
$msg<br>
<br>
<a href='$cgi2?$arg'>コメント一覧にもどる$arrowR</a><br>
<a href='$back?$arg'>記事一覧にもどる$arrowR</a></td></tr>
<tr><td height=10></td></tr>
</table>
<table cellpadding=8 cellspacing=2 class='doc13' border=0 bgcolor='#d0ffd0' width='90%'>
<tr><td bgcolor='#ffffff'>$Text</td></tr>
</table>
</blockquote>
EOF
	
	&print_footer();
	exit;
}

## 共通ヘッダ
sub print_common {
	my ($error) = @_;
	my $str = $fs7G.'コメントの投稿'.$fe;
	
	&do_header1($error,1);
	
	my $back = $cgi3;
	$back = $cgi4 if $op eq 'search';
	
	print <<"EOF";
<table cellpadding=0 cellspacing=2 class='doc12' border=0 width='90%'>
<tr valign='bottom'><td>$str&nbsp; 記事 #$aid にコメントを書きます。</td>
<td align='right'><a href='$back?$arg'>記事一覧にもどる$arrowR</a>&nbsp;
<a href='$cgi2?$arg'>コメント一覧にもどる$arrowR</a></td></tr>
<tr><td bgcolor='#a0a0a0' colspan=2 height=1></td></tr>
</table>
EOF
}
