#!C:/usr/perl/bin/perl.exe

### uK4 - パスワード/秘密の言葉/ワンタイムパスワード通知先の変更
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Digest::MD5 'md5_hex';
use MIME::Base64;
use Net::SMTP;
use utf8;
require "./config.cgi";
@array = qw(bPass bStr bOne myword pass1 pass2 to k4auth3to);
&auth();
%me = &getenv("$userdir/$xmailcfg/config.tab","=");

### 初期表示
if (@ARGV){
	$k4auth3to = $me{k4auth3to} if ($auth3rd && $me{k4auth3});		# 通知先
	$myword = &get_myword();		# 現在の秘密の言葉を得る
	&html();
}

### パスワード/秘密の言葉/ワンタイムパスワードの更新
&parse_form(@array);
&html("このアカウントでは更新できません！",1) if $k4fixed;
&html("通知先アドレスが変です！",1) if ($to && $to !~ /^$emreg$/i);
my ($from,$message,$msg,$subject) = ("$user1\@$domain1");

## パスワードを更新
if ($bPass){
	&html("パスワードを指定してください。",1) if ($pass1 eq '' || $pass2 eq '');
	foreach(@array){
		&html("空白やタブを含むパスワードは許可されません！",1) if $$_ =~ /[ \t]/;
		&zenhan($_) if $$_ =~ /[^$zstr]/;
	}
	&html("パスワードが一致しません！",1) if ($pass1 ne $pass2);
	&html("パスワードに不正な文字が含まれています！",1) if $pass1 =~ /["|<>]/;
	&html("パスワードの長さを $passmin 字以上にしてください！",1) if length($pass1) < $passmin;
	&html("パスワードに記号文字を入れる必要があります！",1) if ($passch1 && $pass1 !~ /[^0-9a-z]/i);
	my $c = $& if $pass1 =~ /^./;
	($c) = &mod_str($c);
	&html("同一文字が連続するパスワードは許可されません！",1) if ($passch2 && $pass1 =~ /^$c+$/);
	&html("通知先アドレスが変です！",1) if ($to && $to !~ /^$emreg$/i);
	
	## 旧パスワードと比較
	my $file = "$mailroot/mailusers.tab";
	if (-s $file){
		my $pass2 = &enc_str($pass1);
		my ($domain2,$user2) = &mod_str($domain1,$user1);
		
		my @tmp;
		open(FILE,$file);
			@tmp = <FILE>;
		close(FILE);
		&html("現在のものと同じパスワードです！",1) if (grep(/^"*$domain2"*\t"*$user2"*\t"*$pass2"*\t/,@tmp));
	}
	
	## 更新
	&ctrlcmd("\"userpasswd\"	\"$domain1\"	\"$user1\"	\"$pass1\"");
	&log('s',$domain1,$user1,'*','run','パスワードの変更',$0);
	
	$goon = 1;
	$msg = 'パスワードを更新しました。';
	if ($k4xExtSystemMSG1){
		$k4xExtSystemMSG1 =~ s/\\n/<br>/g;
		$msg .= $k4xExtSystemMSG1;
	}
	
	# 通知メッセージ
	$message = "アカウント $user1\@$domain1 のパスワードを更新しました。\n";
	$message .= "新しいパスワードは $pass1 です。\n";
	$subject = "パスワード更新通知";
}

## 秘密の言葉を更新(EUCで保存)
elsif ($bStr && $auth2nd){
	my $file = "$userdir/$xmailcfg/myword.tab";
	$myword =~ s/^\s+//;
	$myword =~ s/\s+$//;
	my $myword3 = $myword;
	Encode::_utf8_off($myword3);		# use::utf8があるとEncode::from_toが使えない
	Encode::from_to($myword3,$charset,$charsetE);	# コード変換
	if ($myword && open(FILE,">$file")){
			print FILE $myword3;
		close(FILE);
		$msg = '秘密の言葉を更新しました。';
	} else {
		unlink($file);
		$msg = '秘密の言葉を解除しました。';
	}
	
	# 通知メッセージ
	$message = "アカウント $user1\@$domain1 の秘密の言葉を更新しました。\n";
	$message .= "新しい言葉は \"$myword\" です。\n";
	$subject = "秘密の言葉更新通知";
}

## ワンタイムパスワード通知先を更新
elsif ($auth3rd && $me{k4auth3}){
	&html("ワンタイムパスワード通知先が変です。") if ($k4auth3to && $k4auth3to !~ /$emreg/);
	
	if ($me{k4auth3on}){
		if ($k4auth3to){$msg = 'ワンタイムパスワード通知先を更新しました。';}
		else {$msg = 'ワンタイムパスワード通知先を解除しました。';}
	} else {
		&html("ワンタイムパスワード通知先を指定してください。") if $k4auth3to eq '';
		$msg = 'ワンタイムパスワード通知先を更新しました。';
	}
	
	&saveenv('k4',$domain1,$user1,'k4auth3to');
	
	# 通知メッセージ
	$message = "アカウント $user1\@$domain1 のワンタイムパスワード通知先を更新しました。\n";
	if ($k4auth3to){$message .= "新しい通知先は \"$k4auth3to\" です。\n";}
	else {$message .= "通知先を解除したため、ワンタイムパスワードシステムは停止されました。\n";}
	$subject = "ワンタイムパスワード通知先更新通知";
}

## 更新通知
if ($to){
	$message .= "-------\n$year/$month/$mday $hour:$min\n";
	@To = ($to);
	&startmail;
	$msg .= "$to に通知しました。";
}

&html($msg);

## -------------------------------------
sub html {
	my ($emsg) = @_;
	&htmlconv('myword');
	&expire($_[0]) if ($Expired && !$_[1]);
	$emsg = "$alert $fs5R $emsg $fe" if $emsg;
	my $confirm = "onClick=\"if(!confirm('本当に更新しますか？')){return false;}\"";
	my $msg1 = '<br><br>パスワードには記号文字を含む必要があります。' if $passch1;
	my $msg2 = '<br><br>同一文字が連続するパスワードは許可されません。' if $passch2;
	my $msg3 = '<br><br>"秘密の言葉" は任意の内容にすることができます。日本語もOKです。秘密の言葉を設定すると、2要素でのログイン認証となりセキュリティを高めることができます。' if $auth2nd;
	$msg3 .= '<br><br>ワンタイムパスワード機能によりアカウントのセキュリティを高度に高めることができます。' if ($auth3rd && $me{k4auth3});
	
	print "Content-Type: text/html; charset=$charset\n\n";
	print "$cbody";
	
	$K4 = <<"EOF";
<form method='post' action='changepass.cgi'>
$table1
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=6 cellspacing=0 class='doc13' border=0 width=130>
		<tr><td $bgcolor1>
		パスワードには、すべての英字・数字と$fs2<b> \" | \&lt; \&gt; </b>$fe
		を除くすべての記号文字が使えます。$msg1$msg2$msg3</td></tr>
		</table></td></tr>
	</table></td>
<td width=8 nowrap></td>
<td width='100%'>
	<table cellpadding=1 cellspacing=4 class='doc13' border=0>
	<tr valign='top'><td><img src='$idir/key.gif' width=26 height=40 title='$title' border=0></td>
	<td $bgcolor4 width=12>$null</td>
	<td>$fs7<b>セキュリティ</b>$fe
	$hr
	$emsg
	<table cellpadding=2 cellspacing=0 class='doc131' border=0>
	<tr><td bgcolor='#ffe0e0'>&laquo;パスワードや秘密の言葉等の更新を以下のアドレスに通知する&raquo;<br>
	<input name='to' size=70 maxlength=70 value="$to" $nosubmit></td></tr>
	<tr><td height=16></td></tr>
	<tr><td>$fs5<b>パスワードの更新</b>$fe <font color='black'>( <b>$passmin</b> 文字以上で指定してください)</font></td></tr>
	<tr><td>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='パスワードを入力してください'> 
	<input type='password' name='pass1' size=30 maxlength=128 $nosubmit><br>
	<img src='$idir/arrow_blue.gif' width=32 height=13 title='パスワードをもう一度入力してください'> 
	<input type='password' name='pass2' size=30 maxlength=128 $nosubmit></td></tr>
	<tr><td><input type='submit' name='bPass' value='パスワードを更新する' $confirm></td></tr>
	<tr><td height=16></td></tr>
EOF
	
	# 秘密の言葉
	if ($auth2nd){
		$K4 .= "<tr><td>$fs5<b>秘密の言葉の更新</b>$fe</td></tr>";
		$K4 .= "<tr><td><input name='myword' size=70 maxlength=256 value=\"$myword\" $nosubmit></td></tr>";
		$K4 .= "<tr><td><input type='submit' name='bStr' value='秘密の言葉を更新する' $confirm></td></tr>";
		$K4 .= "<tr><td height=16></td></tr>";
	}
	
	# ワンタイムパスワード通知先
	if ($auth3rd && $me{k4auth3}){
		$K4 .= "<tr><td>$fs5<b>ワンタイムパスワード通知先の更新</b>$fe</td></tr>";
		$K4 .= "<tr><td>";
		if ($me{k4auth3on}){
			$K4 .= "機能を利用したい場合、通知先アドレスを指定してください。<br>";
			$K4 .= "無指定にするとワンタイムパスワード機能を利用しません。";
		} else {
			$K4 .= "通知先メールアドレスを指定する必要があります。";
		}
		$K4 .= "</td></tr>";
		$K4 .= "<tr><td><input name='k4auth3to' size=70 maxlength=256 value=\"$k4auth3to\" $nosubmit></td></tr>";
		$K4 .= "<tr><td><input type='submit' name='bOne' value='ワンタイムパスワード通知先を更新する' $confirm></td></tr>";
	}
	
	$K4 .= "	</table></td></tr></table></td></tr>";
	
	my $str = &get_my_shortcut($domain1,$user1);
	if ($allowautologin && $str){
		$K4 .= <<"EOF";
<tr><td colspan=3><hr size=1>
<img src='$idir/arrow_red.gif' width=31 height=13 title='自動ログイン用ショートカット'>
&nbsp;<b>自動ログイン用ショートカット</b> - 以下のショートカットで本システムに自動ログインできます。<br>
<font color='#a00000'>$str</font></td></tr>
EOF
	}
	
	$K4 .= "</table></form>";
	
	&print_utf($K4);
	&print_footer();
	require "./$k4changepassscript" if ($goon && -f "./$k4changepassscript");
	&exit();
}

## 秘密の言葉を得る
sub get_myword {
	my $myword;
	
	open(FILE,"$userdir/$xmailcfg/myword.tab") || return();
		$myword = <FILE>;
	close(FILE);
	chomp($myword);
	
	$myword;
}
