#!C:/usr/perl/bin/perl.exe

### uK4 - ドメインの管理 - 追加メニュー
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./domain_common.cgi";
@array = qw(
	tdomain n01 n02 n03 n04 n05 n06 n07 n08 n09 n10 n11 n12 n13 n14 n15 
	u01 u02 u03 u04 u05 u06 u07 u08 u09 u10 u11 u12 u13 u14 u15 
	o01 o02 o03 o04 o05 o06 o07 o08 o09 o10 o11 o12 o13 o14 o15
);

## 初期表示
if (@ARGV){
	&domainadmin();	# ドメイン管理者か
	$tdomain = $key4;
	&html();
}

## フォームからの入力を処理
&parse_form(@array);
&domainadmin();
&html("このアカウントでは更新できません！",1) if $k4fixed;

for(1 .. $maxmenu){
	$_ = sprintf("%02d",$_);
	my $line = "$_\t${'n'.$_}\t${'u'.$_}\t${'o'.$_}\n";
	Encode::_utf8_off($line);
	Encode::from_to($line,$charset,$charsetE);
	push(@reg,$line);
}

open(FILE,">$mailroot/domains/$tdomain/k4.menu.tab") || &html("保存に失敗しました。",1);
	flock(FILE,2);
	print FILE @reg;
close(FILE);

$msg = "追加メニューを保存しました。";
&html($msg);

## ページを表示 ------------------------------
sub html {
	if (@_){
		&expire($_[0]) if ($Expired && !$_[1]);
		$notice = "$alert $fs5R $_[0] $fe";
	} else {$notice = "$tdomain ドメインのユーザがログインしたときに表示する追加メニューを指定します。";}
	&check_domaininfo($tdomain);
	&k4menu();	# K4 追加メニューを得る
	&header('menu');
	
	my $title = '追加メニューの管理';
	$K4 = <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc13' border=0>
<tr><td>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title'> 
$fs7G<b>$title</b>$fe
$hr
$notice</td></tr>
<tr><td height=6></td></tr>
<tr><td $bgcolor2>
<form method='post' action='$dmenu'>
<input type='hidden' name='tdomain' value='$tdomain'>
	<table cellpadding=0 cellspacing=0 class='doc13' border=0>
	<tr><td></td><td>■メニュータイトル</td>
	<td colspan=2>&nbsp;■URL<br>
	$k4menu</td></tr>
	</table></td></tr>
<tr><td><input type='submit' name='update' value='保存/更新'></td></tr>
</table>

<table class='doc13'>
<tr><td>
<ul>
<li>メニュータイトルは日本語で自由に指定できますが、できるだけ短く指定するように工夫してください。</li>
<li>URL には、メニュータイトルをクリックしたときに開くウェブページのアドレスを指定します。</li>
<li>"別窓" にチェックをつけると新しいウインドウを開いて指定ページを開きます。</li>
チェックがない場合、本ツール集のドキュメントフレーム内にそれを表示します。</li>
<li>追加メニューの表示はユーザごとにそれをオン/オフにできます。</li>
</ul>
</td></tr>
</table>
EOF
	
	&print_utf($K4);
	&print_footer();
	&exit();
}

sub k4menu {
	local ($id,$name,$op,$url,@reg);
	
	# K4 追加メニューを読む
	if (open(FILE,"$mailroot/domains/$tdomain/k4.menu.tab")){
			while (<FILE>){
				$_ = &dec_utf($_,$charsetE);
				chomp;
				push(@reg,$_);
			}
		close(FILE);
	}
	for $id (1 .. $maxmenu){
		$id = sprintf("%02d",$id);
		foreach(@reg){
			if (/^$id\t/){
				($idx,$name,$url,$op) = split(/\t/,$_);
				if ($name eq '' || $url eq ''){next;}
				if ($op){$op = 'checked';}
				&htmlconv('name');
			}
		}
		$k4menu .= <<"EOF";
<tr><td>#$id&nbsp;</td>
<td><input name='n$id' size=25 value="$name" $nosubmit maxlength=45></td>
<td nowrap>&nbsp;<input name='u$id' size=55 value="$url" $nosubmit maxlength=100></td>
<td nowrap><input type='checkbox' name='o$id' $op value='1'>別窓</td></tr>
EOF
	}
}
