#!C:/usr/perl/bin/perl.exe

### uK4 - ドメインの管理-リストの管理-リストの追加
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./domain_common.cgi";
($cgi,$help,$tagmax) = ("domain_list.cgi","$helper?l",'30');
@array = qw(
	tdomain username CompanyName RealName Subscribe Tag ListSender MessageSize ClosedML UseReplyTo Attachment Header 
	headertext ForceFrom Footer footertext Deny MessageID Log lp lperm ReplyTo welcomesubject WelcomeMessage 
	welcometext goodbyesubject GoodbyeMessage goodbyetext RobotHelp helpsubject helptext RobotInfo 
	infosubject infotext ListAdmin Owner MaxUser memo menuid Ladmin Lmember Lmsgsize Lstag Lattach Lmsgid 
	Lheader Ldeny Lrobot Ldel Lfrom Llog Larc Lsubscribe Llog Larc LadminOK
);

## 初期表示
if (@ARGV){
	&domainadmin();
	$tdomain = $key4;
	&check_domaininfo($tdomain);
	if ($key6 eq 'retry'){
		$menuid = $key7;
		if (!$listtotal){$msg = 'アカウントが作成されていません！';}
		else {$msg = 'アカウントを選択してから実行してください！';}
	}
	elsif ($key6 =~ /@/){
		$msg = "アカウント $key6 を削除しました。";
		$menuid = 'del';
	}
	$menuid = 'member' if !$menuid;
	$chk1 = 'checked';
	$MessageSize = $maxlistmsgsize;
	$MaxUser = $maxlistmember;
	$rt2 = 'checked';
	$LadminOK = 1;
	&html('',$msg);
}

## フォーム入力を処理
&parse_form(@array);
&domainadmin();
&check_domaininfo($tdomain);
$tmp = "$username\@$tdomain";
&html("このアカウントでは追加できません！") if $k4fixed;
&html("<b>$username</b> はシステムで予約されています！") if $tmp =~ /^($postmaster1|$robot1)$/i;
&html("リスト名を指定してください！") if !$username;
&html("リスト名に不正な文字が含まれています！") if $username =~ /[^\w.\-]/;
&html("ドットで開始または終了するリスト名は使用できません！") if ($username =~ /^\./ || $username =~ /\.$/);
&check_listinput();						# 入力情報の内容チェック

# 同一アカウントチェック
open(FILE,"$mailroot/mailusers.tab");
	@reg = <FILE>;
close(FILE);
&html("$username\@$tdomain はすでに存在します！") if (grep(/"$tdomain"\t"$username"/i,@reg));
&html("$username\@$tdomain はシステムで予約済みです！") if -s "$mailroot/cmdaliases/$tdomain/$username.tab";

# アカウント作成
my $pass0 = time();
&ctrlcmd("\"useradd\"	\"$tdomain\"	\"$username\"	\"$pass0\"	\"M\"");
&set_chown("$mailroot/domains/$tdomain/$username") if $OS;
if (!-d "$mailroot/domains/$tdomain/$username"){
	&html("アカウントを作成できませんでした。管理者までご連絡ください。");
	&log('f',$domain1,$user1,'?','admin','リストアカウント作成に失敗',$0);
}

$ReceiveEnable = 1;
&savelistenv($tdomain,$username);	# 環境を保存
&savememo($tdomain,$username);		# 管理用メモを保存

$msg = "アカウント $username\@$tdomain を追加しました。";
foreach(@array){
	if (/^tdomain|MessageSize|ClosedML|UseReplyTo|ReplyTo|MaxUser|menuid$/){next;}
	$$_ = '';
}
&log('s',$domain1,$user1,'?','admin','リストアカウントを作成',$0);
&html('',$msg);

## ページを表示 -------------------------
sub html {
	my ($emsg) = @_;
	$emsg = "$alert $fs5R $emsg $fe" if $emsg;
	if ($Expired && !$_[0]){&expire($_[1]);}
	&check_domaininfo($tdomain);
	&selectmenu_l();
	&header('list');
	
	my $title = 'リストの管理';
	$K4 = <<"EOF";
<table cellpadding=4 cellspacing=0 class='doc131' border=0>
<tr><td colspan=3>
<img src='$idir/arrow_blue.gif' width=32 height=13 title='$title'> 
$fs7G<b>$title</b>$fe <span class='doc15'>$listtotal1</span>
$hr
$fs5R $_[1] $fe</td></tr>
<tr valign='top'><td>$selectmenu</td><td width=1></td><td>
EOF
	&print_utf($K4);
	
	if ($listtotal < $maxlist || $maxlist == 0){
		my $str = $fs7.'リストアカウントの追加'.$fe;
		$K4 = <<"EOF";
<table cellpadding=0 cellspacing=1 class='doc131' border=0>
<tr><td colspan=2>$buttonP $str
$hr
$emsg</td></tr>
<tr><td height=4>
<form method=post action='$cgi'>
<input type='hidden' name='tdomain' value='$tdomain'>
<input type='hidden' name='menuid' value='$menuid'>
<input type='hidden' name='LadminOK' value='$LadminOK'></td></tr>
<tr><td colspan=2>
	<table cellpadding=0 cellspacing=1 class='doc131' border=0>
	<tr><td width=20></td>
	<td><a href="JavaScript:opn_win('$help+listname'$wsize)">リスト名</a>:</td>
	<td><input name='username' size=25 maxlength=50 value='$username' $nosubmit></td></tr>
	<tr><td height=4></td></tr>
	<tr><td></td><td></td><td>
	<input type='submit' value='このアカウントを追加'></td></tr>
	</table></td></tr>
<tr><td colspan=2><br>
$fs2 必要があれば以降を指定/変更してください。$fe
$hr
EOF
		&print_utf($K4);
		
		&printliststat();
		$K4 = "<div align='right'>$arrowU</div>";
		$K4 .= "<blockquote><div class='doc13'>";
		if (open(FILE,"help_macro.cgi")){
				while(<FILE>){
					chomp;
					$K4 .= $_;
				}
			close(FILE);
		}
		$K4 .= "</div></blockquote>";
		$K4 .= "<div align='right'>$arrowU</div>";
	} else {
		my $str = $fs5R.'リストアカウントの追加はできません。'.$fe;
		$K4 = <<"EOF";
<br>
<table cellpadding=0 cellspacing=1 class='doc131' border=0>
<tr><td><p>$str<br>
このドメインの最大リスト数は $maxlist 個です。</p>
<p>アカウントの一部を削除してください。</p></td></tr>
</table>
EOF
	}
	
	&print_utf($K4);
	&print_footer();
	&exit();
}
