#!C:/usr/perl/bin/perl.exe

## ビッグファイルダウンロード用($Id,$sessionを持ち回る)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Digest::MD5 'md5_hex';
use utf8;
require "./config.cgi";
$cgi = 'download.cgi';
$confirm = "onClick=\"if(!confirm('このファイルをダウンロードしますか？')){return false;}\"";
$content = "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
($authpage,$errorpage,$footerpage,$headerpage) = &x_original();
$bigfilemax = 1 if $bigfilemax eq '';
$bigfileroot =~ s/\\/\//g;
$root = "../temp/bigfile";

### 初期アクセスまたは再アクセス -----
if (@ARGV){
	($Id,$session) = @ARGV;
	&print_confirm(1) if (!$Id || !-d "$bigfileroot/$Id" ||
		!-s "$bigfileroot/$Id/profile.txt" || ($session && length($session) != 32));
	
	## 送付サイトの情報を得る
	%b = &getenv("$bigfileroot/$Id/profile.txt",'=','',1,$charset);
	
	## サイトの有効期間をチェック
	my $today = "$year$month$mday";
	&print_confirm(5) if ($b{Start} && $b{Start} > $today);
	&print_confirm(4) if ($b{End} && $b{End} < $today);
	
	## 初期アクセス
	if ($session eq ''){
		my $str = $Id . time() .$ENV{'REMOTE_ADDR'}.$ENV{'HTTP_REFERER'};
		$session = md5_hex $str;
		mkdir("$root",0755);
		mkdir("$root/$Id",0755);
		mkdir("$root/$Id/$session",0755);
		&print_confirm(2) if !-d "$root/$Id/$session";
		foreach my $file ('index.htm','index.html','default.htm'){
			open(FILE,">$root/$Id/$session/$file") && close(FILE);
		}
		
		# ロギング
		&save_history($Id,'open',0);
	} elsif (length($session) != 32 || !-d "$root/$Id/$session"){
		&print_confirm(3);
	}
	
	## セッションの時間切れをチェック
	&print_confirm(6)
		if ($b{ExpireTime} && (stat("$root/$Id/$session/index.html"))[9] <= time() - $b{ExpireTime});
	
	## ログインが必要($root/$session/.$Idは認証済みフラグ)
	&print_auth() if ($b{Auth} && !-f "$root/$Id/$session/.$Id");
	
	## ダウンロードサイトオープン
	&html();
}

### フォームを処理(認証・ダウンロード) -----
&parse_form();
while (($key,$val) = each %qArray){
	&redirect if $k4envstr =~ /,$key,/;
	$val = &dec_utf($val,$charset);
	if ($key =~ /^down_(\d+)$/ && $val){
		$fileID = $1;
		next;
	}
	$val =~ s/(　)+/ /g;
	$val =~ s/\s+/ /g;
	$$key = $val;
}

&print_confirm(1) if (!$Id || !$session || !-d "$root/$Id/$session");
%b = &getenv("$bigfileroot/$Id/profile.txt",'=','',1,$charset);

## 認証
if ($auth){
	if ($myphrase eq ''){
		&save_history($Id,'auth',1);
		&print_auth("パスフレーズを入力してください.");
	}
	my $phrase = $b{PassPhrase};
	$phrase =~ s/(　)+/ /g;
	$phrase =~ s/\s+/ /g;
	my $phrase2 = $myphrase;
	
	# パスフレーズ比較
	if ($b{Sensitive}){
		($phrase2) = &mod_str($phrase2);
		if ($phrase !~ /^$phrase2$/){
			&save_history($Id,'auth',1);
			&print_auth("パスフレーズを確認してください.") ;
		}
	} else {
		my ($p1,$p2) = (uc($phrase),uc($phrase2));
		if ($p1 ne $p2){
			&save_history($Id,'auth',1);
			&print_auth("パスフレーズを確認してください.");
		}
	}
	
	# 認証成功 - 認証済みフラグ作成
	open(FILE,">$root/$Id/$session/.$Id");
		print FILE "Date = $year/$month/$mday $hour:$min:$sec\n";
		print FILE "Session = $session\n";
		print FILE "ID = $Id\n";
		print FILE "IP = $ip\n";
		print FILE "Referer = $ENV{'HTTP_REFERER'}\n";
	close(FILE);
	
	# ダウンロードページへログイン
	print "Location: $cgi?$Id+$session\n\n";
	
	# ロギング
	&save_history($Id,'login',0);
	exit;
}

## ダウンロード
&print_confirm(1) if ($b{Auth} && !-f "$root/$Id/$session/.$Id");
&html("File ID not found") if !$fileID;
my $str = 'File'.$fileID;
($name,$ext,$filename) = ($b{$str.'Name'},$b{$str.'Ext'},$b{$str.'ID'});
&html("File not found") if !-s "$bigfileroot/$Id/$filename";

# ダウンロード回数のチェック
my ($cTime,$dTime) = ($b{'File'.$fileID.'Limit'},0);
if ($cTime && open(FILE,"$bigfileroot/$Id/history.txt")){
		while (<FILE>){
			chomp;
			$_ = &dec_utf($_,$charset);
			my @a = split(/\t/,$_);
			$dTime++ if ($a[2] eq 'download' && !$a[3] && $a[4] eq "File$fileID");
		}
	close(FILE);
	&html("指定ファイルは $cTime 回のダウンロードが完了しました。") if $dTime >= $cTime;
}

$name .= ".$ext" if $name !~ /\.$ext$/;
Encode::_utf8_off($name);
#Encode::from_to($name,$charset,$charsetS);

my $startTime = time();
my $stat = &download("$bigfileroot/$Id/$filename",$name);
my $endTime = time();

if (!$stat){
	$pTime = $startTime - $endTime;
} else {
	$stat = 1;
}

# ロギング/完了
&save_history($Id,'download',$stat,$str,$pTime);
exit;

### ダウンロードページを表示 ---------------------------------
sub html {
	my ($error) = @_;
	$error = 'ようこそダウンロードサイトへ...' if $error eq '';
	my ($c,$colspan,$count,$data,$str1,$str2,@files) = (0,4);
	local($message,$rcpt,$sender,$mailto,$mailto2,$sentto) = ($b{HTMLMessage},$b{RCPTName},$b{SenderName});
	&htmlconv(qw(mailto mailto2 message rcpt sender sentto));
	$mailto = $mailto2 = decode("MIME-Header",encode($charset,$b{SentFrom}));
	$sentto = decode("MIME-Header",encode($charset,$b{SentTo}));
	
	if ($b{Auth}){
		$colspan = 6 if $b{Auth};
		$str2 = "<td>利用可能回数</td><td>ダウンロード数</td>";
	}
	
	# 対象サイトデータを得る(ファイル数、ファイル情報)
	($count,@files) = &x_my_files();
	foreach my $file (@files){
		$file =~ s/</&lt;/g;
		$file =~ s/>/&gt;/g;
		$file =~ s/"/&quot;/g;
		
		# 0ファイルID 1サイトID 2名前 3説明 4拡張子 5サイズ 6制限回数 7ダウンロード完了回数
		my ($i,$id,$name,$desc,$ext,$size,$limit,$download) = split(/\t/,$file);
		my $bgc = 'white';
		$bgc = '#e0ffe0' if $c%2 == 1;
		$ext = uc($ext);
		$name = $desc if $desc;
		1 while $size =~ s/(.*\d)(\d\d\d)/$1,$2/;
		1 while $limit =~ s/(.*\d)(\d\d\d)/$1,$2/;
		1 while $download =~ s/(.*\d)(\d\d\d)/$1,$2/;
		my $link = "<input type='submit' name='down_$i' $confirm value='ダウンロード'>";
		if ($b{Auth}){
			$download = '0' if !$download;
			$link = '終了' if ($limit && $download >= $limit);
			$limit = '無制限' if !$limit;
		}
		$data .= "<tr bgcolor='$bgc' valign='top'><td>$name</td><td>$ext</td><td align='right'>$size(KB)&nbsp;</td>";
		$data .= "<td align='right'>$limit&nbsp;</td><td align='right'>$download&nbsp;</td>" if $b{Auth};
		$data .= "<td align='center'>$link</td></tr>";
		$c++;
	}
	
	# 開始/終了
	$start = "$1/$2/$3" if $b{Start} =~ /(\d{4})(\d{2})(\d{2})/;
	$end = "$1/$2/$3" if $b{End} =~ /(\d{4})(\d{2})(\d{2})/;
	$start = '-' if $start eq '';
	$end = '-' if $end eq '';
	
	# 追加メッセージ
	$message =~ s/\|\|/<br>/g;
	
	$str1 = "<p><font color='#006000'>$message</font></p>";
	if ($rcpt){$str1 .= $rcpt.'のための専用ダウンロードサイトです。<br>';}
	else {$str1 .= $sentto.' 専用ダウンロードサイトです。<br>';}
	$str1 .= "<dd>あて先: $rcpt<br>" if $rcpt;
	$str1 .= "<dd>送付元: $sender<br>" if $sender;
	$str1 .= "ダウンロードボタンをクリックすればダウンロードが開始されます。<br>";
	$str1 .= "ダウンロードに不具合がある場合、<br><a href=\"mailto:$mailto\">$mailto2</a> まで連絡してください。<br>";
	$str1 .= "(ダウンロード数はページを<a href='$cgi?$Id+$session'>再表示</a>すれば最新情報を表示します)" if $b{Auth};
	
	&print_header3(30,"$cgi?$Id+$session");
	&print_body_1();
	
	$K4 = <<"EOF";
<table border=0 cellpadding=0 cellspacing=1 class='doc17' width='600'>
<tr><td valign='bottom'>$fs2$error$fe</td></tr>
<tr><td bgcolor='#c0c0c0' height=1></td></tr>
<tr><td height=10></td></tr>
<tr><td class='doc15'>$str1</td></tr>
<tr><td height=20></td></tr>
</table>

<table border=0 cellpadding=0 cellspacing=1 class='doc15' width='600'>
<form action='$cgi' method='post'>
<input type='hidden' name='Id' value='$Id'>
<input type='hidden' name='session' value='$session'>
<tr align='center' bgcolor='#ffe0e0' class='doc12'><td>ファイル</td><td>種類</td><td>サイズ</td>
$str2<td>ダウンロード</td></tr>
$data
<tr><td bgcolor='#c0c0c0' colspan=6 height=1></td></tr>
<tr><td height=4></form></td></tr>
<tr><td class='doc12' colspan=$colspan>
<ul>
<li>大きなファイルのダウンロードでは時間がかかる場合があります。</li>
<li>ダウンロードが終了するまではこのブラウザウインドウを閉じないでください(最小化はOK)。</li>
<li>ダウンロード完了後はこのブラウザウインドウをそのまま閉じてください。</li>
</ul>
</td></tr>
</table>
EOF
	&print_utf($K4);
	&print_body_2();
	&print_footer3;
}

### 認証ページを表示
sub print_auth {
	my ($error) = @_;
	$error = 'このサイトの閲覧は認証が必要です...' if $error eq '';
	$ct++;
	my %b2 = &getenv("$bigfileroot/$Id/profile.txt",'=','',1,$charset);
	
	&print_header3('','','myphrase');
	
	## リトライチェック
	if ($b2{Retry} && $ct > $b2{Retry}){
		$error = '再アクセスしてください...';
		&print_body_1();
		$K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='$error'></td>
<td class='doc17' valign='bottom'>$fs2$error$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=10></td></tr>
<tr><td colspan=2><p>パスフレーズの入力には回数制限があります。<br>
失敗回数が制限を超えてしまいました。<br>
ログインのためにはサイトに改めてアクセスする必要があります。</p>
</td></tr>
</talble>
EOF
		&print_utf($K4);
		
		# ロギング
		&save_history($Id,'auth',1);
		
		&print_body_2();
		&print_footer3();
	}
	## リトライOKの場合
	if ($authpage){print $authpage;}
	else {
		&htmlconv('myphrase');
		my $str = "<br>(パスフレーズは大文字と小文字とが区別されます)" if $b2{Sensitive};
		&print_body_1();
		$K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='URLを確認してください($error)'></td>
<td class='doc17' valign='bottom'>$fs2$error$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=10></td></tr>
<tr><td colspan=2><p>このサイトへのアクセスはパスフレーズの入力が必要です。<br>
パスフレーズを入力してサイトにログインしてください。
$str</p>
<form action='$cgi' name='myform' method='post'>
<input type='hidden' name='ct' value='$ct'>
<input type='hidden' name='Id' value='$Id'>
<input type='hidden' name='session' value='$session'>
<p><input name='myphrase' size=40 maxlength=128 $nosubmit value="$myphrase">
<input type='submit' name='auth' value='ログイン'></p>
</form></td></tr>
</table>
EOF
		&print_utf($K4);
		&print_body_2();
	}
	
	&print_footer3;
}

### システム標準ボディの左半分を表示
sub print_body_1 {
	print <<"EOF";
<table align='center' border=0 cellpadding=10 cellspacing=0 class='doc15'>
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='top'><td><img src='$idir/foot_1.gif' border=0 height=154 width=160 title='Who?'></td>
<td>
EOF
}

### システム標準ボディの右半分を表示
sub print_body_2 {
	print "</td></tr>\n</table>\n";
}

### サイトの確認(不正アクセス等)
sub print_confirm {
	my ($error) = @_;
	my ($str1,$str2);
	
	if ($error >= 6){			# セッションの時間切れ
		$str1 = "サイトは有効ではありません!!";
		$str2 = <<"EOF";
アクセス先のサイトは時間切れになりました。<br>
改めて初期アクセスを行ってください。<br>
ご協力ありがとうございます。<br>
EOF
	} elsif ($error >= 5){		# サイトの開始前
		$str1 = "サイトは準備中です!!";
		$str2 = <<"EOF";
アクセス先のサイトは受付の準備中です。<br>
しばらくお待ちください。<br>
ご協力ありがとうございます。<br>
EOF
	} elsif ($error >= 4){		# サイトの終了後
		$str1 = "サイトは終了しました!!";
		$str2 = <<"EOF";
アクセス先のサイトは受付を終了しました。<br>
ご協力ありがとうございました。<br>
EOF
	} elsif ($error == 3){		# 存在しない
		$str1 = "サイトが見つかりません!!";
		$str2 = <<"EOF";
アクセス先のサイトは見つかりません。<br>
入力ミスか、すでに削除された可能性があります。<br>
アクセス先を確認してください。<br>
EOF
	} elsif ($error == 2){		# 一時領域を作成できない
		$str1 = "サイトを準備できません!!";
		$str2 = <<"EOF";
アクセス先のサイトを準備できませんでした。<br>
送信元へ問い合わせてください。<br>
EOF
	} else {					# 不正アクセス
		$str1 = "アクセス先が正しくありません!!";
		$str2 = <<"EOF";
アクセス先のサイトは存在しません。<br>
正しいアドレスでサイトへアクセスしてください。<br>
EOF
	}
	
	&print_header3();
	&print_body_1();
	$K4 = <<"EOF";
<table border=0 cellpadding=1 cellspacing=0 class='doc15'>
<tr><td><img src='$idir/i.gif' border=0 height=26 width=26 title='$str1($error)'></td>
<td class='doc17' valign='bottom'>$fs2$str1$fe</td></tr>
<tr><td bgcolor='#c0c0c0' colspan=2 height=1></td></tr>
<tr><td colspan=2 height=20></td></tr>
<tr><td colspan=2>$str2</td></tr>
</talble>
EOF
	&print_utf($K4);
	&print_body_2();
	&print_footer3();
}

### フッタを表示
sub print_footer3 {
	if ($footerpage){print $footerpage;}
	else {print "</body>\n</html>\n";}
	exit;
}

### ヘッダを表示
sub print_header3 {
	my ($refresh,$url,$focus) = @_;
	$focus = "onload=\"document.myform.$focus.focus()\"" if $focus;
	
	print $content;
	
	if ($headerpage){
		print $headerpage;
		return();
	}
	
	## 標準ヘッダを表示
	$refresh = "<meta http-equiv='Refresh' content='$refresh;url=$url'>" if $refresh;
	$K4 = <<"EOF";
<html><head>
$refresh
$charcss
<title>ファイルのダウンロード</title>
</head>
<body $bodyp class='doc15' topmargin=20 leftmargin=20 marginheight=20 marginwidth=20 $focus>
EOF
	&print_utf($K4);
}

### ロギング
sub save_history {
	my ($site,$type,$stat,$file,$time) = @_;
	# 0サイトID 1日時 2ban/download/login/open/create 3ステータス(成功0/失敗1) 4ファイルID 5所要時間 6IP 7Referer
	open(FILE,">>$bigfileroot/$site/history.txt") || return();
		flock(FILE,2);
		print FILE "$site\t$year/$month/$mday $hour:$min:$sec\t$type\t$stat\t$file\t$time\t";
		print FILE "$ENV{'REMOTE_ADDR'}\t$ENV{'HTTP_REFERER'}\t\n";
	close(FILE);
}

## 該当サイトのファイル情報を得る
sub x_my_files {
	my ($count,@files,@tmp,%download) = (0);
	
	# ファイルIDごとのダウンロード回数を得ておく
	if (open(FILE,"$bigfileroot/$Id/history.txt")){
			@tmp = <FILE>;
		close(FILE);
		foreach my $a (@tmp){
			chomp($a);
			# 0ID 1日時 2ban/download/login/open/create 3status(0/1) 4ファイルID 5所要時間 6IP 7Referer
			my @a = split(/\t/,$a);
			$download{$a[4]}++ if ($a[2] eq 'download' && !$a[3]);
		}
	}
	
	# 送付ファイルリスト
	for my $i (1 .. $bigfilemax){
		my $str = 'File'.$i;
		my $id = $b{$str.'ID'};
		next if (!$id || !-f "$bigfileroot/$Id/$id");
		push(@files,"$i\t$id\t$b{$str.'Name'}\t$b{$str.'Desc'}\t$b{$str.'Ext'}\t$b{$str.'Size'}\t$b{$str.'Limit'}\t$download{$str}\t");
		$count++;
	}
	
	($count,@files);
}

### オリジナルHTMLがあれば得る
sub x_original {
	my ($auth,$count,$error,$footer,$header) = ('',0);
	
	## 認証用HTMLファイルが存在する場合(100バイト以上で有効)
	if (open(FILE,"$bigfileroot/$bigfileauth")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$auth .= $_;
			}
		close(FILE);
		$auth = '' if (length($auth) < 100 || $auth !~ /=['"]pathphrase[ '"]/ || $auth !~ /<form /i);
	}
	## エラー用HTMLファイルがある場合(100バイト以上で有効)
	if (open(FILE,"$bigfileroot/$bigfileerror")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$error .= $_;
			}
		close(FILE);
		$error = '' if length($error) < 100;
	}
	## フッタ用HTMLファイルが存在する場合(10バイト以上で有効)
	if (open(FILE,"$bigfileroot/$bigfilefooter")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$footer .= $_;
			}
		close(FILE);
		$footer = '' if length($footer) < 10;
	}
	## ヘッダ用HTMLファイルが存在する場合(100バイト以上で有効)
	if (open(FILE,"$bigfileroot/$bigfileheader")){
			while (<FILE>){
				$_ = &dec_utf($_,$charset);
				$count++ if /<html /i;
				$count++ if /=['"]*utf[-_]*8/i;
				$count++ if /<body /i;
				$header .= $_;
			}
		close(FILE);
		$header = '' if ($count < 3 && length($header) < 100);
	}
	
	($auth,$error,$footer,$header);
}
