#!C:/usr/perl/bin/perl.exe

### uK4 - フォイルアップロード
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./file_common.cgi";
$directory = "../temp/$loginid/upload";
$tempdir = $directory . '/temp';
$max0 = 5;		# 同時アップロード数(デフォルト)

### 初期表示
if (@ARGV){
	exit if !$fsallow;
	mkdir($directory,0755);
	mkdir($tempdir,0755);
	&html;
}

### ファイルアップロード/削除/リネーム
&parse_form();
while (($key,$value) = each %qArray){
	&redirect() if $k4envstr =~ /,$key,/;
	$value =~ s/\s+/ /g;
	$$key = $value;
}
&html("このアカウントでは実行できません！") if $k4fixed;

## アップロード
$saveroot = "$fsroot/$Root/$key7";
$saveroot =~ s/[\/_]+$//;
my ($count,$errors) = (0,'');
for (1 .. $maxupload){
	my ($file,$tempfile) = ($qArray{'file'.$_},$qFileTmp{'file'.$_});
	next if !-s $tempfile;
	$file = &dec_utf($file);
	$file2 = $file;
	
	# トータルサイズ検査
	my $space = &get_total_space();
	if ($k4fsspace && $k4fsspace < $space){
		$errors .= "\"$file2\" は個人用フォルダの総容量が $space(KB) を超えたためアップロードできませんでした。<br>";
		next;
	}
	
	# 個別サイズ検査
	my $size = -s $tempfile;
	$size = int(($size+1023)/1024);
	if ($k4fssize && $size > $k4fssize){
		$errors .= "\"$file2\" は制限サイズ $k4fssize(KB) を超えているためアップロードできませんでした。<br>";
		next;
	}
	
	# 拡張子検査
	my $ext = $1 if $file =~ /\.([^.]+)$/;
	$ext = uc($ext);
	my @ext = split(/\s+/,$fstag);
	if ($ext && @ext && grep(/^$ext$/i,@ext)){
		$errors .= "\"$file2\" は禁止拡張子のためアップロードできませんでした。<br>";
		next;
	}
	
	# ウイルス検査
	if (-f $scanner){
		my $chk;
		my $name = time();
		my $tempfile2 = "$directory/$name";
		copy($tempfile,$tempfile2);
		my ($scanok,@report) = &vscan($tempfile2);
		if (
			(@report && grep(/[\/\\]$name[^.].*(Infection:|Infected|virus)/i,@report)) ||
			($scanner =~ /\\nod32(\.exe)*$/i && grep(/\x83\x45\x83\x43\x83\x8B\x83\x58\x90\x94:[1-9]/,@report) 
				&& grep(/[\/\\]$name /,@report)) ||
			($scanner =~ /\\vscanwin32(\.com)*$/i && grep(/\\$name /i,@report)) ||
			($scanner =~ /\\clamscan(\.exe)*$/i && grep(/$name:.+FOUND/,@report)) ||
			($scanner =~ /\\fsav(\.exe)*$/i && grep(/\\$name(\\.+)* +(\x8A\xB4\x90\xF5|Infection):/i,@report))
		){
			$errors .= "\"$file2\" はウイルス感染の疑いがあるためアップロードできませんでした。<br>";
			$chk = 1;
			unlink($tempfile,$tempfile2);
		}
		next if $chk;
	}
	
	# 保存IDを決定
	my $name = time();
	for (1 .. 100){$name++ if -f "$saveroot/$name";}
	
	# 保存
	my $savefile = "$saveroot/$name";
	copy($tempfile,$savefile);
	if (!-f $savefile){$errors .= "\"$file2\" はアップロードに失敗しました(原因不明)。<br>"; next;}
	
	# 成功したものについてファイル情報を保存
	$count++;
	$errors .= "\"$file2(${size}KB)\" をアップロードしました。<br>";
	my $line = join("\t","$name\t$ext",$file2,$size,${'text'.$_},"$user1\@$domain1","","$year/$month/$mday $hour:$min");
	Encode::_utf8_off($line);
	#Encode::from_to($ling,$charset,$charsetE);
	open(FILE,">$saveroot/$name.txt");
		print FILE "$line\n";
	close(FILE);
}

# アップロード成功の場合はindex.txtを削除
if ($count){unlink("$saveroot/$index","$fsroot/$Root/$dirindex");}

# ロギング

# 完了
for (1 .. $maxupload){${'text'.$_} = '';}
if ($count){$msg = "$count 個のファイルをアップロードしました。";}
else {$msg = "アップロードできせん。";}
&html($msg,$errors);

### ----------------------------------------------
sub html {
	my ($errors1,$errors2) = @_;
	if ($Expired && !$errors1){&expire();}
	
	# フォルダ情報を得る
	my %i = &get_info("$fsroot/$Root/$key7");	# カレントフォルダ情報
	my $space = &get_total_space();				# このユーザの総使用量
	my @files = &get_myfiles();					# カレントフォルダのファイル/フォルダ一覧
	my $files = grep(/^\d{10}\t/,@files);		# カレントフォルダのファイル総数
	
	# 作業フォルダ内ファイルを削除
	foreach (glob("$tempdir/*")){unlink($_);}
	
	# カレントフォルダにアップロード可能なファイル数を判定
	if ($k4fsfiles && $k4fsfiles > $files){
		$maxupload = $k4fsfiles - $files;
		$maxupload = $max0 if $maxupload > $max0;
	}
	
	# アップロード画面表示
	&print_header1($errors1);
	($K4) = &print_header3($errors2);
	
	$K4 .= <<"EOF";
<form action='$uploadcgi' id='K4' method='post' enctype='multipart/form-data'>
<input type='hidden' name='key4' value='$key4'>
<input type='hidden' name='key5' value='$key5'>
<input type='hidden' name='key6' value='$key6'>
<input type='hidden' name='key7' value='$key7'>
<input type='hidden' name='maxupload' value='$maxupload'>
<table cellpadding=10 cellspacing=0 border=0>
<tr><td $bgcolor3>
<table cellpadding=0 cellspacing=1 class='doc131' border=0>
EOF
	
	if ($maxupload){
		for (1 .. $maxupload){
			$K4 .= "<tr><td>保存名$_:</td><td><input name='text$_' size=35 maxlength=128 $nosubmit>&nbsp;</td>";
			$K4 .= "<td><td>ファイル:</td><td><input type='file' name='file$_' size=18 $nosubmit $class></td></tr>";
		}
		
		1 while $k4fssize =~ s/(.*\d)(\d\d\d)/$1,$2/;
		$K4 .= <<"EOF";
<tr><td height=8></td></tr>
<tr><td colspan=2><input type='submit' value='アップロード実行' $class onclick='WaitDisplay()'></td></tr>
</table></td></tr>
</table>
<ul>
<li>保存名は自由に指定でき、他の名前と重複させることも可能です(日本語可)。</li>
<li>保存名を指定しなかった場合、アップロードするファイルの名前が保存名になります。</li>
<li>同名ファイルをアップロードした場合でも異なるファイルとして保存されます。</li>
<li>最大 $k4fssize(KB) の単一ファイルをアップロードできます。</li>
</ul>
</td></tr>
EOF
	} else {
		$K4 .= "<tr><td align='center' height=120>ファイル数が規定数に達しました。</td></tr>";
	}
	
	$K4 .= "</form><tr><td colspan=2></td><td><table width=400><tr><td align='center'>";
	$K4 .= &print_waitmsg('しばらくお待ちください...','ファイルをアップロードしています...');
	$K4 .= "</td></tr></table></td></tr></table>";
	
	&print_utf($K4);
	&print_footer();
	exit;
}

# タイトルを表示
sub print_header3 {
	my ($error) = @_;
	my ($folders,$name) = &get_dirs_list();
	$name = $rootname if !$name;
	$error = "指定ファイルを [$name] フォルダ内にアップロードします。" if !$error;
	
	my $K4 = <<"EOF";
$table0
<tr valign='top'><td>
	<table cellpadding=1 cellspacing=0 border=0>
	<tr><td bgcolor='#ffb0b0'>
		<table cellpadding=4 cellspacing=0 border=0 width='100%'>
		<tr valign='top'><td $bgcolor1 height=100>
			<table cellpadding=1 cellspacing=0 class='doc131' border=0>
			<tr><td align='center' bgcolor='#c0c0c0'><font color='white'><b>フォルダツリー</b></font></td></tr>
			<tr><td height=4></td></tr>
			$folders
			</table></td></tr>
		</table></td></tr>
	</table></td>
<td><img src='$idir/null.gif' height=1 width=12 alt=''></td>
<td width='100%'>
	$table0
	<tr valign='bottom'><td>
	$fs5<b>ファイルのアップロード</b>$fe [$name]</td>
	<td align='right'><a href='$listcgi?$key4+$key5+$key6+$key7'>前にもどる$arrowR</a></td></tr>
	<tr bgcolor='#c0c0c0'><td colspan=2 height=1></td></tr>
	</table>
	<dl><dd><p><font color='#006000'>$error</font></p></dl>
EOF
	($K4,$name);
}
