#!C:/usr/perl/bin/perl.exe

### uK4 - グループの管理トップ
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./config.start.cgi";
require "./group_common.cgi";

## 初期表示
if (@ARGV){
	($gid) = @ARGV;
	exit if $extstr4 !~ /$gid/;
	
	&html();
}

## ページを表示 ----------------------------
sub html {
	if ($Expired && !$_[1]){&expire($_[0]);}
	
	&header(@_);
	&get_group_info();		# グループ情報を得る
	
	$K4 = <<"EOF";
<dl><dd>
$buttonG <span class='doc15'><b>グループ情報</b></span><br>
<table cellpadding=6 cellspacing=0 border=0 width='85%'>
<tr><td $bgcolor3>
<table cellpadding=1 cellspacing=0 class='doc131' border=0>
<tr><td>グループID:</td><td width='100%'>$gid</td></tr>
<tr><td>グループ名:</td><td>$g{'Name'}</td></tr>
<tr><td>状態:</td><td>$stat</td></tr>
<tr><td>メンバー数:</td><td>$members</td></tr>
<tr><td>運用開始日:</td><td>$Start</td></tr>
<tr><td>運用終了日:</td><td>$End</td></tr>
<!-- <tr><td>対応ML:</td><td>$p{'ML'}</td></tr>-->
<tr><td>メモ1:</td><td>$Memo1</td></tr>
<tr><td>メモ2:</td><td>$Memo2</td></tr>
<tr valign='top'><td nowrap>責任者1の情報:</td><td>$info1</td></tr>
<tr valign='top'><td nowrap>責任者2の情報: &nbsp;</td><td>$info2</td></tr>
<tr><td>作成日:</td><td>$p{'Created'}</td></tr>
<tr><td>更新日:</td><td>$p{'Updated'}</td></tr>
</table></td></tr>
<tr><td height=20></td></tr>
</table>

$buttonG <span class='doc15'><b>メニュー案内</b></span>$hr
EOF
	&print_utf($K4);
	
	if ($p{'ManageMembers'}){
		print "<a href='group_members.cgi?$gid'>$fs5 メンバー管理$fe</a><br>";
		print "グループメンバーの閲覧、登録、削除などを行います。$hr";
	}
	if ($p{'Sendmail1'}){
		print "<a href='group_notify.cgi?$gid'>$fs5 全員同報$fe</a><br>";
		print "グループメンバー全員に対して同報メッセージを送信します。$hr";
	}
	if ($p{'Sendmail2'}){
		print "<a href='group_sendmail.cgi?$gid'>$fs5 責任者連絡$fe</a><br>";
		print "グループ責任者に対してメッセージを送信します。$hr";
	}
	if ($p{'EditInfo'}){
		print "<a href='group_info.cgi?$gid'>$fs5 お知らせ(通知メッセージ)$fe</a><br>";
		print "このグループのメンバーがログインしたときに表示する管理者からのメッセージを編集します。";
		print "(メンバーの所属ドメインや個別メンバーについてメッセージが作成されているときはそれらも表示されます)$hr";
	}
	if ($p{'EditMenu'}){
		print "<a href='group_menu.cgi?$gid'>$fs5 追加メニュー$fe</a><br>";
		print "このグループのメンバーに対して追加表示する専用メニューを編集します。";
		print "(メンバーの所属ドメインについて追加メニューが作成されているときはそれらも表示されます)$hr";
	}
	if ($p{'EditBook'}){
		print "<a href='group_book.cgi?$gid'>$fs5 アドレス帳$fe</a><br>";
		print "このグループのメンバーに対して追加表示するアドレス帳データを編集します。";
		print "(メンバーの所属ドメインについてアドレス帳が作成されているときはそれらも表示されます)$hr";
	}
	if ($p{'EditFooter'}){
		print "<a href='group_footer.cgi?$gid'>$fs5 フッタ(メッセージフッタ)$fe</a><br>";
		print "このグループのメンバーがメッセージを送信するときに強制付加する定型文を編集します。";
		print "(メンバーの所属ドメインや個別メンバーについてフッタが作成されているときはそれらも付加されます)$hr";
	}
	if ($p{'EditUrl'}){
		print "<a href='group_url.cgi?$gid'>$fs5 ログアウト先(URL)$fe</a><br>";
		print "このグループのメンバーがログアウトするときに開くウェブサイトを指定します。";
		print "ただし、ユーザが個別にログアウト先を指定している場合はそちらが優先されます。";
		print "また、ユーザが複数のグループに所属している場合、管理 ID の若いグループの指定が優先されます。$hr";
	}
	
	print "<div align='right'>$arrowU</div></dl>";
	
	&print_footer();
	&exit();
}

sub get_group_info {
	while (my($key,$value) = each %g){$$key = $value;}
	
	$stat = "運用中";
	if ($Start || $End){
		my $ctime = $year.$month.$mday;
		if (($Start && $Start > $ctime) || ($End && $End < $ctime)){
			$stat = "$fs2 運用期間終了$fe";
		}
	}
	$stat = "$fs2 停止中$fe" if -f "$groot/$gid/.suspended";
	$stat = "$fs2 削除済み$fe" if -f "$groot/$gid/.deleted";
	
	$Start =~ s/(\d\d\d\d)(\d\d)(\d\d)/$1\/$2\/$3/;
	$End =~ s/(\d\d\d\d)(\d\d)(\d\d)/$1\/$2\/$3/;
	
	$info1 = $Charge1Name.'<br>' if $Charge1Name;
	$info2 = $Charge2Name.'<br>' if $Charge2Name;
	$info1 .= "$Charge1Email $Charge1Phone $Charge1Memo";
	$info2 .= "$Charge2Email $Charge2Phone $Charge2Memo";
	$info1 = '-' if $info1 =~ /^\s*$/;
	$info2 = '-' if $info2 =~ /^\s*$/;
	
	foreach (qw(Start End ML Memo1 Memo2 Created Updated)){$$_ = '-' if $$_ eq '';}
	
	$members = &get_group_members($gid);	# メンバー数を得る
	1 while $members =~ s/(.*\d)(\d\d\d)/$1,$2/;
}
