#!C:/usr/perl/bin/perl.exe

### uK4 - グループの管理 - 追加メニュー
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./group_common.cgi";
$cgi = "group_menu.cgi";
$maxmenu = 15;
$target = "K4.menu.tab";
@array = qw(gid n01 n02 n03 n04 n05 n06 n07 n08 n09 n10 n11 n12 n13 n14 n15 
	u01 u02 u03 u04 u05 u06 u07 u08 u09 u10 u11 u12 u13 u14 u15 
	o01 o02 o03 o04 o05 o06 o07 o08 o09 o10 o11 o12 o13 o14 o15);

## 初期表示
if (@ARGV){
	($gid) = @ARGV;
	exit if $extstr4 !~ /$gid/;
	
	&html();
}

## フォームからの入力を処理
&parse_form(@array);
&html("このアカウントでは実行できません！") if $k4fixed;

# 追加メニューを更新
for (1 .. $maxmenu){
	$_ = sprintf("%02d",$_);
	$menu .= "$_\t${'n'.$_}\t${'u'.$_}\t${'o'.$_}\n";
}
my $menu2 = $menu;
Encode::_utf8_off($menu2);
Encode::from_to($menu2,$charset,$charsetE);
open(FILE,">$groot/$gid/$target");
	flock(FILE,2);
	print FILE $menu2;
close(FILE);

# 完了
&html("追加メニューを更新しました。");

## ページを表示 ----------------------------
sub html {
	&expire if ($Expired && !$_[1]);
	
	&header(@_);
	&print_mytitle('menu');
	&get_k4menu;
	
	print <<"EOF";
<dl><dd>
<form action='$cgi' method='post'>
<input type='hidden' name='gid' value='$gid'>

<table cellpadding=1 cellspacing=0 class='doc13' border=0>
<tr class='doc15'><td>【メニュー名】</td><td>【アドレス(URL)】</td></tr>
EOF
	
	for (1 .. $maxmenu){
		my $chk;
		$_ = sprintf("%02d",$_);
		if (${'o'.$_}){$chk = 'checked';}
		print "<tr><td><input name='n$_' size=25 value=\"${'n'.$_}\" $nosubmit></td>";
		print "<td><input name='u$_' size=55 value=\"${'u'.$_}\" $nosubmit></td>";
		print "<td><input type='checkbox' name='o$_' $chk value='1'>別窓</td></tr>";
	}
	print <<"EOF";
<tr><td height=8></td></tr>
<tr><td colspan=2><input type='submit' name='update' value='更新する'></td></tr>
</table>
<p><div class='doc13'>$hr
<li>"メニュー名" には日本語が使えますが、できるだけ短い名前を工夫してください。</li>
<li>"アドレス" は、オープンするウェブサイトまたは実行するスクリプト名などを指定します。</li>
<li>"別窓" は新ウインドウでメニューを開く場合にチェックをつけます。</li>
<li>"メニュー名" と "アドレス" の双方が指定されているものが実際に表示されます。</li>
</div></p>
<div align='right'>$arrowU</div>
</form>
</dl>
EOF
	
	&print_footer();
	&exit();
}

## 既存メニューを読む
sub get_k4menu {
	my @reg;
	open(FILE,"$groot/$gid/$target") || return();
		while (<FILE>){
			chomp;
			$_ = &dec_utf($_,$charsetE);
			push(@reg,$_);
		}
	close(FILE);
	for my $id (1 .. $maxmenu){
		$id = sprintf("%02d",$id);
		foreach(@reg){
			if (/^$id\t/){
				my ($idx,$name,$url,$op) = split(/\t/,$_);
				next if (!$name && !$url);
				$name =~ s/</&lt;/g;
				$name =~ s/>/&gt;/g;
				$name =~ s/"/&quot;/g;
				${'n'.$id} = $name;
				${'u'.$id} = $url;
				${'o'.$id} = $op;
			}
		}
	}
}
