<blockquote>
<hr color='#D0D0D0' size=1>
<p><font class='doc17'>&laquo;<b>Subject:</b>に付加するタグについて&raquo;</font></p>

<p>メッセージヘッダの Subject: 先頭に付加するタグ文字列には本ツール集独自のマクロを含めることができます。現在サポートされているマクロは以下の通りです(複数マクロの同時使用可)。</p>

<p><font color='red' class='doc15'>カウンタマクロ:</font> &nbsp;<font color="#cc0000" class='doc17'>%c%</font></p>

<p>マクロ %c% は、該当メッセージの Subject:ヘッダにに投稿番号を自動挿入するためのものです。%c% や %c3%、%c31% などのように、文字 % でくくる部分に文字 c に続けて 1 桁または 2 桁の数値を指定します。</p>
<p>文字 c に続く最初の数字は投稿番号の桁数を指定するためのオプションで 1 から 9　までの数値を指定します。数値を指定しなかった場合は 5 を指定したものとみなします。ただし、2 つ目の数字を指定する場合は最初の数字は省略できません。</p>

<p>2 つ目の数字は動作モードを指定するためのオプションで、新規発言の場合のみ投稿番号をカウントアップする場合は 0(省略可能)に、新規発言であれ関連発言であれカウントアップする場合には 1 にします。</p>

## サンプル<br>

<table cellpadding=2 cellspacing=2 border=0 class='doc15' width="80%">
<tr align="center" bgcolor="#ffdddd" class='doc131'><td>タグ文字列</td><td>挿入される文字列</td></tr>
<tr bgcolor="#e0ffe0"><td>%c%</td><td>00001 (新規投稿でカウントアップ)</td></tr>
<tr bgcolor="#e0ffe0"><td>%c51%</td><td>00001 (いつでもカウントアップ)</td></tr>
<tr bgcolor="#e0ffe0"><td>[Information #%c3%]</td><td>[Information #001]</td></tr>
</table>

<p>なお、タグ文字列に %c% と %d%(次項参照)との双方のマクロが使用されている場合に動作モードオプションを 1(いつでもカウントアップする場合)にすると、マクロが正しく挿入されない場合があります。</p>
<br>

<p><font color='red' class='doc15'>日付マクロ:</font> &nbsp;<font color="#cc0000" class='doc17'>%d%</font></p>

<p>マクロ %d% は、その位置にその日の日付(メールサーバが動作しているコンピュータのローカル時)を挿入します。</p>

## サンプル<br>

<table cellpadding=2 cellspacing=2 class='doc15' border=0 width="80%">
<tr align="center" bgcolor="#ffdddd" class='doc131'><td>タグ文字列</td><td>挿入される文字列</td></tr>
<tr bgcolor="#e0ffe0"><td>(%d%)</td><td>(2001-05-03)</td></tr>
<tr bgcolor="#e0ffe0"><td>[Diary #%c3%(%d%)]</td><td>[Diary #001(2001-05-03)] </td></tr>
</table>
<br>

<p><font color="#cc0000" class='doc15'>■ 使用上の注意</font></p>

<ol>
<li>タグ文字列には日本語(全角文字)を使うことはできません。</li>
<li>指定できるタグ文字列の長さは制限していますが、マクロを使うと Subject: ヘッダの実際の長さが非常に長くなる場合があります。その場合、メッセージの配送にトラブルが起こるかもしれません。</li>
</ol>
</blockquote>
