#!C:/usr/perl/bin/perl.exe

### uK4 - 個人用リストの管理(受信拒否)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./list_common.cgi";
@array = qw(ldomain lname type member del deny);

## 初期表示
if (@ARGV){
	$ml = $key4;
	&getLinfo($ml);
	&listadmin($user1,$domain1,$ml);
	($l{lname},$l{ldomain}) = split(/\@/,$ml);
	&getDenylist($l{ldomain},$l{lname});
	&html();
}

## フォーム入力を処理
&parse_form(@array);
%l = %qArray;
$ml = "$l{lname}\@$l{ldomain}";
&listadmin($user1,$domain1,$ml);
&getDenylist($l{ldomain},$l{lname});
my $denyall = @DENY;
&html("このアカウントでは更新/登録できません！",1) if $k4fixed;

my ($count,$tmp,@reg);
my $file = "$mailroot/domains/$l{ldomain}/$l{lname}/$xmailcfg/deny.tab";
if ($l{type} eq 'add'){
	&html("登録アドレスを指定してください。",1) if !$l{member};
	foreach(split(/ *\n+ */,$l{member})){
		s/^\s+//;
		s/\s+$//;
		&html("アドレス <b>$_</b> は変です。",1) if !/^$emreg1$/;
		my ($tmp) = &mod_str($_);
		if (grep(/^$tmp/i,@DENY) || grep(/^$tmp/i,@reg)){next;}
		push(@reg,"$_\n");
		$count++;
	}
	if (!@reg){
		$l{'member'} = '';
		&html("有効なデータがありません。",1);
	}
	if ($maxdeny && $maxdeny < $#reg + 1 + $denyall){&html("登録数が定数を超えます。",1);}
	
	open(FILE,">>$file");
		flock(FILE,2);
		print FILE @reg;
	close(FILE);
	$msg = "$count 個のアドレスを登録しました。";
	push(@DENY,@reg);
}
elsif ($l{type} eq 'del'){
	if (!$l{del}){&html("削除するアドレスを選択してください。",1);}
	($tmp) = &mod_str($l{del});
	foreach(@DENY){
		if (/^$tmp/i){$count++; next;}
		push(@reg,"$_\n");
	}
	open(FILE,">$file");
		flock(FILE,2);
		print FILE @reg;
	close(FILE);
	$msg = "$count 個のアドレスを削除しました。";
	@DENY = @reg;
}
elsif ($l{type} eq 'onoff'){
	if ($l{deny}){$msg = '受信拒否を実行します。';}
	else {$msg = '受信拒否は実行されません。';}
	$Deny = $l{Deny} = $l{deny};
	&saveenv('k4m',$l{ldomain},$l{lname},'Deny');
}
else {&redirect();}

$add = $del = $l{member} = '';
&html($msg);

## ページを表示 --------------------------------
sub html {
	if ($Expired && !$_[1]){&expire($_[0]);}
	&do_header1("$ml の管理",'deny',$_[0]);
	&printstat("$l{lname}\@$l{ldomain}");
	$total = @DENY;
	if ($l{Deny}){$chk0 = 'checked';}
	my $kperm = "<input type='hidden' name='ldomain' value=\"$l{'ldomain'}\">";
	$kperm .= "<input type='hidden' name='lname' value=\"$l{'lname'}\">";
	
	$K4 = <<"EOF";
<dl><dd>
<table cellpadding=4 cellspacing=0 border=0>
<tr><td colspan=2>
<table cellpadding=0 cellspacing=0 class='doc131' border=0>
<tr><td>
<form method='post' action="$denycgi">
$kperm
<input type='hidden' name='type' value='onoff'>
<input type='checkbox' name='deny' $chk0 value='1'>
<a href="JavaScript:opn_win('$help+deny'$wsize)">$fs5R 受信拒否を実行する$fe</td>
<td>&nbsp; <input type='submit' value=' 更新 '>$na</td><td></form></td></tr>
</table>
$hr
<tr><td height=10></td></tr>

<tr><td colspan=2>
<form method='post' action="$denycgi">
$kperm
<input type='hidden' name='type' value='add'>
$buttonP $fs5 拒否アドレスの登録$fe<br>
EOF
	&print_utf($K4);
	
	## アドレス登録
	if ($total >= $maxdeny){
		$K4 = "<p>登録数が定数 $maxdeny 件に達しています。</p>";
		$K4 .= "<p>新たなアドレスを追加するためには登録の一部を削除する必要があります。</p>";
		$K4 = "<tr><td colspan=2 height=60>$fs5R $K4$fe</td></tr>";
	}
	else {
		print "<tr valign='top'><td $bgcolor0><textarea name='member' cols=30 rows=7>$l{'member'}</textarea></td>";
		$K4 = "<td class='doc13' rowspan=2>";
		$K4 .= "このリストへの受信を拒否するメールアドレスを指定してください。$hr";
		$K4 .= "<li>最大 $maxdeny 件の登録が可能です。</li>";
		$K4 .= "<li>1 行に 1 つのメールアドレスを指定してください。</li>";
		$K4 .= "<li>重複するアドレスは登録されません。</li></td></tr>";
		$K4 .= "<tr><td><input type='submit' value='  登録する  '></form>";
	}
	
	## アドレス削除
	if (@DENY){
		foreach(sort(@DENY)){
			s/"//g;
			$members .= "<option value=\"$_\">$_</option>";
		}
		$K4 .= <<"EOF";
<tr><td colspan=2>
<form method='post' action='$denycgi'>
$kperm
<input type='hidden' name='type' value='del'>
$buttonP $fs5 拒否アドレスの削除$fe</td></tr>
<tr valign='top'><td $bgcolor0>
<select name='del' size=7>
<option value='' selected>選択してください　　　　　&nbsp;</option>
$members
</select></td>
<td rowspan=2>
<li>現在 $total 件の登録があります。</li>
<li>削除するアドレスを一覧から選択してください。</li>
<li>削除したデータは復活できません。</li>
</td></tr>
<tr><td><input type='submit' value='  削除する  ' $confirm1><br>
</form>
</td></tr>
EOF
	}
	$K4 .= "</table></dl>";
	
	&print_utf($K4);
	&print_footer();
	exit;
}

## リストの受信拒否リストを得る
sub getDenylist {
	my ($domain,$list) = @_;
	
	# リストを得る
	if (open(FILE,"$mailroot/domains/$domain/$list/$xmailcfg/deny.tab")){
			while (<FILE>){
				chomp;
				next if (/^\s*$/ || /[^\d\w"_.\-\@\t]/ || !/@/);
				s/^\s+//;
				s/\s+$//;
				push(@DENY,$_);
			}
		close(FILE);
	}
}
