#!C:/usr/perl/bin/perl.exe

### uK4 - 個人用リストの管理(環境設定)
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
require "./list_common.cgi";
$tagmax = 30;
$textmax = 1000;
@array = qw(ldomain lname ReceiveEnable RealName CompanyName ClosedML ListSender UseReplyTo ReplyTo Subscribe
	Tag ForceFrom MaxMSGSize MessageSize MessageID Attachment Header Footer header footer memo counter);

## 初期表示
if (@ARGV){
	$ml = $key4;
	&getLinfo($ml);
	&listadmin($user1,$domain1,$ml);
	($l{lname},$l{ldomain}) = split(/\@/,$ml);
	foreach my $tmp ('counter','header','footer','memo'){
		open(FILE,"$mailroot/domains/$l{ldomain}/$l{lname}/$xmailcfg/$tmp.tab") || next;
			while(<FILE>){
				$_ = &dec_utf($_,'JIS');
				if ($tmp eq 'counter'){chomp($_);}
				$l{$tmp} .= $_;
			}
		close(FILE);
	}
	&env0($l{ldomain});
	$l{MaxMSGSize} = $K4D[8];
	
	&html();
}

## フォーム入力を処理
&parse_form(@array);
%l = %qArray;
$ml = "$l{lname}\@$l{ldomain}";
&listadmin($user1,$domain1,$ml);

# エラーチェック
&html("このアカウントでは保存できません！",1) if $k4fixed;
if ($l{ForceFrom}){
	my $tmp = "$l{ForceFrom}";
	$tmp =~ s/ *\(.+\) *//g;
	$tmp = $1 if $tmp =~ /<(.+)>/;
	&html("$alert From:アドレスを確認してください！",1) if $tmp !~ /^$emreg$/;
}
&html("返送アドレスを確認してください !",1) if ($l{ListSender} && $l{ListSender} !~ /^$emreg1$/i);
if ($l{UseReplyTo} == 2){
	&html("Reply-To:アドレスを確認してください！") if ($l{ReplyTo} && $l{ReplyTo} !~ /^$emreg$/);
	$l{UseReplyTo} = $UseReplyTo = 0;
} else {$l{ReplyTo} = $ReplyTo = '';}
&html("Subject:に付加するタグは日本語は使えません !",1) if $l{Tag} =~ /[^$zstr]/;
&html("マクロカウンタは数値を指定してください！",1) if $l{counter} =~ /\D/;
&html("Subject:に付加するタグは半角 $tagmax 文字以内にしてください !",1) if length($l{Tag}) > $tagmax;
&html("メッセージサイズ制限は数値を指定してください !",1) if $l{MessageSize} =~ /\D/;
&html("メッセージサイズは $l{'MaxMSGSize'}KB までです！",1) if ($l{MessageSize} && $l{MaxMSGSize} && $l{MessageSize} > $l{MaxMSGSize});
&html("ヘッダは $textmax バイト以内にしてください !",1) if length($l{header}) > $textmax;
&html("フッタは $textmax バイト以内にしてください !",1) if length($l{footer}) > $textmax;
&html("管理用メモは $textmax バイト以内にしてください !",1) if length($l{memo}) > $textmax;

# 保存準備
$l{RealName} = '?' if !$l{RealName};
$l{CompanyName} = '?' if !$l{CompanyName};
foreach(qw(ClosedML ReceiveEnable)){if (!$l{$_}){$l{$_} = 0;}}
my @tmp = ('k4m',"$l{ldomain}","$l{lname}",'MaxMSGSize','ReplyTo');
push(@tmp,'Attachment') if $Lattach;
push(@tmp,'ForceFrom') if $Lfrom;
if ($Lheader){push(@tmp,'Header'); push(@tmp,'Footer');}
push(@tmp,'MessageID') if $Lmsgid;
push(@tmp,'MessageSize') if $Lmsgsize;
push(@tmp,'Subscribe') if $Lsubscribe;
push(@tmp,'Tag') if $Lstag;

# 更新情報保存
&saveenv('userm',$l{ldomain},$l{lname},'RealName','CompanyName','ReceiveEnable','ClosedML','ListSender','UseReplyTo');
&saveenv(@tmp);

# カウンタ、ヘッダ、フッタ、管理用メモ保存
@array1 = qw(counter memo);
if ($Lheader){push(@array1,'footer'); push(@array1,'header');}
foreach(@array1){
	$tmp = $l{$_};
	Encode::_utf8_off($tmp);
	Encode::from_to($tmp,$charset,'JIS');
	open(FILE,">$mailroot/domains/$l{ldomain}/$l{lname}/$xmailcfg/$_.tab");
		flock(FILE,2);
		print FILE "$tmp";
	close(FILE);
}

# 保存完了
my $msg = "環境を更新しました。";
if ($l{'RealName'} =~ /^\?+$/){$l{RealName} = '';}
if ($l{'CompanyName'} =~ /^\?+$/){$l{CompanyName} = '';}
&html($msg);

## ページを表示 ----------------------------------
sub html {
	if ($Expired && !$_[1]){&expire($_[0]);}
	foreach(qw(ForceFrom RealName CompanyName Tag footer header memo)){
		$l{$_} =~ s/</&lt;/g;
		$l{$_} =~ s/>/&gt;/g;
		$l{$_} =~ s/"/&quot;/g;
	}
	&do_header1("$ml の管理",'view',$_[0]);
	&printstat("$l{lname}\@$l{ldomain}");
	
	$chk0 = 'checked' if $l{ReceiveEnable};
	$chk1 = 'checked' if $l{ClosedML};
	if (!$l{UseReplyTo}){
		if ($l{ReplyTo} =~ /^$emreg$/i){$rt3 = 'checked';}
		else {$rt1 = 'checked'; $l{ReplyTo} = '';}
	} else {
		$rt2 = 'checked';
		$l{'ReplyTo'} = '';
	}
	$maxmsgsize = "(最大$l{MaxMSGSize}KB)" if $l{MaxMSGSize};
	
	$K4 = <<"EOF";
<dl><dd>
<form method='post' action="$viewcgi">
<input type='hidden' name='ldomain' value="$l{ldomain}">
<input type='hidden' name='lname' value="$l{lname}">
<input type='hidden' name='MaxMSGSize' value="$l{MaxMSGSize}">

<table cellpadding=0 cellspacing=1 class='doc131' border=0>
<tr><td colspan=2><input type='checkbox' name='ReceiveEnable' $chk0 value='1'>
<a href="JavaScript:opn_win('$help+enable'$wsize)">$fs5R このメーリングリストを有効にする$fe</td></tr>
<tr><td height=8></td></tr>
<tr><td><a href="JavaScript:opn_win('$help+realname'$wsize)">・ リストの説明(日本語可):</a></td>
<td><input name='RealName' size=35 maxlength=50 value="$l{RealName}" $nosubmit></td></tr>
<tr><td><a href="JavaScript:opn_win('$help+companyname'$wsize)">・ 所属組織:</a></td>
<td><input name='CompanyName' size=35 maxlength=50 value="$l{CompanyName}" $nosubmit></td></tr>
<tr><td nowrap><a href="JavaScript:opn_win('$help+returnpath'$wsize)">・ 返送(Return-Path:)アドレス:</a></td>
<td><input name='ListSender' size=35 maxlength=50 value="$l{ListSender}" $nosubmit></td></tr>
<tr><td height=3></td></tr>
<tr valign='top'><td><a href="JavaScript:opn_win('$help+replyto'$wsize)">・ 応答(Reply-To:)アドレス:</a></td>
<td width='100%'>
<input type='radio' name='UseReplyTo' value='0' $rt1>何も付加しない<br>
<input type='radio' name='UseReplyTo' value='1' $rt2>このアドレスを付加する<br>
<input type='radio' name='UseReplyTo' value='2' $rt3>以下のアドレスを付加する<br>
<input name='ReplyTo' size=35 maxlength=100 value="$l{ReplyTo}" $nosubmit>$na</td></tr>
<tr><td colspan=2><input type='checkbox' name='ClosedML' $chk1 value='1'>
<a href="JavaScript:opn_win('$help+capacity'$wsize)">このリストへの投稿は登録メンバーのみに制限する</td></tr>
EOF

	if ($Lsubscribe && $plsubscribe){
		my $chk = 'checked' if $l{Subscribe};
		$K4 .= <<"EOF";
<tr><td colspan=2><input type='checkbox' name='Subscribe' $chk value='1'>
<a href="JavaScript:opn_win('$help+join'$wsize)">空メッセージ投稿による登録/削除を実行する</td></tr>
EOF
	}
	
	if ($Lstag && $plstag){
		$K4 .= <<"EOF";
<tr><td nowrap>
<a href="JavaScript:opn_win('$help+tag'$wsize)">・ Subject:に付加するタグ(後記参照)&nbsp;</a></td>
<td><input name='Tag' size=35 maxlength=$tagmax value="$l{'Tag'}" $nosubmit>$na</td></tr>
<tr><td><a href="JavaScript:opn_win('$help+mcount'$wsize)">・ マクロ(\%C\%)カウンタ(後記参照)</a></td>
<td><input name='counter' size=9 maxlength=9 value="$l{counter}" $nosubmit>$na</td></tr>
EOF
	}
	
	if ($Lfrom && $plffrom){
		$K4 .= <<"EOF";
<tr><td nowrap>
<a href="JavaScript:opn_win('$help+forcefrom'$wsize)">・ From:アドレスの固定&nbsp;</a></td>
<td><input name='ForceFrom' size=35 maxlength=$tagmax value="$l{ForceFrom}" $nosubmit>$na</td></tr>
EOF
	}
	
	if ($Lmsgsize && $plmsgsize){
		$K4 .= <<"EOF";
<tr><td><a href="JavaScript:opn_win('$help+msglimit'$wsize)">・ メッセージサイズ制限</a></td>
<td><input name='MessageSize' size=9 maxlength=5 value="$l{MessageSize}" $nosubmit>KB$maxmsgsize$na</td></tr>
EOF
	}
	if ($Lmsgid && $plmsgid){
		if ($l{'MessageID'}){$chk6 = 'checked';}
		$K4 .= <<"EOF";
<tr><td colspan=2><input type='checkbox' name='MessageID' $chk6 value='1'>
<a href="JavaScript:opn_win('$help+messageid'$wsize)">Message-ID:ヘッダがなければ付加する$na</td></tr>
EOF
	}
	if ($Lattach && $plattach){
		if ($l{'Attachment'}){$chk3 = 'checked';}
		$K4 .= <<"EOF";
<tr><td colspan=2><input type='checkbox' name='Attachment' $chk3 value='1'>
<a href="JavaScript:opn_win('$help+attach'$wsize)">メッセージ中の添付ファイルを削除する</a>$na</td></tr>
EOF
	}
	&print_utf($K4);
	
	$K4 = '';
	if ($Lheader && $plheader){
		if ($l{Header}){$chk4 = 'checked';}
		if ($l{Footer}){$chk5 = 'checked';}
		$K4 = <<"EOF";
<tr><td colspan=2><input type='checkbox' name='Header' $chk4 value='1'>
<a href="JavaScript:opn_win('$help+header'$wsize)">配信メッセージに以下のヘッダを付加する(日本語注意)</a>$na<br>
<textarea name='header' cols=70 rows=5 wrap='soft'>$l{header}</textarea></td></tr>
<tr><td colspan=2><input type='checkbox' name='Footer' $chk5 value='1'>
<a href="JavaScript:opn_win('$help+footer'$wsize)">配信メッセージに以下のフッタを付加する(日本語注意)</a>$na<br>
<textarea name='footer' cols=70 rows=5 wrap='soft'>$l{footer}</textarea></td></tr>
EOF
	}
	
	$K4 .= <<"EOF";
<tr><td height=8></td></tr>
<tr><td colspan=2>
■<a href="JavaScript:opn_win('$help+memo'$wsize)\">管理用メモ (日本語可)</a><br>
<textarea name='memo' cols=70 rows=5 wrap='soft'>$l{memo}</textarea></td></tr>
<tr><td height=8></td></tr>
<tr><td colspan=2><input type='submit' value='環境を保存する'></td></tr>
</table>
<div align='right'>$arrowU</div>
</dl></form>
EOF
	
	if ($Lstag && $plstag){
		if ($Lstag && open(FILE,"help_macro.cgi")){
				while(<FILE>){
					chomp;
					$K4 .= $_;
				}
			close(FILE);
		}
		$K4 .= "<div align='right'>$arrowU</div>";
	}
	
	&print_utf($K4);
	&print_footer();
	exit;
}
