#!C:/usr/perl/bin/perl.exe

### uK4 - ビッグファイル受領
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use Digest::MD5 'md5_hex';
use utf8;
require "./config.cgi";
require './mailbox_common.cgi';
$bigfilemax2 = 1 if $bigfilemax2 eq '';
$cgi = 'mailbox_upload3.cgi';
$workdir = "../temp/$loginid/bigfile";
exit if (!$allowmail || !$allowbigfile2);
@array = qw(Amount Auth ExpireTime HTMLMessage Message OwnerName PassPhrase RCPTName Retry 
	Sensitive SiteName Size eY0 eM0 eD0 sY0 sM0 sD0 step Url);

### 初期表示
if (@ARGV){
	($big,$op1) = @ARGV;
	%e = &getenv($bigfileflag2,'=','',1,$charset);
	exit if $e{BigfileID} ne $big;
	my $profile = "$workdir/$big/profile.txt";
	my $msg;
	
	if (!$op1){
		mkdir($workdir,0755);
		foreach my $file ('index.htm','index.html','default.htm'){
			open(FILE,">$workdir/$file") && close(FILE);
		}

		$Url = ${bigfileurl2};
		$Url = $1 if (!$Url && $ENV{'HTTP_REFERER'} =~ /^(https?:\/\/.+?)mailbox_(new|reply)\.cgi/);
		$Message = "アップロードサイトのお知らせです。\n";
		$Message .= "以下のサイトからファイルをアップロードしてください。\n";
		$Message .= "    ${Url}upload_login.cgi?$big\n";
		$Message .= "サイトへのログインでは以下のパスフレーズをご利用ください。\n";
		$Message .= "    ##_pass_##\n";
		$step = 1;
	}
	
	&html($msg);
}

## フォーム入力を処理
&parse_form(@array);
%e = &getenv($bigfileflag2,'=','',1,$charset);
my $dir = "$workdir/$e{BigfileID}";
my $profile = "$dir/profile.txt";

## ステップ1
if ($step == 1){
	&html("サイト名を書いてください。") if $SiteName eq '';
	&html("案内文を書いてください。") if $Message eq '';
	my ($sStr,$eStr,$today) = ("$sY0$sM0$sD0","$eY0$eM0$eD0","$year$month$mday");
	&html("開始日の指定が不完全です。") if ($sStr && (!$sY0 || !$sM0 || !$sD0));
	&html("終了日の指定が不完全です。") if ($eStr && (!$eY0 || !$eM0 || !$eD0));
	&html("開始日は終了日の前を指定してください。") if ($sStr && $eStr && $sStr >= $eStr);
	&html("終了日は本日以後を指定してください。") if ($eStr && $eStr < $today);
	if ($Size){
		$Size =~ s/\D//g;
		&html("サイズ上限は $bigfilesize2(KB) 以下にしてください。") if $Size > $bigfilesize2;
	} else {
		$Size = $bigfilesize2;
	}
	if ($Amount){
		$Amount =~ s/\D//g;
		&html("最大ファイル数は $bigfilemax2 以下にしてください。") if $Amount > $bigfilemax2;
	} else {
		$Amount = $bigfilemax2;
	}
	if ($Auth){
		&html("認証する場合はパスフレーズを指定する必要があります。") if $PassPhrase eq '';
		&html("パスフレーズは <b>$bigfileauthstr</b> バイト以上で指定してください。") if length($PassPhrase) < $bigfileauthstr;
		&html("リトライ許可回数を指定する場合、数値で指定してください。") if $Retry =~ /\D/;
		&html("認証済みページの有効時間は数値で指定してください。") if $ExpireTime =~ /\D/;
		&html("認証済みページの有効時間は 600(秒) 以上で指定してください。") if ($ExpireTime && $ExpireTime < 600);
	} elsif ($Message =~ /#+_+pass(word)*_+#+/i){
		&html("認証しないサイトでは <b>$&</b> は不要です。関連部分を削除してください。");
	}
	&html("認証サイトの場合、送付案内文に <b>##_pass_##</b> 文字列を入れる必要があります。") if ($Auth && $Message !~ /#+_+pass(word)*_+#+/i);
	
	# データを保存
	mkdir($dir,0755);
	my ($html) = ($HTMLMessage);
	$html =~ s/\n/\|\|/g;
	#Encode::_utf8_off($html);
	#Encode::_utf8_off($phrase);
	open(FILE,">$profile");
		print FILE <<"EOF";
Created = $year/$month/$mday $hour:$min:$sec
Owner = $user1\@$domain1
IP = $ENV{'REMOTE_ADDR'}
Referer = $ENV{'HTTP_REFERER'}
Start = $sStr
End = $eStr

BigfileID = $e{BigfileID}
SiteName = $SiteName
Amount = $Amount
Auth = $Auth
ExpireTime = $ExpireTime
PassPhrase = $PassPhrase
Sensitive = $Sensitive
Size = $Size
Retry = $Retry

RCPTName = $RCPTName
OwnerName = $OwnerName
HTMLMessage = $html

EOF
	close(FILE);
	my $msg = $Message;
	Encode::_utf8_off($msg);
	open(FILE,">$dir/message.txt");
		print FILE $msg;
	close(FILE);
	
	$step = 2;
	&html();
}

## ファイルの準備を完了(元スクリプトへ戻る)
elsif ($step == 2){
	print "Location: $e{BackTo}?bigfile2\n\n";
	exit;
}

### ---------------------------------------
sub html {
	my ($msg1,$msg2) = @_;
	my $back = "<a href='$e{BackTo}?$e{BackArg}+suspend'>&nbsp;中止してもどる$arrowR&nbsp;</a>";
	my ($height,$str0,$str1,$str2) = (18,"未完了のまま他のページに移動すると処理はキャンセルされます。");
	if ($step == 1){
		$height = 20;
		$str2 = "ビッグファイル受領サイトを作成します。$str0";
	} elsif ($step == 2){
		$height=8;
	}
	if ($msg1){
		$str2 = "$alert $fs5R$msg1$fe";
		$str2 .= "<br>&nbsp;$msg2" if $msg2;
	}
	
	print "Content-Type: text/html; charset=$charset\nPragma: no-cache\n\n";
	$K4 = <<"EOD";
<html>
<head>
$charcss
<title>ビッグファイル受領</title>
</head>
<body $bodyp class='doc131' topmargin=1 leftmargin=4 marginheight=1 marginwidth=4>
$table0
<form action='$cgi' method='post'>
<input type='hidden' name='step' value='$step'>
<input type='hidden' name='Url' value="$Url">
<tr><td height=1><a name='top'>$null</a></td></tr>
<tr valign='bottom'><td><img src='$idir/letter.gif' width=34 height=24 title='ビッグファイルの受領サイトを準備します'></td>
<td nowrap width='100%'>&nbsp;$fs7G<b>ビッグファイル受領</b>$fe</td><td nowrap>$back</td></tr>
<tr><td height=2></td></tr>
<tr><td bgcolor='#c0c0c0' colspan=3 height=1>$null</td></tr>
<tr><td height=2></td></tr>
<tr><td colspan=3 height=$height valign='top'>$str2</td></tr>
</table>
EOD
	&print_utf($K4);
	
	## ステップ1 - 受領サイト案内の編集・サイトの動作条件、ヘルプの表示
	if ($step == 1){
		&htmlconv('Message','OwnerName','PathPhrase','RCPTName','SiteName');
		my ($sY,$eY) = (&s_year($sY0),&s_year($eY0));
		my ($sM,$eM) = (&s_month($sM0),&s_month($eM0));
		my ($sD,$eD) = (&s_day($sD0),&s_day($eD0));
		my $confirm = " onClick=\"if(!confirm('この内容でアップロードサイトを作成しますか？')){return false;}\"";
		my $a1 = 'checked' if $Auth;
		my $a2 = 'checked' if $Sensitive;
		my $Str;
		if (!$bigfilemax2 || $bigfilemax2 == 1){
			$Amount = 1;
			$Str = 'disabled';
		}
		
		$K4 = <<"EOF";
<table border=0 cellpadding=0 cellspacing=0 class='doc131'>
<tr valign='top'><td>
	<table border=0 cellpadding=6 cellspacing=0 class='doc13'>
	<tr><td>${fs5G}[ステップ1] <b>受領案内の編集・サイトの動作条件</b>$fe</td></tr>
	<tr><td $bgcolor3>$buttonG サイトの名前$fs2(必須)$fe<br>
	<input name='SiteName' size=70 maxlength=256 $nosubmit value="$SiteName"></td></tr>
	<tr><td $bgcolor3>$buttonG 案内文の作成・編集(通知メッセージに挿入します)$fs2(必須)$fe<br>
	<textarea name='Message' cols=81 rows=7 wrap='off'>
EOF
		&print_utf($K4);
		Encode::_utf8_off($Message);
		print $Message;
		$K4 = <<"EOF";
</textarea></td></tr>
	<tr><td $bgcolor3>$buttonG アップロードサイトの有効期限<br>
	<select name='sY0'>$sY</select>年 
	<select name='sM0'>$sM</select>月 
	<select name='sD0'>$sD</select>日 ～ 
	<select name='eY0'>$eY</select>年 
	<select name='eM0'>$eM</select>月 
	<select name='eD0'>$eD</select>日</td></tr>
	<tr><td $bgcolor3>$buttonG アップロード可能サイズ、ファイル個数<br>
	<input name='Size' size=10 value="$Size" $nosubmit> サイズの上限 ($bigfilesize2 キロバイト以内)<br>
	<input name='Amount' size=10 maxlength=3 value="$Amount" $Str $nosubmit> 最大ファイル数 ($bigfilemax2 個以内)</td></tr>
	<tr><td $bgcolor3>$buttonG セキュリティ<br>
	<input type='checkbox' name='Auth' $a1 value='1'> アップロードサイトへのアクセスはパスフレーズによる認証が必要<br>
	<input type='checkbox' name='Sensitive' $a2 value='1'> 以下のパスフレーズは大文字・小文字を区別<br>
	<input name='PassPhrase' size=45 value="$PassPhrase" $nosubmit> ($bigfileauthstr バイト以上、空白文字・全角文字OK)<br>
	<input name='Retry' size=10 maxlength=3 value="$Retry" $nosubmit> (認証失敗時のリトライ許可回数)<br>
	<input name='ExpireTime' size=10 maxlength=9 value="$ExpireTime" $nosubmit> (認証済みページの有効時間、秒単位、1日=86400秒、1週間=604800秒)</td></tr>
	<tr><td $bgcolor3>$buttonG 通知先の名前 / 通知元の名前(アップロードサイトで表示)<br>
	<input name='RCPTName' size=45 value="$RCPTName" $nosubmit>(通知先、アップロード者の名前)<br>
	<input name='OwnerName' size=45 value="$OwnerName" $nosubmit>(通知元、サイト運営者の名前)</td></tr>
	<tr><td $bgcolor3>$buttonG 連絡メッセージの作成・編集(ダウンロードサイトで表示)<br>
	<textarea name='HTMLMessage' cols=81 rows=7 wrap='off'>
EOF
		&print_utf($K4);
		Encode::_utf8_off($HTMLMessage);
		print $HTMLMessage;
		$K4 = <<"EOF";
</textarea></td></tr>
	<tr><td align='right'><input type='submit' value='確認ページへ進む &raquo;' $confirm></td></tr>
	</table></td>
<td nowrap>&nbsp;</td>
<td>
<table border=1 cellpadding=6 cellspacing=0>
<tr><td>
	<table border=0 cellpadding=2 cellspacing=0 class='doc13'>
	<tr><td>$fs5&lt;<b>ビッグファイル受領機能について</b>&gt;</td></tr>
	<tr><td>E-mail に添付できないほど大きなファイルをインターネットを介して受け取れるようにするのがビッグファイル受領機能です。</td></tr>
	<tr><td><ol>
	<li>アップロード用のウェブサイトを作成し、E-mail でそのアドレスを相手に知らせます。</li>
	<li>相手にウェブサイトへファイルをアップロードしてもらいます。</li>
	<li>これにより [ビッグファイル] メニューから該当ファイルをダウンロードできるようになります。<br>
	</ol></td></tr>
	<tr><td>$fs5&lt;<b>設定のヒント</b>&gt;</td></tr>
	<tr><td><ul>
	<li>[サイトの名前] にはこのアップロードサイトを識別する任意の名前をつけます。
	この名前はアップロードサイトのウインドウタイトルとして表示されます。
	アップロード者に関連付けた名前にすると管理が楽になるかも?</li>
	<li>[案内文の作成・編集] は、ここで指定する内容が通知メッセージに挿入されて送信されます。<br>
	[セキュリティ] で認証を必要にした場合、この案内文の中には必ず $fs2<b>##_pass_##</b>$fe という文字列を入れる必要があります。
	<b>##_pass_##</b> は通知メッセージへの案内文の挿入時に実際のパスフレーズに置換されます。</li>
	<li>$fs2ダウンロードサイト URL の upload_login.cgi\? に続く 32 文字はサイトを識別するために必須です。削除・変更しないでください。$fe</li>
	<li>[アップロードサイトの有効期限] は、有効期限が必要でない場合は何も指定しないでください。
	指定をすると、期間外のアクセスが拒否されます。</li>
	<li>[セキュリティ] は、アップロードサイトへのアクセスで認証を必要にする場合に適切な設定を行います。<br>
	"<b>認証失敗時のリトライ回数</b>" を指定すると、認証に指定回数失敗した場合はログインフォームの表示を一時停止し、サイトへの再アクセスの案内を表示します。<br>
	"<b>認証済みページの有効時間</b>" を指定すると、1回の認証でダウンロードサイトを利用できる時間(秒数)を制限できます。
	制限した場合、指定時間が過ぎると改めてアップロードサイトへの認証ログインを強制します。有効時間を指定しない場合、制限を行いません。</li>
	<li>[通知先の名前/通知元の名前] は、もし指定すればアップロードサイトが誰のために用意されたのか、誰が用意したのかをサイト内に表示します。
	アップロード者が組織名や個人名である場合、「様」までつけた方がよい場合があります。
	HTML タグは使用できません。</li>
	<li>[連絡メッセージの作成・編集] は、アップロードサイトに追加コメントを表示したい場合に任意の内容で入力してください。
	HTML タグは使用できません。フォーム内の改行がそのままコメントの改行になります。</li>
	</ul></td></tr>
	</table></td></tr>
</table></td></tr>
EOF
		&print_utf($K4);
	}
	
	# ステップ2 - 確認
	elsif ($step == 2){
		my %p = &getenv("$workdir/$e{BigfileID}/profile.txt",'=','',1,$charset);
		my $message;
		if (open(FILE,"$workdir/$e{BigfileID}/message.txt")){
				while (<FILE>){
					$_ = &dec_utf($_,$charset);
					$message .= $_;
				}
			close(FILE);
		}
		$message =~ s/</&lt;/g;
		$message =~ s/>/&gt;/g;
		$message =~ s/"/&quot;/g;
		$message =~ s/\n/<br>/g;
		my $str = " (大文字・小文字を区別) " if $p{Sensitive};
		$message =~ s/#+_+pass(word)*_+#+/$p{PassPhrase}$str/gi;
		
		$K4 = <<"EOF";
<table border=0 cellpadding=4 cellspacing=0 class='doc131'>
<tr valign='top'><td>
	<table border=0 cellpadding=1 cellspacing=0 class='doc13'>
	<tr><td>${fs5G}[ステップ2] <b>確認</b>$fe</td></tr>
	<tr><td bgcolor='#c0c0c0' height=1></td></tr>
	<tr><td height=8></td></tr>
	<tr><td>${fs2}以下の内容でビッグファイル受領の準備ができました。$fe<br>
	以下の [案内文] はメッセージ作成ステップで引用・挿入されます。<br>
	この内容でよければメッセージ作成ステップへもどり、通知メッセージを送信してください。</td></tr>
	<tr><td height=8></td></tr>
	<tr><td $bgcolor3>
		<table cellpadding=2 cellspacing=0 class='doc131' border=0>
EOF
		$K4 .= "<tr><td>有効期限</td><td>";
		if (!$p{Start} && !$p{End}){
			$K4 .= "期間の制限なし";
		} else {
			$K4 .= "$1/$2/$3 に開始" if $p{Start} =~ /(\d{4})(\d{2})(\d{2})/;
			$K4 .= " ～ " if $p{End};
			$K4 .= "$1/$2/$3 に終了" if $p{End} =~ /(\d{4})(\d{2})(\d{2})/;
		}
		$K4 .= "</td></tr>";
		$K4 .= "<tr><td>ファイルの制限</td><td>$Size(KB)、$Amount 個</td></tr>";
		$K4 .= "<tr><td valign='top' nowrap>サイトへのアクセス</td><td>";
		if ($p{Auth}){
			$K4 .= "認証が必要 (パスフレーズ: $p{PassPhrase})";
			$K4 .= "(大文字・小文字を区別)<br>" if $p{Sensitive};
		} else {
			$K4 .= "認証不要</td></tr>";
		}
		my ($rcpt,$owner) = ($p{RCPTName},$p{OwnerName});
		$rcpt = '-' if !$rcpt;
		$owner = '-' if !$owner;
		$K4 .= "<tr><td nowrap>通知先の名前 &nbsp;</td><td>$rcpt</td></tr>";
		$K4 .= "<tr><td>通知元の名前</td><td>$owner</td></tr>";
		$K4 .= "<tr><td valign='top'>案内文</td><td bgcolor='#ffffe0'>$message</td></tr>";
		if ($p{HTMLMessage}){
			my $html = $p{HTMLMessage};
			$html =~ s/</&lt;/g;
			$html =~ s/>/&gt;/g;
			$html =~ s/"/&quot;/g;
			$html =~ s/\|+/<br>/g;
			$K4 .= "<tr><td valign='top' nowrap>連絡メッセージ &nbsp;</td><td>$html</td></tr>";
		}
		
		#my $confirm2 = "onClick=\"if(!confirm('この内容でメッセージ作成ページへもどります。よろしいですか？')){return false;}\"";
		$K4 .= <<"EOF";
		</table></td></tr>
	<tr><td height=4></td></tr>
	<tr><td align='right'><input type='submit' $confirm2 value='メッセージ作成ステップへもどって続行 &raquo;'></td></tr>
	</table></td></tr>
</table>
EOF
		&print_utf($K4);
	}
	
	print "</form></body></html>";
	exit;
}
