#!C:/usr/perl/bin/perl.exe

### uK4 - メモを記録する
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
use utf8;
require "./config.cgi";
$cgi  = "memo.cgi";
$conf = 'memo0';		# 情報ファイル名
$datmax = 1000;			# 1メモ最大データ量
$memobox = 'notepad';	# メモ格納フォルダ名
$cols = 51;
$rows = 15;
if ($ENV{'HTTP_USER_AGENT'} =~ /Gecko/){$cols = 45; $rows = 12;}
@array = qw(del dmemo memo memoid new read title update);
&auth();

if (@ARGV){				# 初期処理
	&ReadConf();
	
	if ($dmemo0){
		foreach(@reg){
			if (/^$dmemo0 *= *(.*)/){
				$checked = 'checked';
				$memoid = $dmemo0;
				$title = $1;
				last;
			}
		}
	}
	if ($memoid eq '' && @reg){
		for $i (1 .. $maxmemo){
			$ii = sprintf("%03d",$i);
			foreach(@reg){
				if (/^(memo$ii) *= *(.*)/){
					($memoid,$title) = ($1,$2);
					last;
				}
			}
		}
	}
	$memoid = 'memo001' if !$memoid;
	
	if (open(FILE,"$userdir/$memobox/$memoid")){
			while(<FILE>){
				#$_ = &dec_utf($_,$charset);
				$_ = &dec_utf($_);
				$memo .= $_;
			}
		close(FILE);
	}
	
	&html();
}
else {					# 新規、上書き、削除
	&parse_form(@array);
	&ReadConf();
	&html("$alert このアカウントでは保存/更新はできません！",1) if $k4fixed;
	
	$checked = 'checked' if $dmemo;
	&html("$alert メモが制限サイズを超えています！<br>$datmax バイト以内にしてください。",1) if length($memo) > $datmax;
	
	undef @tmp;
	if ($del){
		foreach(@reg){
			if (/^$memoid *=/i){next;}
			if (/^memo0 *= *$memoid/i){$_ = "memo0 = ";}
			push(@tmp,$_);
		}
		unlink("$userdir/$memobox/$memoid");
		$msg = '指定メモを削除しました。';
		$checked = $dmemo = $memo = $title = '';
		@reg = @tmp;
	}
	elsif ($new){
		&html("$alert データが空です。",1) if ($memo =~ /^\s*$/ && $title =~ /^\s*$/);
		for $i (1 .. $maxmemo){
			$ii = sprintf("%03d",$i);
			if (grep(/^memo$ii *=/,@reg)){next;}
			$memoid = "memo$ii";
			if ($dmemo){unshift(@reg,"memo0 = $memoid");}
			elsif ($dmemo0){unshift(@reg,"memo0 = $dmemo0");}
			else {}
			push(@reg,"$memoid = $title");
			last;
		}
		$msg = 'メモを作成しました。';
	}
	elsif ($read){
		open(FILE,"$userdir/$memobox/$memoid") || &html("$alert メモを読み込めませんでした。",1);
			while(<FILE>){
				$_ = &dec_utf($_,$charsetE);
				$memo .= $_;
			}
		close(FILE);
		foreach(@reg){
			if (/^$memoid *= *(.*)/){$title = $1;}
		}
		&html();
	}
	elsif ($update){
		&html("$alert データが空です。",1) if ($memo =~ /^\s*$/ && $title =~ /^\s*$/);
		foreach(@reg){
			if (/^$memoid *=/){$_ = "$memoid = $title";}
			push(@tmp,$_);
		}
		@reg = @tmp;
		if ($dmemo){unshift(@reg,"memo0 = $memoid");}
		elsif ($dmemo0){unshift(@reg,"memo0 = $dmemo0");}
		else {}
		$msg = 'メモを更新しました。';
	}
	else {
		&log('r','?','?','?','?',"不正実行",$0);
		&redirect();
	}
	
	## 保存
	open(FILE,">$userdir/$memobox/$conf");
		flock(FILE,2);
		foreach(sort(@reg)){
			Encode::_utf8_off($_);
			print FILE "$_\n";
		}
	close(FILE);
	
	$memo1 = $memo;
	Encode::_utf8_off($memo1);
	#Encode::from_to($memo1,$charset,$charsetE);
	if (!$del){
		open(FILE,">$userdir/$memobox/$memoid");
			flock(FILE,2);
			print FILE $memo1;
		close(FILE);
	}
	&html($msg);
}

### ページを表示
sub html {
	&expire($_[0],100) if ($Expired && !$_[1]);
	$caution = $_[0];
	&ReadMemoList();
	&htmlconv(qw(memo title));
	$option3 = "<input type='submit' name='new' value='新規保存'> ";
	if ($totalmemo != 0 && $del eq ''){
		$option1 = "<input type='submit' name='update' value='上書き保存'> ";
		$option2 = "<input type='submit' name='del' value='このメモを削除' $confirm1>";
		$option3 = '' if $totalmemo >= $maxmemo;
	}
	if ($memoid && $memoid eq $dmemo){$checked = 'checked';}
	if ($maxmemo > 1){
		$checked = 'checked' if $dmemo0 eq $memoid;
		$ifd = "<tr><td></td><td><input type='checkbox' $checked name='dmemo' value='1'>";
		$ifd .= "このメモをデフォルトのメモにする。<br>";
	}
	
	my $title0 = 'メモの管理';
	my $title1 = 'このウインドウを閉じます';
	
	print <<"EOF";
Content-Type: text/html; charset=$charset
CacheControl: no-cache
Pragma: no-cache
Expires: -1\n
EOF
	$K4 = <<"EOF";
<html><head><title>$title</title>$charcss$nocache</head>
<body bgcolor='#f0fff0' class='doc131' topmargin=2 leftmargin=2 marginheight=2 marginwidth=2 $cbody0>
<table cellpadding=0 cellspacing=0 border=1 bordercolor='#0000a0' width='100%'>
<tr><td bgcolor='#ffffff' background='$idir/bgimg.gif'>
	$table0
	<tr><td><img src='$idir/foot_0.gif' width=80 height=30 title='$title0'></td><td width='100%'></td>
	<td><form method='post' action="$cgi"></td>
	<td nowrap><input type='hidden' name='read' value='1'>$select&nbsp;&nbsp;</td>
	<td></form></td>
	<td nowrap><a href="javascript:window.close()">閉じる</a></td>
	<td nowrap>
	<a href="javascript:window.close()">
	<img src="$idir/close.gif" width=16 height=16 title="$title1" border=0></a>&nbsp;
	</table>
</table>

<table cellpadding=1 cellspacing=0 class='doc131' border=0 align='center'>
<tr><td height=10><form method='post' action="$cgi"></td></tr>
<tr><td align='center' colspan=2>
<input type='hidden' name='memoid' value="$memoid">
$fs5R $caution$fe</td></tr
<tr><td height=10>
<tr><td nowrap>タイトル:</td>
<td><input name='title' size=40 maxlength=100 value="$title"><br>
$ifd
<tr><td colspan=2><textarea cols=$cols name='memo' rows=$rows wrap='soft'>
EOF
	
	&print_utf($K4);
	Encode::_utf8_off($memo);
	print "$memo";
	
	$K4 = <<"EOF";
</textarea></td></tr>
<tr><td colspan=2>
$option1
$option3
$option2
&nbsp;</td></tr>
<tr><td></form></td></tr>
</table>
<div align='right' class='doc131'>
<hr color='#C0C0C0' size=1 width=120>
<a href="javascript:window.close()">閉じる&nbsp;</a>
<a href="javascript:window.close()">
<img src="$idir/close.gif" width=16 height=16 title="$title1" border=0></a>
&nbsp;<br>$datmax バイト以内のメモを $maxmemo 個作成できます。&nbsp;</div>
</body>
</html>
EOF
	
	&print_utf($K4);
	exit;
}

sub ReadConf {
	if (!-e "$userdir/$memobox"){mkdir("$userdir/$memobox",0755);}
	
	undef @reg;
	if (open(FILE,"$userdir/$memobox/$conf")){
			while(<FILE>){
				$_ = &dec_utf($_,$charset);
				chomp;
				if (/^memo0 *= *(.+)/i){$dmemo0 = $1; next;}
				if (!/^memo\d+ *=/){next;}
				push(@reg,$_);
			}
		close(FILE);
	}
}

sub ReadMemoList {
	my ($count,$tmp1,$tmp2,@tmp);
	$count = 1;
	$totalmemo = 0;
	@tmp = map {(split / *= */)[1]} @reg;
	@reg = @reg[sort {$tmp[$a] cmp $tmp[$b]} 0 .. $#tmp];
	
	undef $select;
	foreach(@reg){
		if (/^memo0 *=/){next;}
		if (/^$memoid *=/){$totalmemo++; next;}
		($tmp1,$tmp2) = split(/ *= */,$_);
		if (!$tmp2){$tmp2 = "(無題 $count)"; $count++;}
		$select .= "<option value='$tmp1'>$tmp2</option>";
		if ($totalmemo == $maxmemo){last;}
		$totalmemo++;
	}
	if ($totalmemo > 1 || ($totalmemo ==1 && $del)){
		$select = "<input type='submit' value='開く'><select name='memoid'>$select</select>";
	}
}
